<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2014 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
# PHPCIPHER NO ENCRYPT
# PHPLOCKITOPT NOENCODE
/*
  Logaholic Last Updated script
  This script will display when a profile has last been updated 
  by displaying the last found timestamp in the database.
  
  Usage:
  php -q lastupdated.php

*/

# --------------------------------------------------------------------------------
# Please change Default values below
# --------------------------------------------------------------------------------

$notifyadmin = false;         # set to true if you want an email with the output from this script
$adminemail = "";             # enter your email address
$hours = 24;                  # if you are only interested in profiles that have not been updated for more than, say 24 hours, enter 24 here 

# --------------------------------------------------------------------------------
# Dont't edit beyond this point
# --------------------------------------------------------------------------------

# Initialize
$running_from_command_line = true;
set_time_limit(86400);
$now = time();
$b = "\n"; 

include("../../common.inc.php");

if ($_SERVER['DOCUMENT_ROOT']){
    echo "Sorry. This script should be run from the command line only.<br>Terminating.";
    exit();
}   

echo "Profiles that have not been updated in the last $hours hours $b Current time is: " . date("d M Y (H:i)",$now);

# --------------------------------------------------------------------------------
# Start Script
# --------------------------------------------------------------------------------
$ignoretill = ( $now - ( $hours * 3600 ) );
$start = time();
$data = array();
$i = 0;
$q = $db->Execute("select profilename, stats from ".TBL_PROFILES);
while($row = $q->fetchRow()){
    $stats = json_decode($row['stats'],true);
    if($stats['last_update_finished'] < $ignoretill){
        # double array for the once in the million change the updates were done at the same time (never updated profiles)
        $data[ $stats['last_update_finished'] ][] = "$b {$row['profilename']} finished on ". date('d M Y (H:i:s)', $stats['last_update_finished']). " Latest Record: ". date('d M Y (H:i:s)', $stats['max_db_timestamp']);
    }
    $i ++;
}

# sort the data
ksort($data);
foreach ($data as $messages) {
    foreach ($messages as $message) {
       echo $message;
    }
}
$took = number_format(((time() - $start) / 60),2);

echo $b.$b."Done! $b Checked $i profiles took $took minutes".$b;

if ($notifyadmin == true) {
    mail($adminemail,"Logaholic last updated status report",$output);
} 
?>