<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This is the master report class. All other reports should be childen of this parent class
* it is assumed that this is included somewhere where common.inc.php is also included 
*/
include_once("top.php");

#include Classes
include_once("includes/datamanager.php");

if(!$session->isAdmin() && $validUserRequired){
	echoWarning("You don't have permission to access datamanager.","margin:10px;");
	exit();
}

$reqFrom = @mktime(0,0,0,$_REQUEST["fmonth"],$_REQUEST["fday"],$_REQUEST["fyear"]);
$reqTo = @mktime(23,59,58,$_REQUEST["tmonth"],$_REQUEST["tday"],$_REQUEST["tyear"]);

?>
<link type="text/css" rel="stylesheet" href="templates/datamanager.css" />
<script style="text/javascript">
$(document).ready( function() {	
	$(".logname .checkbox").live("click", function(ev) { // Check / Uncheck a month
		if($(this).parent().hasClass("selected") == true) {
			$(this).parent().removeClass("selected"); // Check a month
		} else {
			$(this).parent().addClass("selected"); // Check a month
		}
	});
	
	$(".logname:not(.checkbox, .checked)").click(function(ev) { // Show / Hide a profile's content
		if($(this).next(".monthcontent").is(":hidden") == true) {
			$(this).parent().addClass("open"); // Show the content
		} else {
			$(this).parent().removeClass("open"); // Hide the content
		}
	});
	
	$("#imex-checkbox").click( function() {
		if($('#imex-checkbox').is(':checked')){
			$("#manual-imex").show();
		} else {
			$("#manual-imex").hide();
		}
	});
});
</script>
<div id="Grid">
	<div style="float:left; width:470px; text-align:left;">
		<!-- AUTO EXPORT SETTINGS -->
		<h2>Data Manager Settings</h2>
		<?php
		#SET SETTINGS
		if(isset($_REQUEST["setSettings"])) {
			#save settings to profileSettings
			$profile->SetOtherSettings("datamanagersettings",$_REQUEST["daterangelimit"]);
		}		
		$currentSetting = $profile->GetOtherSettings("datamanagersettings",getGlobalSetting("datamanagersettings",0));		
		
		?>
		<form>
		<table width='300'>
			<tr>
				<td>
					Max daterange in database:
				</td>
				<td>
					<?php					
					echo "<select name='daterangelimit'>";
						if($currentSetting == 0){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='0' {$sel}>No Limit</option>";
						if($currentSetting == 1){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='1' {$sel}>1 ". _MONTH ."</option>";
						if($currentSetting == 2){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='2' {$sel}>2 ". _MONTH ."</option>";
						if($currentSetting == 3){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='3' {$sel}>3 ". _MONTH ."</option>";
						if($currentSetting == 4){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='4' {$sel}>4 ". _MONTH ."</option>";
						if($currentSetting == 5){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='5' {$sel}>5 ". _MONTH ."</option>";
						if($currentSetting == 6){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='6' {$sel}>6 ". _MONTH ."</option>";
						if($currentSetting == 12){ $sel = "selected='selected'"; } else { $sel = "";  }
						echo "<option value='12' {$sel}>12 ". _MONTH ."</option>";
						
					echo "</select>";
					?>
				</td>
			</tr>
		</table>
		<br/>
		<input type='hidden' name='conf' value="<?php echo $profile->profilename; ?>"/>
		<input class="button_wrapper commit-install" type='submit' name='setSettings' value='Save Settings' style='float: left; font-size:14px;' />
		<input class="button_wrapper commit-install" type='submit' name='runSettings' value='Run Manager Now' style='width:150px; float: left; font-size:14px;' />
		</form>
		<br/><br/><br/>
		<!-- #IMPORT / EXPORT -->
		<div id='manual-imex'>
		<h2><?php echo "Import / Export date range from <font color=red>{$profile->profilename}</font>"; ?></h2>
		<form>
			<?php DateSelector($from,$to); ?>
			<input type='hidden' name='conf' value="<?php echo $profile->profilename; ?>"/><br/>
			<input class="button_wrapper commit-install" type='submit' name='export' value='Export' style='float: left; font-size:14px;' />
			<input class="button_wrapper commit-install" type='submit' name='import' value='Import' style='float: left; font-size:14px;' />
		</form>
		</div>
		<br/><br/><br/>
		<div id="output-container">
			<?php	
			#EXPORT
			if(isset($_REQUEST["export"])){
				#collect data from daterange and export.
				$dataManager = new DataManager();
				$dataManager->Export($profile,$reqFrom,$reqTo);	
			}
			#IMPORT
			if(isset($_REQUEST["import"])) {
				#import selected daterange
				$dataManager = new DataManager();
				$dataManager->Import($profile,$reqFrom,$reqTo);
			}
			#RUN SETTINGS
			if(isset($_REQUEST["runSettings"])) {
				$profile->SetOtherSettings("datamanagersettings",$_REQUEST["daterangelimit"]);		
				$currentSetting = $profile->GetOtherSettings("datamanagersettings",getGlobalSetting("datamanagersettings",0));		
				
				$dataManager = new DataManager();
				$dataManager->ClearDatabase($profile,$currentSetting,true);
			}
			?>
		</div>
	</div>
	<?php
	#IMPORT
	$dir = "{$profile->datamanagerDir}{$profile->profilename}/log";
	$logFiles = array();
	if (is_dir($dir)) {
		if ($dh = opendir($dir)) {
			$prev_dropdown = "";
			while (($file = readdir($dh)) !== false) {
				if($file !== "." && $file !== "..") {							
					$month = explode(".",$file);
					$month = $month[0];
					$month = mktime(0,0,0,substr($month,4,-2),substr($month,6,7),substr($month,0,4));
					$month = date("Y m (F)",$month);							
					$logFiles[$month][] = $file;
				}
			}
			closedir($dh);
		}
	}
	ksort($logFiles);	
	?>
	<div id='importGrid'>
		<form>	
			<div class='list-header'>			
				<p style="margin:5px 10px"><b>Log File Overview</b></p>
			</div>
			<ul id='Logs'>
				<?php 
				foreach($logFiles as $m => $files) {	
					echo "<li class='includes'>";
						echo "<div class='logname selected'>";
							echo "<span class='name'>{$m}</span>";
						echo "</div>";
						echo "<ul class='monthcontent'>";
						$i = 0;
						foreach($files as $file) {
							echo "<li class='disabled' rel='{$i}'>";
								echo "<span class=''>{$file}</span>";
							echo "</li>";
							$i ++;
						}
						echo "</ul>";
					echo "</li>";
				}
				?>
			</ul>
		</form>
		<p style='margin:0; padding:5px;'><input type='checkbox' id='imex-checkbox' /><b>Manually Export / Import Logfiles</b></p>
	</div>
</div>