<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 

function CreatePDFContent($dash,$from="",$to="") {
	global $profile, $reports, $cm , $cloudapi;
	
	flush();	
	ob_start();
	?>
	<style type='text/css'>
@page :left {
  margin-left: 2cm;
  margin-right: 2cm;
}

@page :right {
  margin-left: 2cm;
  margin-right: 2cm;
}

.dialog_info span:first-child {
	border:0px !important;
	margin-left: 0px !important;
	padding-left: 0px !important;
}

	</style>
	<?php
	if(!empty($cm)){
		@$cm->PDFstylingOverwrite();
	}

	$dashboard = json_decode(stripslashes($profile->dashboards[$profile->profilename.".dashboards.$dash"]["Value"]),true);
	echo "<div id='print'>";
	if(empty($cloudapi)){ # for the cloud we do not need a header in the pdf
		echo "<h1 class='h1-title'>"._WEB_ANALYTICS_REPORT.": {$profile->confdomain}</h1>";
	}
	foreach($dashboard["reports"] as $grid) {		
		foreach($grid as $report) {
			if (!isset($report["label"])) {
				continue;
			}
			$r="";
			$r = new $reports[$report["label"]]["ClassName"]();
			$r->IgnReIm = 1; # even if there is a problem with the date we may never ever show the reimport box in de email alerts
			
			parse_str($report["url"],$options);
			foreach($options as $option => $value) {
				$r->$option = $value;
				$r->options[$option] = $value;
			}
			
			if(!empty($r->profileselector)){
				$r->profile = new SiteProfile($r->profileselector);
			}
			
			if (!empty($from) && !empty($to)) {
				$r->from = $from;
				$r->to = $to;
			} else if(isset($r->minimumDate) && isset($r->maximumDate)) {
				$dr = DateToTimestamp($r->minimumDate, $r->maximumDate);
				$r->from = $dr['from'];
				$r->to = $dr['to'];
			}
			
			if(!isset($r->trafficsource)){
				$r->trafficsource = null;
				$r->applytrafficsource = false;
			}else{
				$r->applytrafficsource = true;
			}
			$r->displayReportLabel = true;
			$r->displayReportButtons = false;
			// $r->sortTable= false;
			$r->animate_graph = false;
			echo "<div class='report readheight' style='clear:both;'>";
			$r->DisplayReport();
			echo "<div style='clear:both;'></div></div>";
		}	
	}

	echo "</div>";
	if(empty($cloudapi)){ # for the cloud we do not need a footer in the pdf
		echo "<div style='text-align:center;padding:10px;font-size:10px;'>Report created by Logaholic Web Analytics http://www.logaholic.com/</div>";
	}
	?>
	<script type="text/javascript">
	$(document).ready(function() {
		$("a").removeAttr("href");
		$("a").removeAttr("onclick");
		$("#mapArea").remove();
		
		var totalHeight = 0;
		var allowedHeight = 950;
		
		$(".readheight").each(function() {
			if ($(this).outerHeight() > allowedHeight) { // this one is going to be too long anyway, so lets just print it
				$(this).css('page-break-before','always');
				totalHeight = $(this).outerHeight();
			} else if(($(this).outerHeight() + totalHeight) >= allowedHeight) {
				$(this).css('page-break-before','always');
				totalHeight = $(this).outerHeight();
			} else {
				totalHeight += $(this).outerHeight();
			}
		});		
	});
	</script>
	<?php
	$content = ob_get_clean();

	return $content;
}

function askUser() {
	global $session, $db, $content, $profile, $http, $cm;

	if(CheckSubscriptionOption("PDF","Disabled")) {
		include_once "includes/change_subscriptions_setup.php";

		if(!file_exists("templates/pdfsubscription.php")){
			include_once "templates/pdfsubscription-example.php";
		} else {
			include_once "templates/pdfsubscription.php";
		}
		return false;			
	}			

	?>
	<div class="make-pdf">
	<?php
	if (!empty($cm->pdf_download_url)) {
		?>
		<h1><?php echo _CLICK_DOWNLOAD_PDF; ?></h1>
		<form method=post id="pdfform" action="<?php echo $cm->pdf_download_url; ?>">
		<?php
	} else {
		?>
		<h1><?php echo _ENCODING_SEND_PDF; ?></h1>
		<form method=post id="pdfform" action="<?php echo $http; ?>://software.logaholic.com/pdf/download.php">
		<?php
	}
	?>	
	<input type=hidden name="content" value="<?php echo base64_encode($content); ?>">
	<input type=hidden name="name" value="<?php echo $profile->confdomain.".pdf"; ?>">
	<input type=hidden name="version" value="<?php echo LOGAHOLIC_VERSION_NUMBER; ?>">
	<input type=submit id="submitbutton" value="<?php echo _DOWNLOAD_PDF; ?>">
	</form>
	<br />
	<br />
	<br />
	<?php echo _ALTERNATIVELY_PDF; ?><br />
	<form method=post id="htmlform" action="pdf.php?conf=<?php echo $profile->profilename;?>" target="_blank">
	<input type=hidden name="content" value="<?php echo base64_encode($content); ?>">
	<input type=hidden name="name" value="<?php echo $profile->confdomain.".pdf"; ?>">
	<input type=submit value="<?php echo _HTML_VERSION; ?>">
	</form>
	</div>
	<?php
}
?>