<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays a visitors per day table 
*/
if(!defined('APP_INCLUDE')){ die('invalid inclusion'); }

class TwitterCore extends Report {
    
	function Settings(){
		$this->IgnReIm = 1; # Never ever ask for reimport data
		if(isset($this->account)) {
			$this->fileNameExpension = ".".$this->account;
			$this->addlabel = $this->account;
		}
	}

    function getAcounts(){
		$accounts = $this->profile->GetOtherSettings("twitterAccounts",false);
		if($accounts != false){ $accounts = json_decode($accounts,true); }
		return $accounts;
	}

	function DefineReport(){
		echo "<h1>". _ADD_REMOVE_TWITTER ."</h1>";	
	
		$this->addForm();
		$this->remForm();
	}

	function GetDataFromDb(){
		# if no account is set return false
   		if(empty($this->account)){
   			return array();
   		}

   		$data = array();
   		$result = $this->TwitterCall("stats",$this->account);   		
   		$data[0][0] = date("d-M-Y D");
   		$data[0][1] = $result[0]['user']['followers_count'];
   		$data[0][2] = $result[0]['user']['friends_count'];
   		$data[0][3] = $result[0]['user']['statuses_count'];
   		return $data;
	}
	
	function TwitterCall($request, $q){		
		$twitter = file_get_contents("http://software.logaholic.com/twitter/?request={$request}&q={$q}");
		return json_decode( $twitter , true);
	}

	function addForm(){
		if(isset($_REQUEST["accountName"])){
			$val = $_REQUEST["accountName"];
		}else{ $val = ""; }
		
		echo "<form action='' method=post>";
			echo "<input type='text' name='accountName' value='$val' />";
			echo "<input type='submit' name='submitBtn' value='". _ADD_NEW_ACCOUNT ."' />";
		echo "</form>";

		if(isset($_REQUEST["accountName"])){
			$this->addAccount($_REQUEST["accountName"]);
		}
	}

	function addAccount($account){
		if(!$this->checkDoubleAccounts($account)){
			$accs = $this->getAcounts();
			if($accs == false){
				$accs[] = $account;
			}else{
				array_push($accs,$account);
			}
			$this->profile->SetOtherSettings("twitterAccounts",json_encode($accs));
		}else{
			echo _ACCOUNT_STORED;
		}
	}

	function checkDoubleAccounts($account){
		$accs = $this->getAcounts();
		if(!empty($accs)) {
			foreach($accs as $k => $v){
				if($v == $account){
					return true;
				}
			}
		}
		return false;
	}

	function remForm(){
		if(isset($_REQUEST["rem"])){
			$this->remAccount($_REQUEST["rem"]);
		}
		$accs = $this->getAcounts();
		if(!$accs){
			
		}else{
			echo "<ul class='twitter-remove-list'>";
			foreach($accs as $k => $v){
				echo "<li id='$k'><a href='?conf={$this->conf}&labels={$this->label_constant}&action=remform&rem=$k'></a> $v</li>";
			}
			echo "</ul>";
		}
	}

	function remAccount($num){
		$accs = $this->getAcounts();
		unset($accs[$num]);
		$this->profile->SetOtherSettings("twitterAccounts",json_encode($accs));
	}
	
	# Select/Add/Remove twitter account
	function DisplayCustomForm(){
		global $session;
		$accounts = $this->getAcounts();
		if(!$accounts){
			echo _NO_TWITTER_FOUND . "<br><br>";
		}else{
			echo "<select id='account' class='report_option_field'>";
			foreach($accounts as $k => $v){
				echo "<option value='$v'>$v</option>";
			}
			echo "</select>";
		}
		
		if($session->canEditProfiles()){
			echo "<br/><a href='definereport.php?conf={$this->conf}&labels={$this->label_constant}&action=start' class='optionlink open_iframe_window'>". _ADD_REMOVE_TWITTER_LINK ."</a><br/><br/>";
		}
	}
}
?>
