<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/
if(!defined('APP_INCLUDE')){ die('invalid inclusion'); }
 
	if (isset($profiletoupdate)) {
		if($profiletoupdate->structure_version < 4.01) {
			createDataTable($profiletoupdate);
			$profiletoupdate->structure_version = 4.01;
			$profiletoupdate->Save();
		}

		if($profiletoupdate->structure_version < 4.02) { # UPDATE useragents
			include_once("components/useragents/techpattern.php");
			
			ob_start();
			echoNotice("Updating user agent table, this might take a while...");
			lgflush();
			
			$hash = "hash";
			
			$q = $db->Execute("SELECT DISTINCT(useragentid), crawl FROM {$profiletoupdate->tablename}");
			while($row = $q->FetchRow()) {
				if ($row['useragentid']=='') {
					continue;
				}
				$q2 = $db->Execute("SELECT * FROM ".TBL_USER_AGENTS." WHERE id = {$row['useragentid']}");
				while($row2 = $q2->FetchRow()) {
					$id = $row2['id'];
					$agent_array = explode(" on ", $row2['name']);
					
					if(empty($row['crawl'])) {
						$row['crawl'] = 0;
					}
					
					if(count($agent_array) > 1) {
						$tmp_agent = explode(" ", str_replace("(text based browser)","",str_replace("(unknown version)","",$agent_array[0])));
						if($tmp_agent[0] == "Internet") {
							$browsername = $tmp_agent[0]." ".$tmp_agent[1];
							unset($tmp_agent[0]);
							unset($tmp_agent[1]);
						} else {
							$browsername = $tmp_agent[0];
							unset($tmp_agent[0]);
						}
						$browserversion = "";
						foreach($tmp_agent as $part) {
							$browserversion .= "{$part} ";
						}
						
						$tmp_os = explode(" ", str_replace("(unknown version)","",$agent_array[1]));
						$osname = $tmp_os[0];
						
						$osversion = "";
						if(count($tmp_os) > 1) {
							for($i = 1; $i < count($tmp_os); $i++) {
								$osversion .= "{$tmp_os[$i]} ";
							}
						}
						
						$uq = "INSERT INTO {$profiletoupdate->tablename_useragents} (`id`,`name`,`version`,`os`,`os_version`,`useragent`,`$hash`,`is_bot`) VALUES (".$db->Quote($id).", ".$db->Quote($browsername).", ".$db->Quote($browserversion).", ".$db->Quote($osname).", ".$db->Quote($osversion).", ".$db->Quote($row2['name']).", ".$db->Quote(md5($row2['name'])).",{$row['crawl']}) ON DUPLICATE KEY UPDATE id=LAST_INSERT_ID(id)";
					} else {
						$detected = get_useragent($row2['name']);
						
						$uq = "INSERT INTO {$profiletoupdate->tablename_useragents} (`id`, `name`, `version`, `os`, `os_version`, `engine`, `useragent`, `$hash`, `is_bot`, `is_mobile`, `device`) VALUES (".$db->Quote($id).", ".$db->Quote($detected['agent_name']).", ".$db->Quote($detected['agent_version']).", ".$db->Quote($detected['agent_os']).", ".$db->Quote($detected['agent_os_version']).", ".$db->Quote($detected['agent_engine']).", ".$db->Quote($detected['agent_string']).", ".$db->Quote(md5($detected['agent_string'])).", ".$db->Quote($detected['agent_is_bot']).", ".$db->Quote($detected['agent_is_mobile']).", ".$db->Quote($detected['agent_device']).") ON DUPLICATE KEY UPDATE id=LAST_INSERT_ID(id)";
					}
					$db->Execute($uq) or die('Error creating table');
				}
			}
			
			$profiletoupdate->structure_version = 4.02;
			$profiletoupdate->Save();
		}
				
		if($profiletoupdate->structure_version < 4.03) {
			$db->Execute("UPDATE {$profiletoupdate->tablename_visitorids} SET customlabel='' WHERE customlabel is NULL") or die('Error updating visitorid table');
			$db->Execute("ALTER table {$profiletoupdate->tablename_visitorids} change column customlabel customlabel varchar(80) NOT NULL DEFAULT ''") or die('Error updating visitorid table');
			
			$profiletoupdate->structure_version = 4.03;
			$profiletoupdate->Save();
		}

		if($profiletoupdate->structure_version < 4.04) { # Update traffic source
			$query = "UPDATE ".TBL_TRAFFIC_SOURCES." set sourcecondition = ".$db->Quote("is_mobile ='1'")." where profileid='$profiletoupdate->profileid' and sourcename='Mobile Visitors'";
			
			if ($result = $db->Execute($query)) {
					echoNotice("Updated Mobile Visitors Segment");
			}
			$profiletoupdate->structure_version = 4.04;
			$profiletoupdate->Save();
		}
			
		
		# URLS
		if($profiletoupdate->structure_version < 4.05) {
			if( CheckIfIndexExists($profiletoupdate->tablename_urls,$profiletoupdate->tablename_urls."_url") ){
				$db->Execute("ALTER TABLE {$profiletoupdate->tablename_urls} DROP INDEX {$profiletoupdate->tablename_urls}_url");
				$profiletoupdate->structure_version = 4.05;
				$profiletoupdate->Save();
			}
		}
		
		# URLS
		if($profiletoupdate->structure_version < 4.06) {
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename_urls} ADD COLUMN `hash` CHAR(32)");
			$profiletoupdate->structure_version = 4.06;
			$profiletoupdate->Save();
		}
		
		# URLS
		if($profiletoupdate->structure_version < 4.07) {
			$db->Execute("UPDATE {$profiletoupdate->tablename_urls} SET `hash` = MD5(url)");
			$profiletoupdate->structure_version = 4.07;
			$profiletoupdate->Save();
		}
		
		# URLS
		if($profiletoupdate->structure_version < 4.08) {
			$db->Execute("ALTER IGNORE TABLE {$profiletoupdate->tablename_urls} ADD UNIQUE INDEX (hash)");
			$profiletoupdate->structure_version = 4.08;
			$profiletoupdate->Save();
		}				
		
		# URLPARAMS
		if($profiletoupdate->structure_version < 4.09) {
			if( CheckIfIndexExists($profiletoupdate->tablename_urlparams,$profiletoupdate->tablename_urlparams."_params") ){
				$db->Execute("ALTER TABLE {$profiletoupdate->tablename_urlparams} DROP INDEX {$profiletoupdate->tablename_urlparams}_params");
				$profiletoupdate->structure_version = 4.09;
				$profiletoupdate->Save();
			}
		}
		
		# URLPARAMS
		if($profiletoupdate->structure_version < 4.10) {
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename_urlparams} ADD COLUMN `hash` CHAR(32)");
			$profiletoupdate->structure_version = 4.10;
			$profiletoupdate->Save();
		}
		
		# URLPARAMS
		if($profiletoupdate->structure_version < 4.11) {
			$db->Execute("UPDATE {$profiletoupdate->tablename_urlparams} SET `hash` = MD5(params)");
			$profiletoupdate->structure_version = 4.11;
			$profiletoupdate->Save();
		}
		
		# URLPARAMS
		if($profiletoupdate->structure_version < 4.12) {
			$db->Execute("ALTER IGNORE TABLE {$profiletoupdate->tablename_urlparams} ADD UNIQUE INDEX (hash)");
			$profiletoupdate->structure_version = 4.12;
			$profiletoupdate->Save();
		}	
		
		# REFFERERS
		if($profiletoupdate->structure_version < 4.13) {			
			if( CheckIfIndexExists($profiletoupdate->tablename_referrers,$profiletoupdate->tablename_referrers."_referrer") ){
				$db->Execute("ALTER TABLE {$profiletoupdate->tablename_referrers} DROP INDEX {$profiletoupdate->tablename_referrers}_referrer");
				$profiletoupdate->structure_version = 4.13;
				$profiletoupdate->Save();
			}
		}
		
		# REFFERERS
		if($profiletoupdate->structure_version < 4.14) {
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename_referrers} ADD COLUMN `hash` CHAR(32)");
			$profiletoupdate->structure_version = 4.14;
			$profiletoupdate->Save();
		}
		
		# REFFERERS
		if($profiletoupdate->structure_version < 4.15) {
			$db->Execute("UPDATE {$profiletoupdate->tablename_referrers} SET `hash` = MD5(referrer)");
			$profiletoupdate->structure_version = 4.15;
			$profiletoupdate->Save();
		}
		
		# REFFERERS
		if($profiletoupdate->structure_version < 4.16) {
			$db->Execute("ALTER IGNORE TABLE {$profiletoupdate->tablename_referrers} ADD UNIQUE INDEX (hash)");
			$profiletoupdate->structure_version = 4.16;
			$profiletoupdate->Save();
		}		
		
		# REFPARAMS
		if($profiletoupdate->structure_version < 4.17) {
			if( CheckIfIndexExists($profiletoupdate->tablename_refparams,$profiletoupdate->tablename_refparams."_params") ){
				$db->Execute("ALTER TABLE {$profiletoupdate->tablename_refparams} DROP INDEX {$profiletoupdate->tablename_refparams}_params");
				$profiletoupdate->structure_version = 4.17;
				$profiletoupdate->Save();
			}
		}
		
		# REFPARAMS
		if($profiletoupdate->structure_version < 4.18) {
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename_refparams} ADD COLUMN `hash` CHAR(32)");
			$profiletoupdate->structure_version = 4.18;
			$profiletoupdate->Save();
		}
		
		# REFPARAMS
		if($profiletoupdate->structure_version < 4.19) {
			$db->Execute("UPDATE {$profiletoupdate->tablename_refparams} SET `hash` = MD5(params)");
			$profiletoupdate->structure_version = 4.19;
			$profiletoupdate->Save();
		}
		
		# REFPARAMS
		if($profiletoupdate->structure_version < 4.20) {
			$db->Execute("ALTER IGNORE TABLE {$profiletoupdate->tablename_refparams} ADD UNIQUE INDEX (hash)");
			$profiletoupdate->structure_version = 4.20;
			$profiletoupdate->Save();
		}		
		
		# KEYWORDS
		if($profiletoupdate->structure_version < 4.21) {
			if( CheckIfIndexExists($profiletoupdate->tablename_keywords,$profiletoupdate->tablename_keywords."_keywords") ){
				$db->Execute("ALTER TABLE {$profiletoupdate->tablename_keywords} DROP INDEX {$profiletoupdate->tablename_keywords}_keywords");
				$profiletoupdate->structure_version = 4.21;
				$profiletoupdate->Save();
			}
		}
		
		# KEYWORDS
		if($profiletoupdate->structure_version < 4.22) {
			# Gives duplicate error
			@$db->Execute("ALTER TABLE {$profiletoupdate->tablename_keywords} ADD COLUMN `hash` CHAR(32)");
			$profiletoupdate->structure_version = 4.22;
			$profiletoupdate->Save();
		}
		
		# KEYWORDS
		if($profiletoupdate->structure_version < 4.23) {
			$db->Execute("UPDATE {$profiletoupdate->tablename_keywords} SET `hash` = MD5(keywords)");
			$profiletoupdate->structure_version = 4.23;
			$profiletoupdate->Save();
		}
		
		# KEYWORDS
		if($profiletoupdate->structure_version < 4.24) {
			$db->Execute("ALTER IGNORE TABLE {$profiletoupdate->tablename_keywords} ADD UNIQUE INDEX (hash)");
			$profiletoupdate->structure_version = 4.24;
			$profiletoupdate->Save();
		}
		
		# VISITORIDS
		if($profiletoupdate->structure_version < 4.25) {
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename_visitorids} CHANGE COLUMN `ipnumber` `ipnumber` VARCHAR(255)");
			$profiletoupdate->structure_version = 4.25;
			$profiletoupdate->Save();
		}	
		
		# VISITORIDS
		if($profiletoupdate->structure_version < 4.26) {
			if( CheckIfIndexExists($profiletoupdate->tablename_visitorids,$profiletoupdate->tablename_visitorids."_visitorid") ){
				$db->Execute("ALTER TABLE {$profiletoupdate->tablename_visitorids} DROP INDEX {$profiletoupdate->tablename_visitorids}_visitorid");
				$profiletoupdate->structure_version = 4.26;
				$profiletoupdate->Save();
			}
		}
		
		# VISITORIDS
		if($profiletoupdate->structure_version < 4.27) {
			# Error: can't drop check if not exists
			@$db->Execute("ALTER TABLE {$profiletoupdate->tablename_visitorids} DROP INDEX hash");
			$profiletoupdate->structure_version = 4.27;
			$profiletoupdate->Save();
		}
		
		# for visitorids, just use the visitorid column
		if($profiletoupdate->structure_version < 4.28) {
			if( !CheckIfIndexExists($profiletoupdate->tablename_visitorids,"visitorid") ){
				$db->Execute("create unique index visitorid on {$profiletoupdate->tablename_visitorids} (visitorid)");
				$profiletoupdate->structure_version = 4.28;
				$profiletoupdate->Save();
			}
		}
		
				
		if($profiletoupdate->structure_version < 4.29) {
			ob_start();
			echoNotice("Changing index structure of main table ..");
			lgflush();
			
			# now do the main table indexes
			if( CheckIfIndexExists($profiletoupdate->tablename,"visitorid") ){
				$db->Execute("ALTER TABLE {$profiletoupdate->tablename} DROP INDEX visitorid");
			}
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename} DROP INDEX url");
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename} DROP INDEX referrer");
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename} DROP INDEX keywords");
			
			$profiletoupdate->structure_version = 4.29;
			$profiletoupdate->Save();
		}
		
		if($profiletoupdate->structure_version < 4.30) {
			$db->Execute("DROP TABLE IF EXISTS {$profiletoupdate->tablename}_vpd");
			$db->Execute("DROP TABLE IF EXISTS {$profiletoupdate->tablename}_vpm");
			$db->Execute("DROP TABLE IF EXISTS {$profiletoupdate->tablename}_sessionid");
			$db->Execute("DROP TABLE IF EXISTS {$profiletoupdate->tablename}_dailyurls");
			$profiletoupdate->structure_version = 4.30;
			$profiletoupdate->Save();
		}
				
		if($profiletoupdate->structure_version < 4.31) {
		
			$db->Execute("ALTER TABLE {$profiletoupdate->tablename_visitorids} ADD COLUMN `crawl` INT(1) NOT NULL default 0");
			
			$profiletoupdate->structure_version = 4.31;
			$profiletoupdate->Save();
		}


		if($profiletoupdate->structure_version < 4.32) {
			# deprecated
			// if (LOGAHOLIC_BASE_EDITION != "cPanel Edition") {
				// setProfileData($profiletoupdate->profilename, "{$profiletoupdate->profilename}.updatePreference", 'regular');
			// }
			$profiletoupdate->structure_version = 4.32;
			$profiletoupdate->Save();
		}

		if($profiletoupdate->structure_version < 4.33) {
			
			$db->Execute("delete from `".TBL_GLOBAL_SETTINGS."` WHERE `Name` LIKE '{$profiletoupdate->profilename}.bounce.%' AND `Profile` = '{$profiletoupdate->profilename}'");

			$profiletoupdate->structure_version = 4.33;
			$profiletoupdate->Save();
		}

		if($profiletoupdate->structure_version < 4.34) {
			$db->Execute("DROP TABLE IF EXISTS {$profiletoupdate->tablename}_vpd");
			$db->Execute("DROP TABLE IF EXISTS {$profiletoupdate->tablename}_vpm");
			$db->Execute("DROP TABLE IF EXISTS {$profiletoupdate->tablename}_sessionid");
			$db->Execute("DROP TABLE IF EXISTS {$profiletoupdate->tablename}_dailyurls");
			$profiletoupdate->structure_version = 4.34;
			$profiletoupdate->Save();
		}


		if ($profiletoupdate->structure_version < 4.35) {
			$profiletoupdate->setDefaultDashboard();	
			$profiletoupdate->structure_version = 4.35;
			$profiletoupdate->Save();
		}
		
		if ($profiletoupdate->structure_version < 4.36) {
			$tables = array();
			$tables[] = $profiletoupdate->tablename;
			$tables[] = $profiletoupdate->tablename_conversions;
			$tables[] = $profiletoupdate->tablename_urls;
			$tables[] = $profiletoupdate->tablename_urlparams;
			$tables[] = $profiletoupdate->tablename_referrers;
			$tables[] = $profiletoupdate->tablename_refparams;
			$tables[] = $profiletoupdate->tablename_keywords;
			if ($profiletoupdate->trackermode==1) {
				$tables[] = $profiletoupdate->tablename_trackerlog;
			}
			$tables[] = $profiletoupdate->tablename_useragents;
			$tables[] = $profiletoupdate->tablename_crawl;
			$tables[] = $profiletoupdate->tablename_visitorids;
			$tables[] = $profiletoupdate->tablename_screenres;
			$tables[] = $profiletoupdate->tablename_colordepth;
			
			foreach($tables as $k => $table){
				$results = $db->Execute("SHOW CREATE TABLE $table");
				$row = $results->fetchRow();
				# Set the engine to MyISAM if it is something else
				if(strpos($row[1],"ENGINE=MyISAM") === false){
					$db->Execute("ALTER TABLE $table ENGINE =  MyISAM;");
				}
				
				# Set the charset to utf8 if it is something else
				if(strpos($row[1],"CHARSET=utf8") === false){
					$db->Execute("alter IGNORE table $table convert to character set utf8 collate utf8_general_ci");
				}
			}
			
			$profiletoupdate->structure_version = 4.36;
			$profiletoupdate->Save();
		}
	}
		
?>