<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
include_once("common.inc.php");
AccessCheck();

if(!isset($_SERVER['HTTP_X_REQUESTED_WITH']) || strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) !== 'xmlhttprequest') {
	die('Ajax only');
}

if (!isset($_REQUEST["conf"])) { die(_MISSING_REQUIRED_PARAM); }
if (!isset($_REQUEST["labels"]) || empty($_REQUEST["labels"])) { die(_MISSING_REQUIRED_PARAM); }


function AdvancedOptions() {
	global $optionvalues,$r,$reports;

	# If this reports does not create datafiles we should not be able to recreate them.
	if(isset($reports[$r->label_constant]['Update']) && $reports[$r->label_constant]['Update'] === false){
		return false;
	}

	echo "<br/><div class='advanced-report-options'>";
		echo "<a class='optionlink advanced-options-toggler' style='color: #333;'>". _ADVANCED_REPORT_OPTIONS ."</a>";
		echo "<div class='advanced-options-form'>";
			echo "<table>";
				echo "<tr>";	
					echo "<td>"; 
						echo "<input class='noTextInput' name='regenerateDatafiles' type='checkbox' />";
					echo "</td>";
					echo "<td><label>". _RECREATE_DATAFILES ."</label></td>";
				echo "</tr>";
			echo "</table>";
		echo "</div>";
	echo "</div>";
}

function columnSelector() {
	global $r, $optionvalues;
	$fields = $r->fieldsArray();

	if(!empty($optionvalues['displaymode']) && $optionvalues['displaymode'] != 'table') {
		$display = " style='display: none;'";
	} else {
		$display = "";
	}
	
	echo "<div class='column-selector'{$display}>";
	echo "<a class='optionlink column-selector-toggler' style='color: #333;'>". _SHOW_HIDE_COLUMNS ."</a>";
	echo "<div class='column-selector-form'>";
		echo "<table>";
		$i = 0;
		$first = true;
		foreach($fields as $field) {
			$name = "showColumn".$i;
			if(!isset($optionvalues[$name])) {
				$first = true;
			}else{
				$first = false;
				break;
			}
			$i ++;
		}
		$i = 0;
		foreach($fields as $field){
			$name = "showColumn".$i;
			if(isset($optionvalues[$name])) {
				$selected = "checked='yes'";
			} else {
				$selected = "";
			}
			if($first == true) {
				$selected = "checked='yes'";
			}
			echo "<tr><td><input class='noTextInput' type='checkbox' {$selected} name='showColumn{$i}' /></td><td><label for='showColumn{$i}'>{$field}</label></td></tr>";
			$i ++;
		}
		echo "</table>";
	echo "</div>";
	echo "</div>";
}

$labels = $_REQUEST['labels'];
if (!isset($reports[$labels])) { die('invalid label'); }

if(!empty($labels) && $labels != 'global') {
	$report_label = $labels;
	
	$r = new $reports[$report_label]["ClassName"]();
	
	$optionvalues = $_REQUEST;
	$reportoptions = explode(",",$reports[$report_label]["Options"]);
	
	if(empty($optionvalues['period'])) {
		$optionvalues['period'] = $r->period;
	}
} else {
	$reportoptions = array("daterangeField");
}

foreach($reportoptions as $reportoption) {
	if($reportoption == "daterangeField") {
		if(!empty($optionvalues['from']) && !empty($optionvalues['to'])) {
			$minDate = date(GetCustomDateFormat(), $optionvalues['from']);
			$maxDate = date(GetCustomDateFormat(), $optionvalues['to']);
		} else if(!empty($optionvalues['minimumDate']) && !empty($optionvalues['maximumDate'])) {
			$minDate = $optionvalues['minimumDate'];
			$maxDate = $optionvalues['maximumDate'];
		} else {
			$minDate = date(GetCustomDateFormat(), $from);
			$maxDate = date(GetCustomDateFormat(), $to);
		}
		?>
		<label for='daterangeField'><?php echo _DATE_RANGE; ?></label>
		<input type='text' class='noOption' id='daterangeField' name='daterangeField' value='<?php echo $minDate; ?> - <?php echo $maxDate; ?>'/>
		<?php
		echo "<input type='hidden' class='isDefault' id='minimumDate' name='minimumDate' value='{$minDate}' />";
		echo "<input type='hidden' class='isDefault' id='maximumDate' name='maximumDate' value='{$maxDate}' />";
	}
	
	if($reportoption == "displaymode") {
		if(!empty($optionvalues['displaymode'])) {
			$default_displaymode = $optionvalues['displaymode']; 
		} else {
			if(!empty($r->DefaultDisplay)) {
				$default_displaymode = $r->DefaultDisplay;
			} else {
				$default_displaymode = "table";
			}
		}
		
		$displaymodes = explode(",", $r->DisplayModes);
		
        echo "<label for='{$reportoption}'>"._DISPLAY_MODE.":</label>";
		echo "<select id=\"displaymode\" name=\"displaymode\">";
			foreach($displaymodes as $displaymode) {
				if($default_displaymode == $displaymode) { $sel = "selected"; } else { $sel = ""; }
				echo "<option {$sel} value=\"{$displaymode}\">".ucwords( constant("_". strtoupper($displaymode)) )."</option>";
			}
		echo "</select>";
	}
	
	if($reportoption == "profileselector" && LOGAHOLIC_BASE_EDITION !== $edition[4]) {
		
		
		if(!$validUserRequired || $session->isAdmin() || $session->allProfiles){
			echo "<label for='{$reportoption}'>".ucwords(_PROFILE).":</label>";
			echo "<input type=text id=\"profileselector\" name=\"profileselector\" value=\"$profile->profilename\"><br/><br/>";
			?>
			<script>
				$( "#profileselector" ).autocomplete({
					source: function(request, callback){
						GetAvailableProfiles(request,callback);
					},
					minLength: 0
				});
				$("#profileselector").on("autocompleteclose", function(){
					switchProfile($(this));
				});

			</script>
			<?php
		} else {
			if(!empty($session->user_profiles) && count($session->user_profiles) > 1){
			echo "<label for='{$reportoption}'>".ucwords(_PROFILE).":</label>";
			echo "<input type=text id=\"profileselector\" name=\"profileselector\" value=\"$profile->profilename\"><br/><br/>";
			?>
			<script>
				$( "#profileselector" ).autocomplete({
					source: function(request, callback){
						GetAvailableProfiles(request,callback);
					},
					minLength: 0
				});
				$("#profileselector").on("autocompleteclose", function(){
					switchProfile($(this));
				});
			</script>
			<?php
			}
		}
	}
	
	
	if($reportoption == "limit") {
		if(!empty($optionvalues['limit'])) {
			$limit = $optionvalues['limit'];
		}
		if (!$limit) {
		   $limit = $r->limit;
		}
		echo "<label for='{$reportoption}'>"._LIMIT."<span class='small'> ("._MAX_NUMBER_OF_RESULTS_TO_SHOW.")</span></label><input type='text' size='3' name='{$reportoption}' id='limit' value='{$limit}' class='small'>";
	}
	
	if($reportoption == "trafficsource") {
		echo "<label for='{$reportoption}' style='color: #333;'>"._FILTERS."</label>";
		if(empty($optionvalues['trafficsource'])) { $optionvalues['trafficsource'] = 0; }
		echo printTrafficSourceSelectUI($optionvalues['trafficsource']);
	}
	
	if($reportoption == "roadto") {
		if(!empty($optionvalues['roadto'])) {
			$roadto = $optionvalues['roadto'];
		}
        echo "<label for='{$reportoption}'>"._TARGET.":</label>";
        echo "<select id=\"roadto\" name=\"roadto\">";

        if ($profile->targetfiles) {
			$targets=explode(",",$profile->targetfiles);
			foreach ($targets as $thistarget) {
				if ($thistarget) {
					if(isset($roadto)) {
						if (trim($thistarget)==$roadto) { $sel="selected"; } else { $sel=""; }
					} else {
						$sel="";
					}
					echo "<option $sel value=\"".trim($thistarget)."\">".trim($thistarget)."\n";
				}
			}
        } else {
			echo "<option selected=\"selected\" value=\"\">"._NONE."</option>";
		}
        echo "</select>";
	}
	
	if($reportoption == "internal_site_search") {
		if(!empty($optionvalues['internal_site_search'])) {
			$search = $optionvalues['internal_site_search'];
		} else {
			$search = $profile->GetOtherSettings("sitesearch");
			if(empty($search)) {
				$search = "";
			}
		}
        echo "<label for='{$reportoption}'>"._SEARCH."&nbsp;"._PAGE.":</label>";
        echo "<input id=\"internal_site_search\" type=text size=40 name=internal_site_search value=\"$search\" class='small'> <span class=small> "._SEARCH_PAGE_EXPLAIN." </span>";
        echo "<input type=hidden name=searchmode value=\"like\">";
	}
	
	if($reportoption == "search") {
		if(!empty($optionvalues['search'])) {
			$search =$optionvalues['search'];
		} else {
            $search = "";    
        }
		
		if(!empty($optionvalues['searchmode'])) {
			$searchmode = $optionvalues['searchmode'];
		} else if (!empty($r->searchmode)) {
			$searchmode = $r->searchmode;
		}
		
		switch($report_label) {
			case "_GOOGLE_RANKINGS":
			case "_KEYWORD_CONVERSION":
			case "_KEYWORD_TRENDS":
			case "_TOP_KEYWORDS":
			case "_TOP_KEYWORDS_DETAILS":
				$metric = _KEYWORDS;
				break;
			case "_REFERRER_CONVERSION":
			case "_REFERRER_TRENDS":
			case "_TOP_REFERRERS":
			case "_TOP_REFERRERS_DETAILS":
				$metric = _REFERRERS;
				break;
			case "_ERROR_REPORT":
			case "_MOST_CRAWLED_PAGES":
			case "_PAGE_CONVERSION":
			case "_PAGE_TRENDS":
			case "_TOP_PAGES":
			case "_TOP_PAGES_DETAILS":
				$metric = _PAGES;
				break;
			case "_MOST_ACTIVE_CRAWLERS":
				$metric = _CRAWLERS;
				break;
			case "_MOST_ACTIVE_USERS":
			case "_RECENT_VISITORS":
				$metric = _IP_NUMBERS;
				break;
			case "_TOP_FEEDS":
				$metric = _FEEDS;
				break;
			default:
				$metric = constant($report_label);
		}
		
		echo _SEARCH." {$metric} "._THAT." ";
		if (!empty($searchmode)) {
			echo "<select class='' id='searchmode' name='searchmode'>";
			if($searchmode == "not like") {
				echo "<option value='equals'>"._EQUALS."</option>";
				echo "<option value='like'>"._MATCH."</option>";
				echo "<option value='not like' selected>"._DONT_MATCH."</option>";
			} elseif($searchmode == "like") {
				echo "<option value='equals'>"._EQUALS."</option>";
				echo "<option value='like' selected>"._MATCH."</option>";
				echo "<option value='not like'>"._DONT_MATCH."</option>";
			} else {
				echo "<option value='equals' selected>"._EQUALS."</option>";
				echo "<option value='like'>"._MATCH."</option>";
				echo "<option value='not like'>"._DONT_MATCH."</option>";
			}
			echo "</select>";
		} else {
			echo _MATCH." <input class='' id='searchmode' type='hidden' name='searchmode' value='like'>";
		}
		echo "<input type='text' size='35' name='search' id='search' value='{$search}' class='small' title=\""._YOU_MAY_USE_AND_OR_SELECTORS."\"><span class='small'>";
		echo "</span>";
	}
	
	if($reportoption == 'source') {
		echo "<label for='sourcetype'>"._SEARCH."</label>";
		echo "<select class='report_option_field' id='sourcetype'>";
			echo "<option value=\"page\" "; if (@$optionvalues['sourcetype'] == "page") { echo "selected=\"selected\""; } echo ">"._PAGE.": </option>";
			echo "<option value=\"keyword\" "; if (@$optionvalues['sourcetype'] == "keyword") { echo "selected=\"selected\""; } echo ">"._KEYWORD.": </option>";
			echo "<option value=\"referrer\" ";     if (@$optionvalues['sourcetype'] == "referrer") { echo "selected=\"selected\""; } echo ">"._REFERRER.": </option>";
		echo "</select>";
		
		echo "<div>";
			echo "<input class='report_option_field' type=\"text\" name=\"source\" id=\"source\" value=\"".@urldecode($optionvalues['source'])."\" onkeyup=\"popupActionMenu(event, this.value+'@'+this.id+'@'+$('#sourcetype').val(), 'forminput');\" onclick=\"popupMenu(event, this.value+'@'+this.id+'@'+$('#sourcetype').val(), 'forminput');\" autocomplete=\"off\">";
		echo "</div>";
	}
	
	if($reportoption == 'period') {
		# Period selector
		$sel1 = "";
		$sel2 = "";
		$sel3 = "";
		$sel4 = "";
		
		if ($optionvalues['period'] == _DAYS) {
			$sel1 = "selected";
		} else if ($optionvalues['period'] == _WEEKS) { 
			$sel2 = "selected";
		} else if ($optionvalues['period'] == _MONTHS) { 
			$sel3 = "selected";
		} else {
			$sel4 = "selected";
		}
		
		echo "".strtoupper(substr(_REPORT,0,1)).substr(_REPORT,1).' '._PERIOD.": ";
		
		echo "<select id='period' name='period'>";
			echo "<option {$sel4} value='auto'>Auto</option>";
			echo "<option {$sel1} value='"._DAYS."'>"._DAYS."</option>";
			echo "<option {$sel2} value='"._WEEKS."'>"._WEEKS."</option>";
			echo "<option {$sel3} value='"._MONTHS."'>"._MONTHS."</option>";
		echo "</select>";
	}
	
	if($reportoption != 'columnSelector' && $reportoption != 'profileselector') {
		echo "<br/><br/>";
	}
}

echo "<input name='conf' id='conf' value='{$profile->profilename}' type='hidden' />";
if(!empty($labels) && $labels != 'global') {
	echo "<input name='labels' id='labels' value='{$report_label}' type='hidden' />";
}

if(!empty($r)) {
	echo $r->DisplayCustomForm();
}

if(in_array("columnSelector", $reportoptions) !== false) {
	if($r->displaymode != 'pie' && $r->displaymode != 'bubble') {
		columnSelector();
	}
}
AdvancedOptions();

if(!empty($labels)) { // Delete Report
	if(!empty($downloaded_reports)) {
		if(array_key_exists($reports[$report_label]['ClassName'], $is_download) == true) {
			echo "<a style='position: absolute; margin-top: 100px; left: 15px;' class='delete_download' href='includes/deletedownload.php?conf={$conf}&delete_download={$is_download[$reports[$report_label]['ClassName']]}'>"._DELETE_DOWNLOADED_REPORT."</a>";
		}
	}
}
?>
<script type="text/javascript">
$(document).ready( function(){
	/* We'll handle the Quick Date options here */
	$(".set-lwa-datepicker").live("click", function() {
		var DateObject = new Date();
		
		// Today
		if($(this).hasClass('lwa_today')) {
			var from_date = new Date().format('<?php echo implode($profile->dateFormat); ?>');
			var to_date = new Date().format('<?php echo implode($profile->dateFormat); ?>');
		}
		
		// Yesterday
		if($(this).hasClass('lwa_yesterday')) {
			var from_date = new Date(new Date().setDate(new Date().getDate()-1)).format('<?php echo implode($profile->dateFormat); ?>');
			var to_date = new Date(new Date().setDate(new Date().getDate()-1)).format('<?php echo implode($profile->dateFormat); ?>');
		}
		
		// Last 7 Days
		if($(this).hasClass('lwa_last7days')) {
			var from_date = new Date(new Date().setDate(new Date().getDate()-6)).format('<?php echo implode($profile->dateFormat); ?>');
			var to_date =  new Date().format('<?php echo implode($profile->dateFormat); ?>');
		}

		// Last 30 Days
		if($(this).hasClass('lwa_last30days')) {
			var from_date = new Date(new Date().setDate(new Date().getDate()-30)).format('<?php echo implode($profile->dateFormat); ?>');
			var to_date =  new Date().format('<?php echo implode($profile->dateFormat); ?>');
		}
		
		// This Month
		if($(this).hasClass('lwa_thismonth')) {
			var from_date = '<?php echo date(implode($profile->dateFormat),strtotime("01 ".date("F")." ".date("Y"))); ?>';
			var to_date =  new Date().format('<?php echo implode($profile->dateFormat); ?>');
		}
		
		// Last Month
		if($(this).hasClass('lwa_lastmonth')) {
			var from_date = '<?php echo date(implode($profile->dateFormat),mktime(0,0,0,date("m")-1,01,date("Y"))); ?>';
			var to_date = '<?php echo date(implode($profile->dateFormat),mktime(23,59,59,date("m"),1 -1,date("Y"))); ?>';
		}
		
		// Last 3 Months
		if($(this).hasClass('lwa_last3months')) {
			var from_date = '<?php echo date(implode($profile->dateFormat),mktime(0,0,0,date("m")-2,01,date("Y"))); ?>';
			var to_date =  new Date().format('<?php echo implode($profile->dateFormat); ?>');
		}
		
		// This Year
		if($(this).hasClass('lwa_thisyear')) {
			var from_date = '<?php echo date(implode($profile->dateFormat),strtotime("01 January ".date("Y"))); ?>';
			var to_date =  new Date().format('<?php echo implode($profile->dateFormat); ?>');
		}
		
		// Last Year
		if($(this).hasClass('lwa_lastyear')) {
			var from_date = '<?php echo date(implode($profile->dateFormat),strtotime("01 January ".(date("Y")-1))); ?>';
			var to_date = '<?php echo date(implode($profile->dateFormat),strtotime("31 December ".(date("Y")-1))); ?>';
		}
		
		// All Time
		if($(this).hasClass('lwa_alltime')) {
			var from_date = '<?php echo date(implode($profile->dateFormat),LogaholicFirstTimestamp());?>';
			var to_date =  new Date().format('<?php echo implode($profile->dateFormat); ?>');
		}
		


		$("#fromRange").datepicker('setDate', from_date);
		$("#toRange").datepicker('setDate', to_date);
		$("#daterangeField").attr('value', from_date + ' - ' + to_date);
		$('#minimumDate').attr('value', from_date);
		$('#maximumDate').attr('value', to_date);
		$(".lwa_datepicker").hide();
		$(".lwa_datepicker_overlay").hide();
	});
});
</script>