<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays all traffic by hour
*/

$reports["_ALL_TRAFFIC_BY_MINUTE"] = Array(
	"ClassName" => "AllTrafficByMinute", 
	"Category" => "_TRAFFIC", 
	"icon" => "images/icons/32x32/alltrafficbyhour.png",
	"Options" => "daterangeField,profileselector,trafficsource,columnSelector,displaymode",
	"Filename" => "all_traffic_by_minute",
	"Distribution" => "Premium",
	"Order" => 3,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => false
);

class AllTrafficByMinute extends Report {
	
	function Settings() {
		$this->DisplayModes = "table,linechart,barchart";
		$this->DefaultDisplay = "linechart";
		if(!isset($this->displaymode)){
			$this->displaymode = "table";
		}
		
		$this->columnDefinitions[] = array("Label" => 'Min');
		if($this->displaymode == 'table'){
			$this->columnDefinitions[] = array("Label" => _UNIQUE_IPS);
		} else {
			$this->columnDefinitions[] = array("Label" => addslashes(_UNIQUE_IPS));
		}
		$this->columnDefinitions[] = array("Label" => _TOTAL_PAGES);
		$this->columnDefinitions[] = array("Label" => _VIEWED_PAGES);
		$this->columnDefinitions[] = array("Label" => _CRAWLED_PERC);
		$this->columnDefinitions[] = array("Label" => _PAGES_PER_IP);
		$this->help = _ALL_TRAFFIC_BY_MINUTE_HELP;
	}
	
	function DefineQuery() {
		global $db;
		$query  = "SELECT FROM_UNIXTIME(timestamp, '%d-%b-%Y %H:%i') AS days, COUNT(DISTINCT visitorid) AS visitors, COUNT(*) as requests, (COUNT(*) - SUM(crawl)) AS viewed, (SUM(crawl) / (COUNT(*) * 1.00)*100) AS crawled, (COUNT(*) / (COUNT(DISTINCT visitorid) * 1.00)) AS ppu FROM ".$this->profile->tablename_merge." WHERE timestamp >= ". $db->quote($this->from) ." AND timestamp <= ". $db->quote($this->to) ." GROUP BY days ORDER BY timestamp";

		return $query;
	}
	
	function DisplayCustomForm(){
			echoWarning(_ALL_TRAFFIC_BY_MINUTE_ROW_WARNING,"margin-right:25px;");
	}
	
	function updateStats(){	
		# this report has a low priority
		return false;
	}
}
?>