<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays a clicktrail
*/
$reports["_CLICK_TRAILS"] = Array(
	"ClassName" => "ClickTrail", 
	"Category" => "_VISITOR_DETAILS", 
	"icon" => "images/icons/32x32/clicktrails.png",
	"Options" => "daterangeField,profileselector,limit",
	"Filename" => "clicktrail",
	"Distribution" => "Legacy",
	"Order" => 13,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => false,
	"Update" => false
);

Class ClickTrail extends Report {
	
	function Settings() {
		$this->help = "";

		//dump($this->options);
		//exit();
		if(!empty($this->options)) {
			
			# this creates our search conditions array
			foreach($this->options as $option => $val) {
				if(substr($option, 0, 5) == 'field') {
					$condition_options['field'][] = $val;
				} elseif(substr($option, 0, 9) == 'condition') {
					$condition_options['condition'][] = $val;
				} elseif(substr($option, 0, 6) == 'cvalue') {
					$condition_options['cvalue'][] = $val;
				}
			}
			if (!empty($condition_options)) {
				$this->conditions = $condition_options;
			}
			
			# this creates a string of conditions to show to the user
			if(!empty($condition_options['condition'])) {
				for($c = 0; $c <= (count($condition_options['condition']) - 1); $c++) {
					$condition_options['cvalue'][$c] = urldecode($condition_options['cvalue'][$c]);
					if(strlen($condition_options['cvalue'][$c]) >= 50) {
						$cvalue_val = substr($condition_options['cvalue'][$c], 0, 23)."...".substr($condition_options['cvalue'][$c], -23);
					} else {
						$cvalue_val = $condition_options['cvalue'][$c];
					}
					if($c == 0) {
						$this->addlabel .= @$condition_options['field'][$c]." ".@$condition_options['condition'][$c]." ".@$cvalue_val;
					} else {
						$this->addlabel .= !empty($this->andor) ? " {$this->andor} " : " AND ";
						$this->addlabel .= @$condition_options['field'][$c]." ".@$condition_options['condition'][$c]." ".@$cvalue_val;
					}
				}
			}
		}

		if (!isset($this->dhistory)) { $this->dhistory="daterange"; }
		if (!isset($this->andor)) { $this->andor = "AND"; } else { $this->andor = @$this->andor; }
		if (!isset($this->limit)) { $this->limit = "100"; } else { $this->limit = @$this->limit; }
		if (isset($this->submit)) { if (($this->submit == "Report") && (isset($this->filter_top))) { $this->filter = $_GET["filter_top"]; } }

		if(!empty($this->visitorid)){
			$this->addlabel .= " | visitor-id: {$this->visitorid}";
		}
	}

	function GetMatchingItemID($field,$condition,$cvalue) {
		
		$table = getTable($field);
		if ($table ===false) {
			return false;
		}
		$tfield = getField($table);
		if ($tfield ===false) {
			return false;
		}		
		return getID($cvalue,$table);
	}
	
	function DisplayReport() {
		global $db,$gi;
		
		$this->displayReportButtons = false;
		$use_merge_table=false;
		
		if ( !empty($this->visitorid) && @$this->cvalue1 == "") {
			$this->cvalue1 = $this->visitorid;
			$this->condition1 = "is";
			$this->field1 = "visitorid";
		} else if (!empty($this->ip) && (isset($this->cvalue1) && empty($this->cvalue1))) {
		   $this->cvalue1 = $this->ip;
		   $this->condition1 = "is";
		   $this->field1 = "ipnumber";
		}
		
		if (isset($this->cvalue1)&& $this->cvalue1 !="") {
			$i=1;
			$andor=@$this->andor;
			while ($i < 25) {
				$cvalue="";
				$cvalue=@$this->{'cvalue'.$i};
				if ($cvalue!="") {
					$field=@$this->{'field'.$i};
					if ($field=="") {
						echoWarning(_UNKNOWN . " type: ".$cvalue."<br>"._PLEASE_SELECT_FIELD);
						return false;   
					}
					
					$condition=@$this->{'condition'.$i};
					if ($field=="keywords") {
						//$cvalue=urlencode($cvalue);
					} else {
						// var_dump($cvalue);
						$cvalue=urldecode($cvalue);
						// var_dump($cvalue);
					}
					if ($field=="refparams" || $field=="params") {
						$cvalue=str_replace(" ","+",$cvalue);
					}
					if ($field=="crawl" && $cvalue != 0) {						
							$use_merge_table=true;						
					}
					
					//make sql string
					if ($condition=="contains") {
						$op = "$field LIKE ".$db->Quote("%{$cvalue}%");
					} else if ($condition=="nocontain") {
						$op = "$field NOT LIKE ".$db->Quote("%{$cvalue}%");
					} else if ($condition=="start") {
						$op = "$field LIKE ".$db->Quote("{$cvalue}%");
					} else if ($condition=="end") {
						$op = "$field LIKE ".$db->Quote("%{$cvalue}");
					} else if ($condition=="is") {
						$iid = $this->GetMatchingItemID($field,$condition,$cvalue);
						if ($field=="ipnumber" || $field=="useragent" || $iid === false) {
							$op = "$field =".$db->Quote("$cvalue");
						} else {
							$op = "$field =".$db->Quote($this->GetMatchingItemID($field,$condition,$cvalue));
						}
					} else if ($condition=="isnot") {
						$iid = $this->GetMatchingItemID($field,$condition,$cvalue);
						if ($field=="ipnumber" || $field=="useragent" || $iid === false) {
							$op = "$field !=".$db->Quote("$cvalue");
						} else {
							$op = "$field !=".$db->Quote($this->GetMatchingItemID($field,$condition,$cvalue));
						}
					}
					
					if ($i==1) {
						$sqlstring=" {$op}";
					} else {
						$sqlstring.=" {$andor} {$op}";
					}
					//echoWarning($sqlstring);
				}
				$i++;
			}
			$filter=1;
		} 

		//we need to rewrite the sqlstring to the new style tables
		$joincond="";
		$addtables="";
		if (@$sqlstring) {
			if (strpos("  ".$sqlstring," url ")!=FALSE) {
				$sqlstring=str_replace("url =","a.url=",$sqlstring);
				$sqlstring=str_replace("url !=","a.url!=",$sqlstring);
				$sqlstring=str_replace("url LIKE","u.url LIKE",$sqlstring);
				$sqlstring=str_replace("url NOT LIKE","u.url NOT LIKE",$sqlstring); 
				$addtables=",{$this->profile->tablename_urls} as u";
				$joincond="and a.url=u.id";
			}

			if (strpos("  ".$sqlstring," params ")!=FALSE) {
				$sqlstring=str_replace("params =","a.params=",$sqlstring);
				$sqlstring=str_replace("params !=","a.params!=",$sqlstring);
				$sqlstring=str_replace("params LIKE","up.params LIKE",$sqlstring);
				$sqlstring=str_replace("params NOT LIKE","up.params NOT LIKE",$sqlstring);
				$addtables.=",{$this->profile->tablename_urlparams} as up";
				$joincond.=" and a.params=up.id";
			}

			if (strpos("  ".$sqlstring," referrer ")!=FALSE) {
				$sqlstring=str_replace("referrer =","a.referrer=",$sqlstring);
				$sqlstring=str_replace("referrer !=","a.referrer!=",$sqlstring);
				$sqlstring=str_replace("referrer LIKE","r.referrer LIKE",$sqlstring);
				$sqlstring=str_replace("referrer NOT LIKE","r.referrer NOT LIKE",$sqlstring);
				$addtables.=",{$this->profile->tablename_referrers} as r";
				$joincond.=" and a.referrer=r.id";
			}

			if (strpos("  ".$sqlstring," refparams ")!=FALSE) {
				$sqlstring=str_replace("refparams =","a.refparams=",$sqlstring);
				$sqlstring=str_replace("refparams !=","a.refparams!=",$sqlstring);
				$sqlstring=str_replace("refparams LIKE","rp.params LIKE",$sqlstring);
				$sqlstring=str_replace("refparams NOT LIKE","rp.params NOT LIKE",$sqlstring);
				$addtables.=",{$this->profile->tablename_refparams} as rp";
				$joincond.=" and a.refparams=rp.id";
			}

			if (strpos("  ".$sqlstring," keywords ")!=FALSE) {
				$sqlstring=str_replace("keywords =","a.keywords=",$sqlstring);
				$sqlstring=str_replace("keywords !=","a.keywords!=",$sqlstring);
				$sqlstring=str_replace("keywords LIKE","k.keywords LIKE",$sqlstring);
				$sqlstring=str_replace("keywords NOT LIKE","k.keywords NOT LIKE",$sqlstring);
				$addtables.=",{$this->profile->tablename_keywords} as k";
				$joincond.=" and a.keywords=k.id";
			}
			
			if (strpos("  ".$sqlstring," ipnumber ")!=FALSE) {
				$sqlstring=str_replace("ipnumber =","v.ipnumber=",$sqlstring);
				$sqlstring=str_replace("ipnumber !=","v.ipnumber!=",$sqlstring);
				$sqlstring=str_replace("ipnumber LIKE","v.ipnumber LIKE",$sqlstring);
				$sqlstring=str_replace("ipnumber NOT LIKE","v.ipnumber NOT LIKE",$sqlstring);
			}
			
			if (strpos("  ".$sqlstring," useragent ")!=FALSE) {
				$sqlstring=str_replace("useragent =","b.name=",$sqlstring);
				$sqlstring=str_replace("useragent !=","b.name!=",$sqlstring);
				$sqlstring=str_replace("useragent LIKE","b.name LIKE",$sqlstring);
				$sqlstring=str_replace("useragent NOT LIKE","b.name NOT LIKE",$sqlstring);
			}

			if (strpos("  ".$sqlstring," crawl ")!=FALSE) {
				$sqlstring=str_replace("crawl =","a.crawl=",$sqlstring);
				$sqlstring=str_replace("crawl !=","a.crawl!=",$sqlstring);
				$sqlstring=str_replace("crawl LIKE","a.crawl LIKE",$sqlstring);
				$sqlstring=str_replace("crawl NOT LIKE","a.crawl NOT LIKE",$sqlstring);
			}

		}
		
		$this->ReportHeader();
		
		if (@$filter) {
			echo "<table cellpadding=2><tr><td valign=top>\n";
			if (@$sqlstring!="") {
				if ($use_merge_table == true) {
					$use_table = $this->profile->tablename_merge;
				} else {
					$use_table = $this->profile->tablename;
				}
				$query = "SELECT v.customlabel AS customlabel,v.id AS id,v.visitorid AS visitorid, MAX(v.ipnumber) AS ipnumber, count(*) AS hits, FROM_UNIXTIME(MIN(a.timestamp), '%d-%b-%Y %a') AS day, MAX(a.country) AS country, CONCAT(b.name, ' ', b.version) AS useragent FROM {$use_table} as a, {$this->profile->tablename_useragents} as b, {$this->profile->tablename_visitorids} as v {$addtables} WHERE a.visitorid = v.id AND a.useragentid = b.id AND a.timestamp BETWEEN ". $db->quote($this->from) ." AND ". $db->quote($this->to) ." {$joincond} AND ({$sqlstring}) GROUP BY a.visitorid ORDER BY a.timestamp DESC limit {$this->limit}";
				//echoWarning($query);
				$query = subsetDataToSourceID($query,$this->trafficsource);
				
				$logfile = $db->Execute($query);
			}
			$i=0;
			echo "<div style='width:100%; left:0; z-index:55; font-size:11px; border: 1px solid #DCDBDB; background:#ffffff; top:0px; margin-bottom:10px; height:32px;'>";
			
			# maak effe een random id Jonguh!
			$md5_time = md5(time());
			$menu_id = 'dg'.$md5_time.rand(1,1000);

			echo "<a id='$menu_id' class='openvisitorlist'>"._VISITOR_LIST."<img src='images/arrow_down_darkgrey_square.png' style='float:right;margin:3px 0px 5px 10px;'></a>";
			echo "</div>";
			?>
			<script type="text/javascript">
				$(document).ready( function(){
					$("#<?php echo $menu_id;?>").click( function(){
						if($("#<?php echo $menu_id;?>_visitorlist").css("display") == "none"){
							$("#<?php echo $menu_id;?>_visitorlist").css("display","block");
						} else {
							$("#<?php echo $menu_id;?>_visitorlist").css("display","none");
						}
					});
					$(".reporttable").click( function(){
						$(".visitorlist").css("display","none");
					});
				});						
			</script>
			<?php
			echo "<div id='{$menu_id}_visitorlist' class='visitorlist' style='position:absolute; background: none repeat scroll 0 0 #FFFFFF; border: 1px solid #DCDBDB; display:none; margin:-11px 0 0 0;'>";
			echo "<table cellpadding=3 width=100% cellspacing=0 border=0 align=center class=smallborder>\n";
			// echo "<tr><td colspan=2 width=200><img src=\"images/icons/user.gif\" width=16 height=16 align=left> <b>"._VISITOR_LIST.":<br></b></td></tr>\n";
			while ($loglines = $logfile->FetchRow()) {
				// If a visitor ID wasn't passed in, then select the first one as the one we want to highlight.
				$this->customlabel = $loglines["customlabel"];
				$this->custom_id = $loglines["id"];
				if (!@$this->visitorid) {
					$this->visitorid = $loglines["visitorid"];
				}
					$s = "";
					if ($loglines["visitorid"] == $this->visitorid) {
						 $s = "bgcolor=#CCFFCC";
					}
					if ($loglines["country"]) {
						$cparts=explode(", ", $loglines["country"]);
						$ccode = strtolower(((count($cparts) > 1) && ($cparts[1] > "")) ? $cparts[1] : $cparts[0]);
					} else {
						$ccode = "";
					}
					if (isset($gi)) {
						$area=geoip_record_by_addr($gi, $loglines["ipnumber"]);
						if ($area) {
							$city=$area->country_name .", " . $area->city;
						} else {
							$city = _UNKNOWN_CITY;
						}
						if(!empty($ccode)) {
							$image = "<img hspace=3 width=14  height=11 src=\"images/flags/$ccode.png\" border=0>";
						} else {
							$image = "";
						}
					} else {
						$image = "";
						$city = "";
						$area = "";
					}
					echo "<tr><td $s>". $image ."</td>";
					echo "<td title=\"".$loglines["useragent"]." $city\" $s>";
					
					$additional_params = "";
					foreach($this->options as $optionkey => $optionvalue) {
						if($optionkey == "visitorid" || $optionkey == "conf") { continue; }
						$additional_params .= "&".urlencode($optionkey)."=".urlencode($optionvalue);
					}
					
					$additional_params .= "&"."visitorid"."=".urlencode($loglines["visitorid"]);
					echo "<span><a class='navlinks actionmenu_activator' href=\"#\" onclick=\"popupMenu(event, '".$loglines["ipnumber"].";".$loglines["visitorid"]."','clicktrailipnumber','{$additional_params}')\">".$loglines["ipnumber"]."</a></span><br>\n";
					
					echo "<font color=gray size=1>".$loglines["day"]."</font><br>";
					if (@$this->resolveon != 1) {
						if(empty($this->customlabel)){
							echo "<div id=\"ip{$i}\" style=\"font-size:10px;color:gray;\">"._RESOLVING."...</div>\n";
							$which = "{$menu_id}_visitorlist #ip$i";
							echo "<script language=\"javascript\" type=\"text/javascript\"> StoreResolveIP('".$loglines["ipnumber"]."', '$which',".$this->custom_id.",'".$this->profile->profilename.	"'); </script>\n";  
						}else{
							echo "<div id=\"ip{$i}\" style=\"font-size:10px;color:gray;\">".$this->customlabel."</div>\n";
						}
					} else {
					   echo "<font color=gray size=1>".$loglines["ipnumber"]."</font>";
					}
					
					echo "</td></tr>\n";
				$i++;
			}
			echo "</table><P><div align=center>$i "._VISITORS_FOUND.".</div>";
			echo "</div>";
			
			if ($i==0) {
				$stop=1;
			}
		} 	

		if (!empty($this->visitorid) || !empty($this->ip)) {
			$lasttimestamp = 0;
			if ($this->visitorid) {
				$selector = "v.visitorid = ". $db->quote($this->visitorid);
			} else {
				$selector = "v.ipnumber = ". $db->quote($this->ip) ."";
			}
			
			if (@$this->dhistory == "daterange") {
				$selector .= " and a.timestamp >=". $db->quote($this->from) ." and a.timestamp <=". $db->quote($this->to);
			}
			
			$query = $db->Execute("SELECT a.timestamp, v.ipnumber, u.url, up.params, r.referrer, rp.params AS refparams, b.name AS useragent, v.visitorid, a.status, a.crawl, b.useragent as ua FROM ".$this->profile->tablename_merge." AS a, {$this->profile->tablename_useragents} AS b, {$this->profile->tablename_urls} AS u, {$this->profile->tablename_urlparams} AS up, {$this->profile->tablename_referrers} AS r,{$this->profile->tablename_refparams} AS rp,{$this->profile->tablename_visitorids} AS v WHERE a.visitorid = v.id AND {$selector} AND a.url = u.id AND a.params = up.id AND a.referrer = r.id AND a.refparams = rp.id and b.id = a.useragentid ORDER BY a.timestamp");
			
			$i=0;
			$gr=1;
			while ($loglines = $query->FetchRow()) {
				# Put in the header row...
				if ($i==0) {
					$this->ip= $loglines['ipnumber']; 
					if (isset($gi)) {
						$area=geoip_record_by_addr($gi, $loglines["ipnumber"]);
						if ($area) {
							$city=$area->country_name .", " . $area->city;
						} else {
							$city = _UNKNOWN_CITY;
						}
					}
					?>
					<div style="postion:absolute; margin:-35px 0 15px 110px;">

					<?php
						// dump($loglines['ua']);
						// dump($loglines['visitorid']);
					?>
					
					Click-Trail Analysis for <?php echo "<a target=_blank title="._RIPE_WHOIS_LOOKUP." href=\"http://www.db.ripe.net/whois?form_type=simple&full_query_string=&searchtext={$this->ip}&do_search=Search\">{$this->ip}</a> ".$loglines["useragent"] . ", ".@$city; if ($loglines["crawl"]!=0) { echo " [Bot/Crawler]"; } 
					?>

					</div>
					
					<table class="reporttable" cellspacing=0 cellpadding=4 border=0 style="width:100%;">
					<?php 
					echo "<tr bgcolor=silver><td><b>"._LOGTIME."</b></td><td><b>"._REFERRING_PAGE."</b></td><td></td><td><b>"._REQUESTED_PAGE."</b></td><td><b>"._STATUS."</b></td><td><b>"._TIME_SPENT."</b></td></tr>";
				}
				
				$ipnumber=$loglines["ipnumber"];
				$logtimestamp=$loglines["timestamp"];
				$logtime=date("D, d-m-Y H:i:s",$logtimestamp);
				$geturl=$loglines["url"];
				if ($loglines["params"]!="") {
					$geturl=$loglines["url"].$loglines["params"];
				}
				$refurl=$loglines["referrer"];
				if ($loglines["refparams"]!="?") {
					$refurl=$loglines["referrer"].$loglines["refparams"];
				}
				if (strlen($geturl) > 35) {
					$geturln=substr($geturl,0,35) . "...";
				} else {
					$geturln=$geturl;
				}
				if (strlen($refurl) > 35) {
					$refurln=substr($refurl,0,35) . "...";
				} else {
					$refurln=$refurl;
				}
				$timespent=$logtimestamp-$lasttimestamp;
				$min=number_format(($timespent/60),1);
				if (($logtimestamp-$lasttimestamp) > 72000) {
					$logtime="<b>$logtime</b>";
					$newday=1;
				} else {
					$newday=0;
				}

				$lasttimestamp=$logtimestamp;

				if ($newday==0) {
					echo "<td>$timespent sec ($min min)</td></tr>";
				} else {
					if ($i!=0){
					echo "<td><font color=Red>"._USER_LEFT."</font></td></tr>";
					}
				}			

				if (empty($this->profile->confdomain) || strpos($refurl, $this->profile->confdomain)==FALSE) {
					if (strpos($refurl, "G]")!=FALSE) {
						$gsyn=substr($refurl,3);
						$refurln=$gsyn;
						$gsyn="<img src=images/google.png border=0 alt='Via Google Ads: $refurl'>&nbsp;";
						$refurl=$refurln;
					} else {
						$gsyn="";
					}
					$refurln="$gsyn<a class=greenlink2 href=\"\" onclick=\"popupMenu(event, '".urlencode($refurl)."', 'clicktrailreferrer');\">$refurln</a>";
					
				}
				if ($gr==3) {
					$gr=1;
					$bgcol="bgcolor=#F8F8F8";
				} else {
					$gr++;
					$bgcol="";
				}
				# this is to make the searched element stick out, but it ned work (all the other cvalues should be check, maybe load in array and do array search)
				if ($geturl==@$_REQUEST["cvalue1"] || $refurl==@$_REQUEST["cvalue1"]) {
					$bgcol="bgcolor=yellow";
				}
				echo "<tr $bgcol class=small><td>$logtime</td><td title=\"$refurl\"><font size=1>$refurln</font><br><div id=\"ref$i\" class=actionmenu style=\"display:none;\"></div></td><td><img src=images/icons/link_go.gif width=16 height=16></td><td title=\"$geturl\"><a href=\"\" onclick=\"popupMenu(event, '".urlencode($geturl)."', 'clicktrailpage');\">$geturln</a><br></div></td><td>".$loglines['status']."</td>";
				$i++;
			}
			echo "<td><font color=Red>"._USER_LEFT."</font></td></tr>";

			echo "</table>";
			$stop=1;
		}		
					
		if (!@$stop) {
		?>
		<table cellpadding=8 border=0 width=100%>
		<tr>
		  <td class=smallborder valign=top width=150><img src="images/icons/user.gif" width=16 height=16 align=left> <b><?php echo _VISITOR_LIST?><br></b><?php echo _NONE?> <?php echo _SELECTED?></td>
			<td valign=top>
			<table cellspacing=0 cellpadding=0 border=0 width=100%>
			<tr><td valign=top>
			<h3 style="margin-top:0px;"><?php echo _CLICK_TRAIL_ANALYSIS?> </h3>
			
			<?php echo _EXPLAIN_CLICK_TRAILS?>
			
			<div style="margin-left:15px;background:#CCCCCC;padding:10px;"><?php echo _TIP?></div>
			
			
			</td></tr></table>
			
		</td>
		<td valign=top width=250 style='border-style : solid; border-width:0px; border-left-width : thin;'>
		<?php echo _LIST_SEARCHABLE_FIELDS."<br/><br/>"?>
		   <?php echo _EXPLAIN?>
		</td>
		</tr>
		</table>

		<?php
		}
		# Removed because it errors when openend with most active visitors in PDF
		// if (file_exists("components/geoip/GeoLiteCity.dat")) { geoip_close($gi); }
		?>
		</td>
		</tr>
		</table>
		<?php
	}
	
	function DisplayCustomForm() {
		$this->options = $_REQUEST;
		
		echo "<input type='hidden' name='ip' id='ip' value=\"".@$this->ip."\"> ";
		echo "<input type='hidden' name='visitorid' value=\"".@$this->visitorid."\"> ";
		
		$condition_options = array();
		foreach($this->options as $option => $val) {
			if(substr($option, 0, 5) == 'field') {
				$condition_options['field'][] = $val;
			} elseif(substr($option, 0, 9) == 'condition') {
				$condition_options['condition'][] = $val;
			} elseif(substr($option, 0, 6) == 'cvalue') {
				$condition_options['cvalue'][] = $val;
			}
		}
		
		echo "<span style=\"margin-top:8px;\"><b>"._SEARCH.":</b></span>";
		
		if(isset($condition_options['condition']) && count($condition_options['condition']) > 1) {
			echo "<div class='andor_selector'>";
				echo "<span style='float: left; margin-right: 20px;'>Mode: </span>";
				if(empty($this->andor) || $this->andor == "AND") {
					echo "<label style='float: left;'>AND</label><input type='radio' class='noTextInput' style='width: 25px; float: left;' name='andor' value='AND' checked />";
				} else {
					echo "<label style='float: left;'>AND</label><input type='radio' class='noTextInput' style='width: 25px; float: left;' name='andor' value='AND' />";
				}
				if(!empty($this->andor) && $this->andor == "OR") {
					echo "<label style='float: left;'>OR</label><input type='radio' class='noTextInput' style='width: 25px; float: left;' name='andor' value='OR' checked />";
				} else {
					echo "<label style='float: left;'>OR</label><input type='radio' class='noTextInput' style='width: 25px; float: left;' name='andor' value='OR' />";
				}
			echo "</div>";
			echo "<div class='clear'></div>";
		}
		
		echo "<div class='condition_descriptor'>("._FIELD.", "._CONDITION.", "._VALUE.")</div>";
		
		$form_id = md5(time());
		$form = "<script type='text/javascript'>plusMinusForm('{$form_id}', 'field', 'condition', 'cvalue');</script>";
		$form .= "<div id='{$form_id}'>";
			if(count($condition_options) == 0) {
				$fieldselect = LoadFieldSelectFull();
				$fieldselect = SelectField($fieldselect,'field1');
				
				$form .= "<div class='conditions_row'>";
					$form .= "<select style='width: 60px;' src='field' class='report_option_field' id='field1' name='field1'>".$fieldselect."</select>";
					$form .= "<select style='width: 60px;' src='condition' class='report_option_field' id='condition1' name='condition1'>";
					$form .= "	<option value=\"".@$this->condition1."\" selected>".@$this->condition1;
					$form .= "	<option value='is'>"._SELECT_IS."</option>";
					$form .= "	<option value='contains'>"._CONTAINS."</option>";
					$form .= "	<option value='nocontain'>"._NOT_CONTAINS."</option>";
					$form .= "	<option value='start'>"._STARTS_WITH."</option>";
					$form .= "	<option value='end'>"._ENDS_WITH."</option>";
					$form .= "	<option value='isnot'>"._SELECT_IS_NOT."</option>";
					$form .= "</select>";
					$form .= "<input style='width: 75px;' class='report_option_field qbuilderhelp' src='cvalue' rel='1' name='cvalue1' id='cvalue1' value='".@$this->cvalue1."' autocomplete='off'>";
					$form .= "<button style='width: 25px; height: 20px; margin: 0; padding: 0;' type='button' class='plus_btn noOption'> &plus; </button><button style='width: 25px; height: 20px; margin: 0; padding: 0;' type='button' class='min_btn noOption' disabled='disabled'> &minus; </button>";
				$form .= "</div>";
			} else {
				for($c = 0; $c < count($condition_options['condition']); $c++) {
					$fieldselect = LoadFieldSelectFull();
					$fieldselect = SelectField($fieldselect,$condition_options['field'][$c]);
					
					$form .= "<div class='conditions_row'>";
						$form .= "<select style='width: 60px;' src='field' class='report_option_field' id='field".($c + 1)."' name='field".($c + 1)."'>".$fieldselect."</select>";
						$form .= "<select style='width: 60px;' src='condition' class='report_option_field' id='condition".($c + 1)."' name='condition".($c + 1)."'>";
						$form .= "	<option value=\"".@$condition_options['condition'][$c]."\" selected>".@$condition_options['condition'][$c];
						$form .= "	<option value='is'>"._SELECT_IS."</option>";
						$form .= "	<option value='contains'>"._CONTAINS."</option>";
						$form .= "	<option value='nocontain'>"._NOT_CONTAINS."</option>";
						$form .= "	<option value='start'>"._STARTS_WITH."</option>";
						$form .= "	<option value='end'>"._ENDS_WITH."</option>";
						$form .= "	<option value='isnot'>"._SELECT_IS_NOT."</option>";
						$form .= "</select>";
						$form .= "<input style='width: 75px;' src='cvalue' class='report_option_field qbuilderhelp' rel='".($c + 1)."' name='cvalue".($c + 1)."' id='cvalue".($c + 1)."' value='".@$condition_options['cvalue'][$c]."' autocomplete='off'>";
						$form .= "<button style='width: 25px; height: 20px; margin: 0; padding: 0;' type='button' class='plus_btn noOption'> &plus; </button><button style='width: 25px; height: 20px; margin: 0; padding: 0;' type='button' class='min_btn noOption'> &minus; </button>";
					$form .= "</div>";
				}
			}
		$form .= "</div>";
		echo $form;
		echo "<br/>";
		
		echo "<label>"._FILTERS.": </label>";
		echo printTrafficSourceSelect();
		
		echo "<br/>";
		echo "<br/>";

		echo "<label for='resolveon'>"._RESOLVE_IP."   :</label>";
		echo "<select class='report_option_field' id='resolveon' name='resolveon'>";
			echo "<option value=\"1\" ";
				if (@$this->resolveon == "1") { echo "selected"; }
			echo ">"._ANSWER_NO."</option>";
			echo "<option value=\"0\" ";
				if (@$this->resolveon != "1") { echo "selected"; }
			echo ">"._ANSWER_YES."</option>";
		echo "</select>";
			
		echo "<br/>";
		echo "<br/>";
		
		echo "<label for='dhistory'>"._DISPLAY.":</label>";
		echo "<select class='report_option_field' id='dhistory' name='dhistory'>";
			echo "<option value='all'>"._FULL_VISITOR_HISTORY."</option>";
			echo "<option value='daterange'";
				if (@$this->dhistory == "daterange") { echo "selected"; }
			echo ">"._SHOW_HISTORY_IN_DATE_RANGE."</option>";
		echo "</select>";
	}
	
	function DefineReport() {
		$this->DisplayReport();
	}
	
	function UpdateStats() {
		return false;
	}
}