<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report lets you make split test of your pages and gives you an overview of wich one works the best.
*/
$reports["_CONTENT_BASED_SPLIT_TEST"] = Array(
	"ClassName" => "ContentBasedSplitTest", 
	"Category" => "_TEST_CENTER", 
	"icon" => "images/icons/32x32/contentbasedsplittest.png",
	"Options" => "daterangeField,profileselector,roadto",
	"Filename" => "content_based_split_test",
	"Distribution" => "Legacy",
	"Order" => 1,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => false,
	"Update" => false
);

class ContentBasedSplitTest extends Report {

	function Settings() {
		$this->help = "";		
		$this->displayReportButtons = false;
	}
		
	function DisplayCustomForm(){
		global $db, $session;
		//split test functions
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
		$this->Create_tables();
		$q = $db->Execute("select id,testname from {$this->sptablename} WHERE status=1");
		
		echo "<label for='testid'>"._CHOOSE_SPLIT_TEST."</label>";
		echo "<select id='testid' class='report_option_field'>";
		
		if($q == false){
			echo "<option value=''>"._NONE."</option>";
		} else {
			while($data = $q->FetchRow()){
				if(isset($this->testid) && $this->testid == $data["id"]){
					$selected = "selected='selected'";
				}else{
					$selected = "";
				}
				echo "<option value='{$data["id"]}' $selected>{$data["testname"]}</option>";
			}
		}
		echo "</select>";
		
		if($session->canEditProfiles()) {
			echo "<a href='definereport.php?conf={$this->conf}&testcenter=create&labels=_CONTENT_BASED_SPLIT_TEST' class='optionlink open_iframe_window'>". _CREATE_EDIT_PHP_SPLIT_TEST ."</a>";
		}
	}
	function DisplayReport(){
		global $db, $niceto, $nicefrom;
		
		if(empty($this->roadto)){ 
			$this->ReportHeader(); echoNotice("Please choose a KPI from the report settings.","margin:5px;"); return false; 
		}
		
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
		if(empty($this->roadto)){ $this->ReportHeader(); echoNotice(_CHOOSE_KPI_FROM_SETTINGS,"margin:5px;"); return false; }
		$target= $this->roadto;
		
		if(!isset($this->testid)){
			echoWarning(_NO_SPLIT_TEST,"margin:5px;");
			return false;
		}
		
		//get some info
		$q = $db->Execute("select * from {$this->sptablename} where id={$this->testid}");
		$data=$q->FetchRow();
		$testname=$data['testname'];
		$testurl=$data['testurl'];
		$testdesc=$data['testdesc'];
		$splitperc=$data['splitperc'];
		$created=date("Y-m-d",$data['created']);

		//1. Select uniques from page a
		$q = $db->Execute("select count(distinct visitorid) as users from {$this->sptablename_results} where timestamp >=". $db->quote($this->from) ." and timestamp <=". $db->quote($this->to) ." and testid={$this->testid} and page='A'");
		$pagea=$q->FetchRow() or die ($db->ErrorMsg());

		//2. Select uniques from page b
		$q = $db->Execute("select count(distinct visitorid) as users from {$this->sptablename_results} where timestamp >=". $db->quote($this->from) ." and timestamp <=". $db->quote($this->to) ." and testid={$this->testid} and page='B'");
		$pageb=$q->FetchRow() or die ($db->ErrorMsg());

		if ($pagea[0]==0 && $pageb[0]==0) {
			$this->addlabel = _TEST_RESULT.": $testname";
			$this->ReportHeader();
			$q = $db->Execute("select max(timestamp) from {$this->sptablename_results} where testid={$this->testid}");
			$lasttime=$q->FetchRow() or die ($db->ErrorMsg());

			echo "<b>"._NO_SPLIT_TEST_COLLECTED." '$testname' "._DURING_DATE_RANGE.".</b><br>";
			if ($lasttime[0]!=0) {
				echo ""._LAST_ACTIVITY_ADDED_ON.date("Y-m-d, H:i:s",$lasttime[0])."<br>";   
			}
			echo "<br>"._MAKE_SURE_TEST_CODE_IS_PUBLISHED.".<br><br>";
			echo ""._DESCRIPTION.": $testdesc<br>"._TRAFFIC_SPLIT_PERCENT." $splitperc % &nbsp;&nbsp;&nbsp; "._TEST_CREATED_ON." $created<br>"._REPORT." "._DATE_RANGE.": "._REPORT." $nicefrom "._TO." {$niceto}<br>"._SELECTED." "._TARGET.": $target"; 
			return;   
		}

		# 1. Select Converted uniques from page a
		$q = $db->Execute("select count(distinct sp.visitorid) as users from {$this->sptablename_results} as sp, {$this->profile->tablename} as t, {$this->profile->tablename_urls} as u,{$this->profile->tablename_visitorids} as vi where t.timestamp >=". $db->quote($this->from) ." and t.timestamp <=". $db->quote($this->to) ." and sp.timestamp < t.timestamp and t.visitorid=vi.id and vi.visitorid=sp.visitorid and sp.page='A' and sp.testid={$this->testid} and t.url=u.id and u.url='$target' and (t.status=200 or t.status=302)");
		$converta=$q->FetchRow() or die ($db->ErrorMsg());
		
		# 1. Select Converted uniques from page b
		$q = $db->Execute("select count(distinct sp.visitorid) as users from {$this->sptablename_results} as sp, {$this->profile->tablename} as t, {$this->profile->tablename_urls} as u,{$this->profile->tablename_visitorids} as vi where t.timestamp >=". $db->quote($this->from) ." and t.timestamp <=". $db->quote($this->to) ." and sp.timestamp < t.timestamp and t.visitorid=vi.id and vi.visitorid=sp.visitorid and sp.page='B' and sp.testid={$this->testid}  and t.url=u.id and u.url='$target' and (t.status=200 or t.status=302)");
		$convertb=$q->FetchRow() or die ($db->ErrorMsg());

		
		# calculate the rest
		$cra=@number_format((($converta[0]/$pagea[0])*100),2);
		$crb=@number_format((($convertb[0]/$pageb[0])*100),2);

		$this->addlabel="";
		$this->ReportHeader();
		
		echo "<div style='width:550px;margin: 0 auto;font-size:14px;line-height:20px;padding: 10px 0 10px 0;'>";
		echo "A/B Split Test Content: <strong>$testname</strong><br />";
		echo "Key Performance Indicator: <strong>{$this->roadto}</strong><br />";
		echo "</div>";		
		
		$this->CompareMeter("Page Visitors:", $pagea[0], $pageb[0], _PAGE." A ({$pagea[0]})", _PAGE." B ({$pageb[0]})");
		$this->CompareMeter("Target Visitors:", $converta[0], $convertb[0]);
		
		$this->CompareMeter(_CONVERSION_RATE, $cra , $crb, "{$cra}%", "{$crb}%");
		
		$infoa['target_indirect_total']=$converta[0];
		$infoa['page_total']=$pagea[0];
		$infob['target_indirect_total']=$convertb[0];
		$infob['page_total']=$pageb[0];
		echo "<br>";
		$this->DisplayWinner($infoa,$infob,_PAGE);
		
		echo "<div style='margin:0 auto;width:550px;'><table cellpadding=4 cellspacing=0 width='100%'>";		

		echo "<tr><td colspan=4>"._OTHER_SPLIT_INFO."</td></tr>";
	
		echo "<tr><td>"._BOUNCE_RATE." "._PAGE." A</td><td>". $this->SplitTestBounceRateOfPageVariation("A")."</td>";
		echo "<td>"._BOUNCE_RATE." "._PAGE." B</td><td>". $this->SplitTestBounceRateOfPageVariation("B")."</td></tr>";
		
		
		
		echo "<tr><td colspan=2>"._TIME_SPENT." "._PAGE." A<br>".$this->SplitTestTimeOnPage("A")."</td>";
		echo "<td colspan=2>"._TIME_SPENT." "._PAGE." B<br>".$this->SplitTestTimeOnPage("B")."</td></tr>";

		echo "</table></div>";
		
	}
	function SplitTestTimeOnPage($page) {
		global $db;
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
		/**
		* @desc This function will calculate grouped averages for time spent on a particular page, 
		* not counting people who bounced (had no further requests)
		* @returns $output that contains a html table
		*/    
		$db->Execute("drop temporary table if exists {$this->profile->tablename}_goodtimes"); $db->Execute("drop table if exists {$this->profile->tablename}_pagetime");
		
		// first find the visitorid and timestamp of the request we're interested in.   
		$query="CREATE TEMPORARY TABLE {$this->profile->tablename}_goodtimes ";
		$query.="SELECT vi.id as visitorid,min(timestamp) as timestamp FROM {$this->sptablename_results} as sp, {$this->profile->tablename_visitorids} as vi ";
		$query.="WHERE testid=". $db->quote($this->testid) ." AND (timestamp >=". $db->quote($this->from) ." and timestamp <=". $db->quote($this->to) .") ";
		$query.="AND page='$page' AND sp.visitorid=vi.visitorid ";
		$query.="GROUP BY visitorid";   
		
		// get the visitorid and timestamp of the request that came after the one we're interested in
		// and create a tempoary table to hold the difference between the two timestamps
		$query2 ="CREATE TABLE {$this->profile->tablename}_pagetime ";  
		$query2.="SELECT a.visitorid, (min(a.timestamp)-b.timestamp) as length from {$this->profile->tablename} as a, {$this->profile->tablename}_goodtimes as b ";
		$query2.="WHERE b.visitorid=a.visitorid and a.timestamp > b.timestamp and a.timestamp <= ". $db->quote($this->to) ." ";
		$query2.="GROUP BY a.visitorid";  
		
		$db->Execute($query);
		$db->Execute($query2);
		
		// get a meaningful breakdown of the time spent
		$range = $db->Execute("select count(*) as visitors from {$this->profile->tablename}_pagetime");
		$range_data = $range->FetchRow();
		$total_visitors=$range_data['visitors'];
		$query = "select \"0 to 10 secs            \", ((count(*)*1.0)/$total_visitors*100),count(*), avg(length)/60, \"1\" as ord from {$this->profile->tablename}_pagetime where length >=0 and length <=10 union ";
		$query.= "select \"10 to 60 secs            \", ((count(*)*1.0)/$total_visitors*100),count(*), avg(length)/60, \"2\" as ord from {$this->profile->tablename}_pagetime where length >=10 and length <=60 union ";
		$query.= "select \"1 to 5 mins            \", ((count(*)*1.0)/$total_visitors*100),count(*), avg(length)/60, \"3\" as ord from {$this->profile->tablename}_pagetime where length >=60 and length <=300 union ";
		$query.= "select \"5 to 15 mins            \", ((count(*)*1.0)/$total_visitors*100),count(*), avg(length)/60, \"4\" as ord from {$this->profile->tablename}_pagetime where length >=300 and length <=900 union ";
		$query.= "select \"15 to 30 mins            \", ((count(*)*1.0)/$total_visitors*100),count(*), avg(length)/60, \"5\" as ord from {$this->profile->tablename}_pagetime where length >=900 and length <=1800 union ";
		$query.= "select \"30 to 1 hr            \", ((count(*)*1.0)/$total_visitors*100),count(*), avg(length)/60, \"6\" as ord from {$this->profile->tablename}_pagetime where length >=1800 and length <=3600 union ";
		$query.= "select \"> 1 hr            \", ((count(*)*1.0)/$total_visitors*100),count(*), avg(length)/60, \"7\" as ord from {$this->profile->tablename}_pagetime where length >=3600";
		$query.= " order by ord";
		
		// get the results form the database
		$db->SetFetchMode(ADODB_FETCH_NUM);
		$result = $db->Execute($query);
		$data = $result->GetArray();
		$db->SetFetchMode(ADODB_FETCH_BOTH);
		
		// clean up temp tables (so we can do this more than once in a single script)
		$db->Execute("drop temporary table {$this->profile->tablename}_goodtimes");
		$db->Execute("drop table {$this->profile->tablename}_pagetime");
		
		//prepare the output
		$output="<table width='100%' cellpadding=4 bgcolor='#F8F8F8'><tr><td><i>"._TIME_SPENT."</i></td><td><i>"._UNIQUE_VISITORS."</i></td><td><i>"._AVERAGE_DURATION."</i></td></tr>";
		foreach ($data as $thisdatarow) { 
			$output.= "<tr><td>$thisdatarow[0]</td><td title='$thisdatarow[2] Visitors'>".number_format($thisdatarow[1],2)."%</td><td>".number_format($thisdatarow[3],2)." mins</td></tr>";   
		}
		$output.="</table>";    
		return $output;       
		// return $data;       
	}
	function SplitTestBounceRateOfPageVariation($page) {
		global $db;
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
		// get the visitorid and timestamp of the request we're interested in 
		$db->Execute("CREATE TEMPORARY TABLE {$this->profile->tablename}_goodtimes select vi.id as visitorid,timestamp from {$this->sptablename_results} as sp, {$this->profile->tablename_visitorids} as vi where testid=". $db->quote($this->testid) ." and timestamp >=". $db->quote($this->from) ." and timestamp <=". $db->quote($this->to) ." and page='$page' and sp.visitorid=vi.visitorid");
		
		// first get total number of visitors to page
		$query = "select count(distinct visitorid) from {$this->profile->tablename}_goodtimes";
		$result = $db->Execute($query); 
		$total_visitors = $result->FetchRow();
		$total_visitors = $total_visitors[0];    
		
		// count how many visitors have hits beyond the timestamp we just found
		$query = "select count(distinct b.visitorid) from {$this->profile->tablename} as a, {$this->profile->tablename}_goodtimes as b where b.visitorid=a.visitorid and a.timestamp > b.timestamp and a.timestamp <= ". $db->quote($this->to) ."";
		$result = $db->Execute($query); 
		$stay_visitors = $result->FetchRow();
		$stay_visitors = $stay_visitors[0];
		
		$bounce_visitors = $total_visitors - $stay_visitors;
		$bounce_rate = @($bounce_visitors / $total_visitors * 100);
		
		$db->Execute("drop temporary table {$this->profile->tablename}_goodtimes");  
		return number_format($bounce_rate,0) . "%";       
	}
	
	function Welcome() {
		global $databasedriver;
		echo "
		<table width=580px cellpadding=5 border=0>
			<tr>
				<td valign=top style='line-height:20px;'>
					<h3 style=\"margin-top:0px;\">"._WELCOME_TEST_CENTER."</h3><ul>";
					if (!IS_PHPDOCK) {
							echo "<li> <a href=definereport.php?conf={$this->profile->profilename}&testcenter=create&labels=_CONTENT_BASED_SPLIT_TEST&spt=create>"._CREATE_PHP_SPLIT_TEST."</a>"._EASY;                                                                                        
						} else {
						echo "<li> <font color=gray><u>"._CREATE_PHP_SPLIT_TEST."</u><br>"._NO_DESKTOP_VERSION."</font>";    
						}
					echo "</ul>";
					if ($databasedriver=='sqlite' && !IS_PHPDOCK) {
					echo "<B><font color=red>"._PLEASE_NOTE_TEST_ONLY_WITH_MYSQL."</b></font>";
					}
				echo "</td>";
			echo "</tr>";
		echo "</table>";
	}
	function DefineReport(){
		echo "<div style='float:left; width:100%; height:50px;'></div>";
		echo "<div style='float:left;'>";
		if(isset($_REQUEST["spt"])){
			switch($_REQUEST["spt"]){
				case "create":
					$this->CreateTest();
					break;
				case "delete":
					$this->DeleteTest();
					break;
				case "showclosed":
					$this->ShowClosed();
					break;
				case "edit":
					$this->EditTest();
					break;
				case "close":
					$this->CloseTest();
					break;
				case "activate":
					$this->ActivateTest();
					break;
				case "define":
					$this->DefineTest();
					break;
				case "savetest":
					$this->SaveTest();
					break;
				case "publish":
					$this->PublishTest();
					break;
			}
		}else{
			$this->Welcome();
		}
		echo "</div>";
		$this->SidePanel();
	}
	function DefineTest() {		
		$orisource=@file_get_contents($this->testurl);
		$this->testid = $this->SaveTest(); // save basic info from step 1
		if(!$this->testid){
			return false;
		}
		echo "
			<div class=\"test-center-create\">
				<table cellpadding=6 cellspacing=0 width=600 border=0>
					<tr>
						<td colspan=2><font size=3><b>" ._CREATE_TEST."</b></font></td>
					</tr>
					<tr>
						<td colspan=2>"._TEST_HTML_COPY."<hr noshade size=1>
							<form name=editor method=post action=''>";
								$orisource=str_replace("&","[#amp#]",$orisource);
								$orisource=str_replace("</textarea>","</overruletextarea>",$orisource);  ?>
								<input type='checkbox' class='noTextInput' name="wr" onclick="togglewrap()"><?php echo _WORD_WRAP; ?><P>
								<table with=100%>
									<tr>
										<td>
											<b><?php echo _ORIGINAL_VERSION?>:</b><br>
											<textarea name="panea" onscroll="syncpane('b')" cols=48 rows=25 wrap=off style='color:darkgray;'><?php echo $orisource; ?></textarea>
										</td>
										<td>
											<b><?php echo _CREATE_VARIATION?>:</b><br>
											<textarea name="paneb" onscroll="syncpane('a')" cols=48 rows=25 wrap=off style='color:darkgreen;'><?php echo $orisource; ?></textarea>
										</td>
									</tr>
									<tr>
										<td colspan=2 align=right><?php
											echo "
												<input type=submit value='"._CREATE."'/>
												<input type=hidden name=testid value=\"{$this->testid}\"/>
												<input type=hidden name=spt value='publish' />
												<input type=hidden name=conf value=\"{$this->profile->profilename}\"/>";
									?>	</td>
								</table>
							</form>
						</td>
					</tr>
				</table>
			</div>
		<?php
	}
	function CreateTest(){
		echo "
		<div class=\"test-center-create\">
			<table cellpadding=6 cellspacing=0 width=580px border=0>
				<tr>
					<td colspan=3><font size=3><b>"._CREATE_TEST."</b></font></td>
				</tr>
				<tr>
					<td colspan=3>
						<ul><li>"._STEP1_TEST . "</li><li>"._STEP2_TEST . "</li><li>"._STEP3_TEST."</li></ul>
						<P>" ._LETS_START_TEST ."<hr noshade size=1>
						<form method=post action=''>
					</td>
				</tr>
				<tr>
					<td>"._TEST_NAME.":</td>
					<td><input type=text size=20 name=testname maxval=50></td>
					<td bgcolor=#e0e0e0>"._TEST_NAME ."</td>	
				</tr>
				<tr>
					<td width=150>"._IMPORT_TEST.":</td>
					<td><input type=text size=40 maxval=50 name=testurl></td>
					<td bgcolor=#e0e0e0>"._ENTER_TEST_URL."</td>
				</tr>
				<tr>
					<td>"._TEST_DESCRIPT."</td>
					<td><textarea name=testdesc cols=30 rows=5 maxval=255></textarea></td>
					<td bgcolor=#e0e0e0>"._DESCRIBE_YR_TEST."</td>
				</tr>
				<tr>
					<td>"._TRAFFIC_SPLIT."%</td>
					<td><input type=text size=40 maxval=50 name=splitperc value=\"50\"></td>
					<td bgcolor=#e0e0e0>"._ENTER_PERCENT."</td>
				</tr>
				<tr>
					<td>
						<input type=submit value='"._CREATE."'>
						<input type=hidden name=spt value=\"define\">
						<input type=hidden name=testid value=\"0\">
						<input type=hidden name=conf value=\"{$this->profile->profilename}\">
						</form>
					</td>
				</tr>
			</table>			
		</div>";
	}
	function DeleteTest() {
		global $db;
		$db->Execute("delete from {$this->profile->tablename}_splittests where id=". $db->quote($this->testid) ."") or die ($db->ErrorMsg());
		$this->Welcome();
	}
	function CloseTest() {
		global $db;
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
		
		$db->Execute("update {$this->sptablename} set status=2 where id=". $db->quote($this->testid) ."");
		
		$this->ShowClosed();
	}
	function EditTest() {
		global $db;
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
		$q = $db->Execute("select * from {$this->sptablename} where id={$this->testid}");
		$data=$q->FetchRow();
		$testname=$data['testname'];
		$testurl=$data['testurl'];
		$testdesc=$data['testdesc'];
		$splitperc=$data['splitperc'];
		$panea=stripslashes($data['pagea']);
		$paneb=stripslashes($data['pageb']);
		$panea=str_replace("&","[#amp#]",$panea); 
		$paneb=str_replace("&","[#amp#]",$paneb);
		$panea=str_replace("</textarea>","</overruletextarea>",$panea);
		$paneb=str_replace("</textarea>","</overruletextarea>",$paneb); 

		echo "
			<form name=editor method=post action=''>
				<div class=\"test-center-create\">
					<table cellpadding=6 cellspacing=0 width=580px border=0>
						<tr>
							<td colspan=3><font size=3><b>"._EDIT_SPLIT_TEST."</b></font></td>
						</tr>
						<tr>
							<td>"._TEST_NAME.":</td>
							<td><input type=text size=20 name=testname maxval=50 value=\"$testname\"></td>
							<td bgcolor=#e0e0e0>"._TEST_NAME."</td>
						</tr>
						<tr>
							<td width=100>"._IMPORT_TEST.":</td>
							<td><input type=text size=40 maxval=50 name=testurl  value=\"$testurl\" disabled></td>
							<td width=270 bgcolor=#e0e0e0>"._ENTER_TEST_URL."</td>
						</tr>
						<tr>
							<td>"._DESCRIPTION.":</td>
							<td><textarea name=testdesc cols=30 rows=5 maxval=255>$testdesc</textarea></td>
							<td bgcolor=#e0e0e0>"._DESCRIBE_YR_TEST."</td>
						</tr>
						<tr>
							<td>Traffic Split %:</td>
							<td><input type=text size=40 maxval=50 name=splitperc value=\"$splitperc\"></td>
							<td bgcolor=#e0e0e0>"._ENTER_PERCENT."</td>
						</tr>
						<tr>
							<td colspan=3><hr noshade size=1>";	?>
								<input type='checkbox' class='noTextInput' name="wr" onclick="togglewrap()"> <?php echo _WORD_WRAP;?><P>
								<table with=450>
									<tr>
										<td>
											<b><?php echo _PAGE_A_ORIGINAL;?>:</b><br>
											<textarea name="panea" onscroll="syncpane('b')" cols=45 rows=25 wrap=off style='color:darkgray;'><?php echo htmlspecialchars($panea); ?></textarea>
										</td>
										<td>
											<b><?php echo _PAGE_B_VARIATION;?>:</b><br>
											<textarea name="paneb" onscroll="syncpane('a')" cols=45 rows=25 wrap=on style='color:darkgreen;'><?php echo $paneb; ?></textarea>
										</td>
									</tr>
								</table><?php echo "
								<input type=submit value="._SAVE.">
								<input type=hidden name=spt value=\"publish\">
								<input type=hidden name=testid value=\"{$this->testid}\">
								<input type=hidden name=edit value=\"1\">
								<input type=hidden name=conf value=\"{$this->profile->profilename}\">
							</td>
						</tr>
					</table>
				</div>
			</form>";
	}
	function ActivateTest() {
		global $db,$nosave;
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";

		$db->Execute("update {$this->sptablename} set status=1 where id=". $db->quote($this->testid) ."");
		$nosave=1;
		$this->PublishTest();
	}
	function PublishTest() {
		global $nosave,$silent,$panea;
		$filename=$this->profile->profilename."-splittest{$this->testid}".".php";
		if(isset($this->nosave)){
			$nosave = $this->nosave;
		}
		echo "
		<div class=\"test-center-create\">
			<table cellpadding=6 cellspacing=0 width=500 border=0>
				<tr>
					<td colspan=2>";
					if($_REQUEST["spt"] == "activate"){
						echo "<font size=3><b>"._PUBLISH_SPLIT_TEST_REACTIVATED."</b></font>";
					}else{
						echo "<font size=3><b>"._PUBLISH_SPLIT_TEST."</b></font>";
					}
				echo "</td>
				</tr>
				<tr>
					<td colspan=2>";
						if ($nosave!=1) {
							$silent=1;
							$this->SaveTest();
						}
						echo _PUBLISH_TEST_NEXT."
						<form>";
							$w_path = $_SERVER['PHP_SELF'];
							$wpath = dirname($w_path);
				   			
							if (stripos($panea,"<BODY")!=FALSE) {
								echo "<font color=red>A BODY tag was detected in your split test content, we recommend to use the 'Testing an Entire Page' code below.</font><br>";
							}							
							echo "<br><hr noshade size=1><br>"._TESTING_AN_ENTIRE_PAGE.":<br><br>";
							$abcodespace="<html><head>\n<script language=\"javascript\" type=\"text/javascript\" src=\"http://$_SERVER[HTTP_HOST]$wpath/abtester.php?conf={$this->profile->profilename}&testid={$this->testid}&vmethod={$this->profile->visitoridentmethod}&tn={$this->profile->tablename}&jsmode=2\"></script>\n</head><body></body></html>"; 
							?><textarea wrap=on cols=70 rows=6 name="abcodespace2" onClick="javascript:this.form.abcodespace2.focus();this.form.abcodespace2.select();"><?php echo $abcodespace; ?></textarea><br><font size=1>Click above to Select All, then press Ctrl-C to copy.</font><?php
							
							echo "<br><hr noshade size=1><br>". _TESTING_PART_OF_PAGE."";  
						   $abcodespace="<div id=\"abtester\"></div><script language=\"javascript\" type=\"text/javascript\" src=\"http://$_SERVER[HTTP_HOST]$wpath/abtester.php?conf={$this->profile->profilename}&testid={$this->testid}&vmethod={$this->profile->visitoridentmethod}&tn={$this->profile->tablename}&jsmode=1\"></script>";
						   ?><br><br><textarea wrap=on cols=70 rows=4 name="abcodespace" onClick="javascript:this.form.abcodespace.focus();this.form.abcodespace.select();"><?php echo $abcodespace; ?></textarea><br><font size=1><?php echo _CLICK_ABOVE_CTRL_C_COPY?></font>
							
						</form>
						<form method=post action='<?php echo "definereport.php?conf={$this->profile->profilename}&labels=_CONTENT_BASED_SPLIT_TEST"; ?>'>
							<input type=hidden name=conf value=<?php echo $this->profile->profilename;?>>
							<input type=submit value=Finish>
						</form>
					</td>
				</tr>
			</table></div>       
		<?php
	}
	function ShowClosed() {
		global $db;
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
			
		$q = $db->Execute("select id,testname from {$this->sptablename} where status=2");
		echo "
		<table cellpadding=4 width=580px>
			<tr>
				<td><b>"._CLOSED_TESTS."</b></td>
			</tr>";
			echo "<tr><td>";
			echoWarning(_DELETE_TEST_WARNING,"margin-right:10px");
			echo "</td></tr>";
			$i=0;
			while ($data=@$q->FetchRow()) {
			echo "
			<tr>
				<td valign=center>
					<img src=images/icons/savedtest.gif width=16 height=16 align=left>					
					<nobr>". $data['testname'] . "</nobr><br>
					<a href=testpreview.php?conf={$this->profile->profilename}&testid=". $data['id'] . "&page=A target='_blank'>"._PREVIEW . "</a> | 
					<a href=definereport.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&testid=". $data['id'] . "&spt=edit>"._EDIT."</a> | 
					<a href=definereport.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&testid=". $data['id'] . "&spt=delete>Delete</a> |
					<a href=definereport.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&testid=". $data['id'] . "&spt=activate>Activate</a>
				</td>
			</tr>";
			$i++;
			}
			if ($i==0) {
			echo "<tr><td>"._NONE."</td></tr>";
			}
		echo "</table>";
	}
	function Sidepanel() {
		global $db,$spt;
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
		
		$options = array();
		
		$q = @$db->Execute("select * from {$this->sptablename} where status= 1");
		if (!$q) {
			// Probably no table.  When we create a test, we'll create the table.
		}
		echo "<div class='top_navigation_wrap' style='position:fixed; width:99%; left:0; z-index:55; font-size:11px; top:0px;'>";
		echo "<ul class='dropdown top_navigation'>";
		echo "<li><a href=\"definereport.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&spt=create\">". _NEW ."</a></li>";
		$i=0;
		echo "<li><a style='cursor:pointer;'>Tests</a>";
		echo "<ul class='dropdown-list'>";
		while (($q) && ($data=@$q->FetchRow())) {
			echo "<li><a style='cursor:pointer;' class='top-menu-list-item' rel='$i' name='{$data['testname']}' title='Preview Split Test'>{$data['testname']}</a></li>";
			$options[$i]["name"] = $data["testname"];
			$options[$i]["id"] = $data["id"];
			$options[$i]["rel"] = $i;
			$i++;
		}
		echo "</ul>";
		$selected = _NO_SPLIT_SELECT;
		foreach($options as $k => $v){
			if(isset($this->testid) && $this->testid == $v["id"]){ $style = "display:block;"; $selected = "Selected: {$v["name"]}"; }else{ $style="display:none;"; }
			echo "<li class='list-option' style='{$style}' rel='{$v["rel"]}'><a href='definereport.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&testid={$v['id']}&nosave=1&spt=publish' title='"._PUBLISH . " " . $v["name"] ."'>"._PUBLISH."</a></li>";
			
			echo "<li class='list-option' style='{$style}' rel='{$v["rel"]}'><a href='testpreview.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&testid={$v['id']}&page=A' title='"._PREVIEW . " " . $v["name"] ."'>"._PREVIEW."</a></li>";
			
			echo "<li class='list-option' style='{$style}' rel='{$v["rel"]}'><a href='definereport.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&testid={$v['id']}&spt=edit' title='"._EDIT . " " . $v["name"] ."'>"._EDIT."</a></li>";
			
			echo "<li class='list-option' style='{$style}' rel='{$v["rel"]}'><a href='definereport.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&testid={$v['id']}&spt=close' title='"._CLOSE . " " . $v["name"] ."'>"._CLOSE."</a></li>";
		}
		echo " <li> <a href=\"definereport.php?labels=_CONTENT_BASED_SPLIT_TEST&conf={$this->profile->profilename}&testid=".@$this->testid."&spt=showclosed\" class=\"sidelinks\">"._SHOW_CLOSED_TESTS."</a> </li>";
		echo "</ul>";
		echo "<div id='selected-item' style='float:right; margin:8px;'>$selected</div>";
		echo "</div>"; ?>
		<script type='text/javascript'> 
		$(document).ready( function() {
			$(".dropdown > li").live({
				mouseenter: function() {
					var dropdownElement = $(this);
					dropdown_timer = setTimeout(function () {
						dropdownElement.find('.dropdown-list').show();
					}, 100);
				},
				mouseleave: function() {
					clearTimeout(dropdown_timer);
					$(this).find('.dropdown-list').hide();
				}
			});
		
			$(".top-menu-list-item").live("click",function(){
				itemRel = $(this).attr("rel");
				$("#selected-item").html("Selected: "+$(this).attr("name"));
				$(".list-option").each(function () {
					if($(this).attr("rel") == itemRel){
						$(this).css("display","block");
					}else{
						$(this).css("display","none");
					}
				});
			});			
		});
		</script><?php
	}
	function Create_tables(){
		global $db, $databasedriver ;
			if (!CheckIfTableExists($this->sptablename)) {
			$db->Execute("CREATE TABLE {$this->sptablename} (".
			"id " . ($databasedriver == "sqlite"? "INTEGER PRIMARY KEY ": "int(11) NOT NULL auto_increment ") . "," .
			"testname varchar(100) NOT NULL default '',
			testdesc text,
			testurl varchar(255) default NULL,
			pagea blob,
			pageb blob,
			splitperc int(3) default '50',
			created int(11) NOT NULL default '0',
			status int(1) default '1' ".
			($databasedriver == "sqlite" ? "" : ", PRIMARY KEY  (id)") . 
			") ENGINE=MyISAM CHARSET=utf8");
			if ($databasedriver == "mysql") { 
				$db->Execute("ALTER TABLE {$this->sptablename} ADD INDEX {$this->sptablename}_testname (testname)"); 
			} else { 
				$db->Execute("CREATE INDEX {$this->sptablename}_testname on {$this->sptablename}(testname)"); 
			}
		}	
		if (!CheckIfTableExists($this->sptablename_results)) {
			$db->Execute("CREATE TABLE {$this->sptablename_results} (".
			"id " . ($databasedriver == "sqlite"? "INTEGER PRIMARY KEY ": "int(11) NOT NULL auto_increment ") . "," .
			" testid int(10) NOT NULL default '0',
			visitorid varchar(32) NOT NULL default '0',
			timestamp int(11) NOT NULL default '0',
			page varchar(2) NOT NULL default '0' ".
			($databasedriver == "sqlite" ? "" : ", PRIMARY KEY  (id)") . 
			") ENGINE=MyISAM CHARSET=utf8");
			if ($databasedriver == "mysql") { 
				$db->Execute("ALTER TABLE {$this->sptablename_results} ADD INDEX {$this->sptablename_results}_visitorid (visitorid)");
				$db->Execute("ALTER TABLE {$this->sptablename_results} ADD INDEX {$this->sptablename_results}_timestamp (timestamp)");
				$db->Execute("ALTER TABLE {$this->sptablename_results} ADD INDEX {$this->sptablename_results}_testid (testid)");
				$db->Execute("ALTER TABLE {$this->sptablename_results} ADD INDEX {$this->sptablename_results}_page (page)");
			} else { 
				$db->Execute("CREATE INDEX {$this->sptablename_results}_visitorid on {$this->sptablename_results}(visitorid)");
				$db->Execute("CREATE INDEX {$this->sptablename_results}_timestamp on {$this->sptablename_results}(timestamp)");
				$db->Execute("CREATE INDEX {$this->sptablename_results}_testid on {$this->sptablename_results}(testid)");
				$db->Execute("CREATE INDEX {$this->sptablename_results}_page on {$this->sptablename_results}(page)"); 
			}
		}	
	}
	function SaveTest() {
		global $db,$silent;
		
		if(empty($_REQUEST["testname"])){
			$_REQUEST["testname"] = "Unnamed Test";
		}
		
		$this->sptablename = $this->profile->tablename."_splittests";
		$this->sptablename_results = $this->profile->tablename."_splittests_results";
		if (empty($this->testid)) {
			// If the tables don't already exists, then create them...
			$this->Create_tables();

			$cd=time();
			
			$q = $db->Execute("SELECT testname FROM {$this->sptablename} WHERE testname = ". $db->Quote($_REQUEST["testname"]));
			while($check = $q->fetchRow()){
				echoWarning("Test name already taken!","margin: 0 0 0 200px;");
				return false;
			}
			
			$db->Execute("insert into {$this->sptablename} (testname, testurl, testdesc, splitperc, created) values (".$db->Quote($_REQUEST["testname"]).",".$db->Quote($_REQUEST["testurl"]).",".$db->Quote($_REQUEST["testdesc"]).",".$db->Quote($_REQUEST["splitperc"]).",'$cd')");
			$this->testid=$db->Insert_ID();
			return $this->testid;  
		} else {
			$_REQUEST["panea"]= str_replace("[#amp#]","&",$_REQUEST["panea"]);
			$_REQUEST["paneb"]= str_replace("[#amp#]","&",$_REQUEST["paneb"]);
			$_REQUEST["panea"]= str_replace("</overruletextarea>","</textarea>",$_REQUEST["panea"]);
			$_REQUEST["paneb"]= str_replace("</overruletextarea>","</textarea>",$_REQUEST["paneb"]);
			
			if (isset($this->edit) && $this->edit==1) {
				$db->Execute("update {$this->sptablename} set testname=".$db->Quote($_REQUEST["testname"]).",testdesc=".$db->Quote($_REQUEST["testdesc"]).",splitperc=".$db->Quote($_REQUEST["splitperc"]).",pagea=".$db->Quote($_REQUEST["panea"]).", pageb=".$db->Quote($_REQUEST["paneb"])." where id=". $db->quote($this->testid) ."") or die ($db->ErrorMsg());
			} else {
				$db->Execute("update {$this->sptablename} set pagea=".$db->Quote($_REQUEST["panea"]).", pageb=".$db->Quote($_REQUEST["paneb"])." where id=". $db->quote($this->testid) ."") or die ($db->ErrorMsg());
			}
			return $this->testid;
		}
	}
	
	function UpdateStats() {
		return false;
	}
}
?>