<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays the days of the week
*/
$reports["_DAYS_OF_THE_WEEK"] = Array(
	"ClassName" => "DaysOfTheWeek", 
	"Category" => "_VISITOR_DETAILS", 
	"icon" => "images/icons/32x32/daysoftheweek.png",
	"Options" => "daterangeField,profileselector,displaymode,trafficsource,columnSelector",
	"Filename" => "days_of_the_week",
	"Distribution" => "Standard",
	"Order" => 6,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class DaysOfTheWeek extends Report {
	
	function Settings() {
		$this->DefaultDisplay = "table";
		$this->DisplayModes = "table,pie,linechart,barchart,areachart";
		$this->allowDateFormat = false;
		$this->sort_order = SORT_ASC;
		$this->sort_key = 3;
		$this->columnDefinitions[] = Array("Label" => "_DATE");
		$this->columnDefinitions[] = Array("Label" => "_VISITS");
		$this->columnDefinitions[] = Array("Label" => "_PAGEVIEWS");
		# Define this column because we want to sort on this , but it should not sum the number...
		$this->columnDefinitions[] = Array("Label" => "_NUMBER", "dataType" => "String" );
	}

	function GetReportData(){
		$data = parent::GetReportData();
		# remove the sorting number from the column definitions because the sorting has now been done in the parent.
		unset($this->columnDefinitions[3]);
		for ($i=0; $i < count($data); $i++) { 
			$data[$i][0] = LogaDate(array("format1" => "l"),$data[$i][0],"STRING");
			# remove the sorting number from the array
			unset($data[$i][3]);
		}
		return $data;
	}
	
	function DefineQuery() {
		global $db;
		$query  = "SELECT FROM_UNIXTIME(timestamp,'%W') AS days, COUNT(distinct sessionid), COUNT(*) AS hits, FROM_UNIXTIME(timestamp,'%w') AS daynum FROM {$this->profile->tablename} WHERE timestamp >= ". $db->quote($this->from) ." and timestamp <= ". $db->quote($this->to) ." GROUP BY days ORDER BY FROM_UNIXTIME(timestamp, '%w')";
		
		return $query;
	}
}
?>
