<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays an analysis of your funnel
*/
$reports["_FUNNEL_ANALYSIS"] = Array(
	"ClassName" => "FunnelAnalysis", 
	"Category" => "_PERFORMANCE", 
	"icon" => "images/icons/32x32/funnelanalysis.png",
	"Options" => "daterangeField,profileselector",
	"Filename" => "funnel_analysis",
	"Distribution" => "Legacy",
	"Order" => 10,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => false,
	"Update" => false
);

class FunnelAnalysis extends Report {
	
	function Settings() {		
		$this->funneltablename = $this->profile->tablename."_funnels";
		
		$this->columnDefinitions[] = array("Label" => _CONVERSION_PERC);
		$this->columnDefinitions[] = array("Label" => _STAGE);
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS);
		$this->columnDefinitions[] = array("Label" => _BOUNCE_RATE);
		$this->columnDefinitions[] = array("Label" => _RETENTION_PERC);
		$this->columnDefinitions[] = array("Label" => _VALUE);
		$this->help = _HELP_TEXT_FUNNELS;
		$this->sortTable=false;
		$this->displayReportButtons=false;
		$this->displayTotalRow = false;
	}
	
	function DisplayReport() {
		global $db,$data,$nograph,$graphinclude,$divlabel, $arr_FCColors, $FC_ColorCounter;
		
		#load funnel data
		flush();
		
		if(!isset($this->funnelid)){
			$this->ReportHeader(); 
			echoNotice(_NO_DATA_TO_DISPLAY,"margin:5px;");
			return false;
		}
		
		if (!CheckIfTableExists($this->funneltablename)) {
			echoNotice(_NO_DATA_TO_DISPLAY,"margin:5px;");
			return false;
		}
		$q = $db->Execute("select * from {$this->funneltablename} where funnelid=". $db->Quote($this->funnelid) ." order by id");
		
		$i=0;
		while (($q) && ($data=$q->FetchRow())) {
			if ($data['funnelid']==$data['id']) {
				//funnelname
				$this->funnelname=$data['label'];
				//echo $funnelname;
			} else if ($data['funnelid']!=$data['id'] && $i==0) {
				//echo "// this is the first url: ". $data['url'];
				$url1=$data['url'];
				$label1=$data['label'];
				$value1=$data['value'];
				$i++;
			} else {
				//rest
				// echo "next url: ($i)".$data['url'];
				$ourls[$i]=$data['url'];
				$olabels[$i]=$data['label'];
				$ovalues[$i]=$data['value'];
				$i++;
			}
		}
		if($i == 0){
			$this->addlabel = _FUNNEL.": {$this->funnelname}";
			$this->reportHeader();
			echoWarning(_NO_FUNNEL_DEF,"margin: 5px 5px 5px 5px;");
			return false;
		}
		// 1. get all the ips that started at the first url and put that in a temp table
		if (@$url1=="" || @$url1=="any") {
			$q = $db->Execute("select count(distinct visitorid) from {$this->profile->tablename} where timestamp >=". $db->Quote($this->from) ." and timestamp <=". $db->Quote($this->to));
			$data=@$q->FetchRow();
			$total_pop=$data[0];
		} else {
			$query= "create temporary table {$this->profile->tablename}_temp_fips (visitorid int(11))";
			flush();
			$db->Execute($query) or die (_ERROR.":" . $db->ErrorMsg());
			$sqlstr=$this->makesql($url1,"");
			$query  = "insert into {$this->profile->tablename}_temp_fips select visitorid from {$this->profile->tablename} as a,{$this->profile->tablename_urls} as u,{$this->profile->tablename_urlparams} as up,{$this->profile->tablename_referrers} as r where timestamp >=". $db->Quote($this->from) ." and timestamp <=". $db->Quote($this->to) ." and a.url=u.id and a.params=up.id and a.referrer=r.id $sqlstr group by visitorid";
			flush();  
			$db->Execute($query);

			$q = $db->Execute("select count(distinct visitorid) from {$this->profile->tablename}_temp_fips");
			$data=@$q->FetchRow();
			$total_pop=$data[0];
		}

		// 2. from the above get all ips that made it to the other urls
		$i=1;
		while (@$ourls[$i]!="") {
			if ($url1=="" || $url1=="any") {
				$sqlstr=$this->makesql($ourls[$i], "");
				$result = $db->Execute("select count(distinct visitorid) from {$this->profile->tablename} as a,{$this->profile->tablename_urls} as u,{$this->profile->tablename_urlparams} as up,{$this->profile->tablename_referrers} as r where timestamp >=". $db->Quote($this->from) ." and timestamp <=". $db->Quote($this->to) ." and a.url=u.id and a.params=up.id and a.referrer=r.id $sqlstr")  or die ("Error:" . $db->ErrorMsg());
			} else {
				$sqlstr=$this->makesql($ourls[$i],"m.");
				$result = $db->Execute("select count(distinct t.visitorid) from {$this->profile->tablename} as a, {$this->profile->tablename}_temp_fips as t,{$this->profile->tablename_urls} as u,{$this->profile->tablename_urlparams} as up,{$this->profile->tablename_referrers} as r where a.timestamp >=". $db->Quote($this->from) ." and a.timestamp <=". $db->Quote($this->to) ." and a.visitorid=t.visitorid and a.url=u.id and a.params=up.id and a.referrer=r.id $sqlstr")  or die ("Error:" . $db->ErrorMsg());
			}
			$data=@$result->FetchRow();
			$url_pop[$i]=$data[0];
			$i++;
		}

		// create data array
		$r=0;
		$data="";

		//set the first row
		if (!@$url1) {
			if (!@$funnelname) {
				echo "<div style='margin: 3px 5px; float: left;' class=\"warning ui-state-error ui-corner-all\">No Funnel Found</div>";
				return;   
			}
			echo "<div class=\"toplinegreen\" style=\"font-size:18px;display:block;padding:2px;font-family:arial;\">"._FUNNEL.": $funnelname</div>";
			echo "<div style=\"background:silver;display:block;padding:2px;\">&nbsp;".FunnelGraphToggle()."</div>";
			echo ""._DEFINITION_INCOMPLETE." <a href=\"definereport.php?labels=_FUNNEL_ANALYSISconf={$this->profile->profilename}&amp;funnelid={$this->funnelid}&amp;funnel=edit\">"._EDIT."</a>.";
			return false;
		}
		
		$data[$r][0]="100";
		$data[$r][1]="<span style='border-bottom: 1px dashed #00F; cursor: help;' title=\"".$url1. "\">".$label1."</span>";
		$data[$r][2]=$total_pop;
		$data[$r][3]="0";
		$data[$r][4]="0";
		$data[$r][5]=($value1*$total_pop);
		$legend = "<div class='legend_bullet'><div style='height:14px; width:14px; background-color: ".$this->graphcolors[0]."'></div></div>";
		$data[$r][6] = $legend;
		//set the rest
		$r=1;
		$i=1;
		while (@$ourls[$i]!="") {
			$data[$r][0]=@round((($url_pop[$i]/$total_pop)*100),2); 
			$data[$r][1]="<span style='border-bottom: 1px dashed #00F; cursor: help;' title=\"".$ourls[$i]. "\">".$olabels[$i]."</span>";
			$data[$r][2]=$url_pop[$i];
			if ($i <= 1) {
				@$data[$r][3]=(($url_pop[$i]/$total_pop)*100)-100;
				@$data[$r][4]=(($url_pop[$i]/$total_pop)*100);
			} else {
				@$data[$r][3]=(($url_pop[$i]/$url_pop[($i-1)])*100)-100;
				@$data[$r][4]=(($url_pop[$i]/$url_pop[($i-1)])*100);
			}
			$data[$r][5]=($url_pop[$i]*$ovalues[$i]);
			
			
			$legend = "<div class='legend_bullet'><div style='height:14px; width:14px; background-color: ".$this->graphcolors[$i]."'></div></div>";
			$data[$r][6] = $legend;
			
			$data[$r][7]=$ourls[$i];
			$i++;
			$r++;
		}
		
		//$this->label=_FUNNEL_ANALYSIS;

		$nograph=1;
		reset($data);
		$filter="";
		$drilldown="";
		$query="";
		$this->addlabel = _FUNNEL.": ".$this->funnelname;
		$this->ReportHeader();
		echo "<div style='position:absolute; margin-top:20px;'>";
		$this->FunnelChart($data);
		echo "</div>";
		
		$this->addgraph = "";
		$this->displayHeader = false;
		
		$this->columnDefinitions = array();
		$this->columnDefinitions[] = array("Label" => "");
		$this->columnDefinitions[] = array("Label" => _CONVERSION_PERC);
		$this->columnDefinitions[] = array("Label" => _STAGE);
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS);
		$this->columnDefinitions[] = array("Label" => _BOUNCE_RATE);
		$this->columnDefinitions[] = array("Label" => _RETENTION_PERC);
		$this->columnDefinitions[] = array("Label" => _VALUE);
		$this->setupColumnDefinitions();
		
		$i = 0;
		$data2 = array();
		foreach($data as $set){
			$data2[$i][0] = $set[6];
			$data2[$i][1] = $set[0];
			$data2[$i][2] = $set[1];
			$data2[$i][3] = $set[2];
			$data2[$i][4] = $set[3];
			$data2[$i][5] = $set[4];
			$data2[$i][6] = $set[5];
			if(isset($set[7])){
				$data2[$i][7] = $set[7];
			}
			$i ++;
		}
		echo "<style>.funneltable{ min-height:250px; padding-left:240px; margin:10px 5px 10px;} .funneltable table td, th{ padding:2px; } .funneltable p{ font-size:14px; font-style:italic; margin-bottom:5px; padding:0px; }</style>";
		echo "<div class='funneltable'>";
		echo "<p>Funnel Data</p>";
		
		$this->Table($data2);
		echo "</div>";
	}
	
	function makesql($urls,$prefix) {
		global $db;

		$urls=explode(",",$urls); 
		$gi=0;
		$sqlstr="";

		while (@$urls[$gi]!="") {
			$urls[$gi]=trim($urls[$gi]);
			if ($gi==0) {
				$cond="and (";
			} else {
				$cond="or";
			}
			if (strpos(" ".$urls[$gi], "*")!=FALSE) {
				//we do a like style
				$urls[$gi]=str_replace("*", "%", $urls[$gi]);
				if (strpos(" ".$urls[$gi],"ttp://")!=FALSE) {
					$sqlstr.="$cond r.referrer like ". $db->Quote($urls[$gi]);
				} else {
					$sqlstr.="$cond concat(u.url,up.params) like ". $db->Quote($urls[$gi]);
				}
			} else {
				if (strpos(" ".$urls[$gi],"http:")!=FALSE) {
					$sqlstr.="$cond r.referrer=". $db->Quote($urls[$gi]);
				} else {
					if (strpos("?",$urls[$gi])!=FALSE) {
						$sqlstr.="$cond concat(u.url,up.params)=". $db->Quote($urls[$gi]);
					} else {
						$sqlstr.="$cond u.url=". $db->Quote($urls[$gi]);
					}
				}
			}
			$gi++;
		}
		
		return $sqlstr.")";
	}
	
	function DisplayCustomForm() {
		global $db,$session;
		
		$q = @$db->Execute("select id,label from {$this->funneltablename} where id=funnelid");
		$ii=1;
		echo "<select class='report_option_field' id='funnelid'>";
		if (!$q->fields) {
			// Probably no table.  When we create a test, we'll create the table.
			echo "<option value=''>"._NONE."</option>";
		}
		while (($q) && ($data=@$q->FetchRow())) {
			echo "<option value='{$data['id']}'>{$data['label']}</option>";
		}
		echo "</select>";
		
		if($session->canEditProfiles()){
			echo "<a href='definereport.php?conf={$this->profile->profilename}&labels=_FUNNEL_ANALYSIS' class='optionlink open_iframe_window'>"._MANAGE_FUNNELS."</a>";
		}
	}
	
	function GetFunnelid() {
		global $db;
		
		$q = @$db->Execute("select id,label from {$this->funneltablename} where id=funnelid LIMIT 1");
		$data=@$q->FetchRow();
		return $data[0]; 
	}
	
	function FunnelGraphToggle() {
		global $db;
		$q = @$db->Execute("select id,label from {$this->funneltablename} where id=funnelid");
		echo "<select id=\"funnelselector\" style=\"float:left;background:#f0f0f0;border:1px solid gray;\" onChange=\"showAjaxGet('definereport.php?labels=_FUNNEL_ANALYSISconf={$this->profile->profilename}&to=". $db->quote($this->to) ."&from=". $db->quote($this->from) ."&graphinclude=1&divlabel={$this->divlabel}&funnelid='+this.options[this.selectedIndex].value, '{$this->divlabel}')\">";

		$i=0;
		while (($q) && ($data=@$q->FetchRow())) {
			echo "<option value=\"".$data['id']."\"";
			if ($data['id']==$this->funnelid) { echo " selected"; }
			echo "> {$data[label]} </option>";
			$i++;
		}
		if ($i==0) {
			//echo "<tr><td>none</td></tr>";
		}
		echo "</select>";
	}
	
	
	function EditFunnel() {
		global $ourls,$db;
		
		$olabels = array();
		if ($this->funnel=="create") {
			//this is new
		} else {
			// get info from database
			$ourls=array();
			$q = $db->Execute("select * from {$this->funneltablename} where funnelid=". $db->Quote($this->funnelid) ." order by id");
			$i=0;
			while (($q) && ($data=@$q->FetchRow())) {
				if ($data['funnelid']==$data['id']) {
					//funnelname
					$this->funnelname=$data['label'];
				}else {
					//rest
					$ourls[$i]=$data['url'];
					$olabels[$i]=$data['label'];
					$ovalues[$i]=$data['value'];
					$i++;
				}
			}
		}
		
		$this->Sidepanel();
		
		echo "<form method=post id=\"editform\" name=\"editform\" action=definereport.php?labels=_FUNNEL_ANALYSIS><div style='height: 560px; overflow-y: auto;'><table cellpadding=6 cellspacing=0 width=580px style='margin-right: 15px;' border=0><tr><td colspan=3><font size=3><b>". _DEFINE_FUNNEL ."</b></font></td></tr>";
		echo "<tr><td valign=top colspan=2><b>"._FUNNEL_NAME.":</b> <input type=text size=30 name=funnelname maxval=50 value=\"".@$this->funnelname."\"><br>&nbsp;</td>";
		echo "<td bgcolor=#e0e0e0 valign=top>"._GIVE_FUNNEL_NAME."</td></tr>";
		echo "<tr><td colspan=2 valign=top><b>"._FUNNEL_DEF.":</b><br><br>";
		echo "<div class='condition_descriptor'>("._LABELNAME.", "._PAGES.", "._VALUE.")</div>";
		
		$form_id = md5(time());
		$form = "<script type='text/javascript'>plusMinusForm('{$form_id}', 'field', 'group', 'value', false);</script>";
		$form .= "<script type='text/javascript'>
				$(\".funnelqbuilder\").live(\"keyup\", function(event) {
					QBuilderHelpForms('funnelentry', event, $(this).val() + '@' + 'group' + $(this).attr('rel') + '@' + 'funnelentry', 'forminput');
				});

				$(\".funnelqbuilder\").live(\"click\", function(event) {
					QBuilderHelpForms('funnelentry', event, $(this).val() + '@' + 'group' + $(this).attr('rel') + '@' + 'funnelentry', 'forminput');
				});
		</script>";
		$form .= "<div id='{$form_id}' style='width: 350px;'>";
			if(count($olabels) == 0) {
				$form .= "<div class='conditions_row'>";
					$form .= "<input style='width: 75px; margin: 5px;' src='field' rel='1' name='field1' id='field1' value='' autocomplete='off'>";
					$form .= "<input style='width: 100px; margin: 5px;' class='funnelqbuilder' src='group' rel='1' name='group1' id='group1' value='' autocomplete='off'>";
					$form .= "<input style='width: 40px; margin: 5px;' src='value' rel='1' name='value1' id='value1' value='' autocomplete='off'>";
					$form .= "<button style='width: 25px; height: 20px; margin: 0; padding: 0;' type='button' class='plus_btn noOption' /> + </button><button style='width: 25px; height: 20px; margin: 0; padding: 0;' type='button' class='min_btn noOption' disabled='disabled' /> - </button>";
				$form .= "</div>";
			} else {
				for($c = 0; $c < count($olabels); $c++) {
					$form .= "<div class='conditions_row'>";
						$form .= "<input style='width: 75px; margin: 5px;' src='field' rel='".($c + 1)."' name='field".($c + 1)."' id='field".($c + 1)."' value='".@$olabels[$c]."' autocomplete='off'>";
						$form .= "<input style='width: 100px; margin: 5px;' class='funnelqbuilder' src='group' rel='".($c + 1)."' name='group".($c + 1)."' id='group".($c + 1)."' value='".@$ourls[$c]."' autocomplete='off'>";
						$form .= "<input style='width: 40px; margin: 5px;' src='value' rel='".($c + 1)."' name='value".($c + 1)."' id='value".($c + 1)."' value='".@$ovalues[$c]."' autocomplete='off'>";
						$form .= "<button style='width: 25px; height: 20px; margin: 0; padding: 0;' type='button' class='plus_btn noOption' /> + </button><button style='width: 25px; height: 20px; margin: 0; padding: 0;' type='button' class='min_btn noOption' /> - </button>";
					$form .= "</div>";
				}
			}
		$form .= "</div>";
		echo $form;
		echo "<br/>";
		
		if ($this->funnel=="create") { ?>
		<div id="funnelhelp" align=center>
		&nbsp;<P>
		<a href="javascript:close('funnelhelp');"><img src=images/funnelexample2.gif border=1 alt="Click to close example"></a>
		</div>
		<?php
		}
		echo "<input type=submit value='". _SAVE ."'><input type=hidden name=funnel value=\"save\"><input type=hidden name=funnelid value=\"".@$this->funnelid."\">
		<input type=hidden name=edit value=\"".@$this->funnel."\"><input type=hidden name=conf value=\"{$this->profile->profilename}\"></form>";
		echo "<td bgcolor=#e0e0e0 valign=top><b>"._STAGE." 1:</b><br>"._FIRST_FUNNEL_PAGE_DEF.":<br>http://www.google.*<br>";
		echo "<P>"._STAGE." 2, 3, 4 "._ETCETERA.":</b><br>"._ENTER_OTHER_FUNNEL_PAGES."<P>";
		echo _ENTER_MULTIPLE_FUNNEL_PAGES."<P>";
		echo _ENTER_OPTIONALLY_STAGE_VALUE;
		echo "<P>"._DONT_FORGET_LABEL."</td><tr>";

		echo "<tr class=dotline><td cospan=3>";
		echo "</td></tr></table></div>";
	}

	function SaveFunnel() {
		global $db,$databasedriver;

		if ($_REQUEST["funnelname"]=="") {
			$_REQUEST["funnelname"]=_UNNAMED_FUNNEL_REPORT;
		}
		
		if(!empty($this->funnelid)){		
			if ($this->funnelid) {
				//update funnel
				$db->Execute("update {$this->funneltablename} set label=".$db->Quote($_REQUEST["funnelname"])." where id=". $db->Quote($_REQUEST["funnelid"])."");
				$db->Execute("delete from {$this->funneltablename} where funnelid=".$db->Quote($_REQUEST["funnelid"])." and id!=funnelid") or die ($db->ErrorMsg());

				// loop the other urls
				if (@$_REQUEST["group1"]=="") {
					$_REQUEST["group1"]="any";
				}
				$i=1;
				while ($i < 25) {
					$field = "";
					if(!empty($_REQUEST["field$i"])){
						$field = $_REQUEST["field$i"];
					}
					$value = "";
					if(!empty($_REQUEST["value$i"])){
						$value = $_REQUEST["value$i"];
					}
					$group = "";
					if(!empty($_REQUEST["group$i"])){
						$group = $_REQUEST["group$i"];
					}
					if ($group || $field) {
						$db->Execute("insert into {$this->funneltablename} (funnelid, label, url, value) values (". $db->Quote($_REQUEST["funnelid"]).",". $db->Quote($field) .",". $db->Quote($group) .",". $db->Quote($value) .")");
					}
					$i++;
				}
			
				$this->Sidepanel();

				return "<div style='margin: 3px 5px; float: left;' class=\"warning ui-state-highlight ui-corner-all\">"._UPDATED.": <b>".$_REQUEST["funnelname"]."</b></div>";  
			} 
		}else {
			# If the tables don't already exists, then create them...
			if (!CheckIfTableExists($this->funneltablename)) {
				$db->Execute("CREATE TABLE {$this->funneltablename} (".
				"id " . ($databasedriver == "sqlite"? "INTEGER PRIMARY KEY ": "int(11) NOT NULL auto_increment ") . "," .
				"funnelid int(11) default NULL,
				label varchar(100) NOT NULL default '',
				value double(100,2) NOT NULL default '0.00',
				url blob default NULL ".
				($databasedriver == "sqlite" ? "" : ", PRIMARY KEY  (id)") . 
				") ENGINE=MyISAM CHARSET=utf8");
			}
			$q = $db->Execute("SELECT label FROM {$this->funneltablename} WHERE label = ".$db->Quote($_REQUEST["funnelname"])."");
			while($check = $q->fetchRow()){
				$this->Sidepanel();
				return "<div style='margin: 3px 5px; float: left;' class=\"warning ui-state-error ui-corner-all\">Funnel name already taken!</div>";
			}
			# Insert the funnel
			$db->Execute("insert into {$this->funneltablename} (label) values (". $db->Quote($_REQUEST["funnelname"]).")");
			$nfid=$db->Insert_ID();
			$db->Execute("update {$this->funneltablename} set funnelid=". $db->Quote($nfid) ." where id=". $db->Quote($nfid));

			// loop the other urls
			if (@$_REQUEST["group1"]=="") {
				$_REQUEST["group1"]="any";
			}
			
			if ($_REQUEST["group1"]!="") {
				$i=1;
				while ($i < 25) {
					$field = "";
					if(!empty($_REQUEST["field$i"])){
						$field = $_REQUEST["field$i"];
					}
					$value = "";
					if(!empty($_REQUEST["value$i"])){
						$value = $_REQUEST["value$i"];
					}
					$group = "";
					if(!empty($_REQUEST["group$i"])){
						$group = $_REQUEST["group$i"];
					}
					if ($group) {
						$db->Execute("insert into {$this->funneltablename} (funnelid, label, url, value) values (".$db->Quote($nfid).",".@$db->Quote($field).",".$db->Quote($group).",".$db->Quote($value).")");
					}
					$i++;
				}
				$i++;
			}
		
			$this->Sidepanel();
			
			return "<div style='margin: 3px 5px; float: left; padding: 5px;' class=\"warning ui-state-error ui-corner-all\">"._SAVED."!</div>";
		}
	}

	function DeleteFunnel() {
		global $db;
		$db->Execute("delete from {$this->funneltablename} where funnelid=". $db->Quote($this->funnelid)."") or die ($db->ErrorMsg());
		
		$this->Sidepanel();
		
		return "<div style='margin: 3px 5px; float: left;' class=\"warning ui-state-error ui-corner-all\">"._DELETED_FUNNEL."!</div>";
	}
	
	function Welcome() {
		
		$this->Sidepanel();
		
		echo "<div style=\"float:left;\">";
		echo "<table cellpadding=5 border=0 width=580px >";
		echo "<tr>";
		echo "<td width='480px' valign=top style='line-height:20px;'>";
		echo "<h3 style=\"margin-top:0px;\">"._LOGAHOLIC_FUNNEL_ANALYSIS."</h3>";
		echo _WHAT_IS_FUNNEL ."<P/>";
		echo _CHOOSE_FUNNEL_OR;
		echo "<a href=definereport.php?labels=_FUNNEL_ANALYSIS&funnel=create&conf={$this->profile->profilename}>"._CREATE_NEW_FUNNEL."</a>.";
		echo "</td><td width='100px' valign=top style='border-style : solid; border-width:0px; border-left-width : thin;'>";
		echo "<b>"._WHATS_SALES_FUNNEL."?</b><P>";
		echo _A_SALES_TUNNEL;
		echo "<P>"._EXAMPLE_SALES_FUNNEL.":<p><img src=images/funnelexample.gif>";
		echo "</td></tr></table>";
		echo "</div>";
	}
	
	function Sidepanel() {
		global $db;
		$q = @$db->Execute("select id,label from {$this->funneltablename} where id=funnelid");
		if (!$q) {
			// Probably no table.  When we create a test, we'll create the table.
		}
		echo "<style type='text/css'> body { overflow: hidden!important; } </style>";
		echo "<div style=\"float:left;width:180px;margin-top:2px;border:0px solid red;\">"; 
		$i=0;
		$lastcat=_FUNNEL_ANALYSIS_REPORTS;
		$active=0;

		echo "<div id=\"accordion\"> <h3 class=\"accordion_header_first\"><a href=\"#\">"._FUNNEL_ANALYSIS_REPORTS."</a></h3>";
		echo "<div class=\"reportmenu\"><ul>";    
		$icon = "images/icons/savedtest.gif";
		echo " <li> <a href=\"definereport.php?labels=_FUNNEL_ANALYSIS&conf={$this->profile->profilename}&funnel=create\" class=\"sidelinks\" style=\"background-image: url($icon);\">". _CREATE_NEW_FUNNEL . "</a> </li>";    
		$ii=1;
		while (($q) && ($data=@$q->FetchRow())) {
			if ($lastcat!=$data['label']) {
				$lastcat=$data['label']; 
				echo "</ul></div>";
				echo "<h3 class=\"accordion_header\"><a href=\"#\">".$data['label']."</a></h3>";
				echo "<div class=\"reportmenu\"><ul>";
				$active=$ii++;    
			}

			if (isset($this->funnelid) && $this->funnelid ==$data['id']) { 
				$openactive=$active;
				// $s = "background: #CCFFCC no-repeat left;"; 
				$s="";
			} else {
				$s="";   
			}
			$s1="";
			$s2="";
			$s3="";
			if (isset($this->funnel) && $this->funnel =="edit") { $s2=$s; }
			if (isset($this->funnel) && $this->funnel =="delete") { $s3=$s; }
			
			echo " <li> <a href=\"definereport.php?labels=_FUNNEL_ANALYSIS&conf={$this->profile->profilename}&funnelid=". $data['id'] . "&funnel=edit\" class=\"sidelinks\" style=\"$s2 background-image: url($icon);\">". _EDIT . "</a> </li>";    
			echo " <li> <a href=\"definereport.php?labels=_FUNNEL_ANALYSIS&conf={$this->profile->profilename}&funnelid=". $data['id'] . "&funnel=delete\" class=\"sidelinks\" style=\"$s3 background-image: url(images/icons/delete.gif);\">". _DELETE . "</a> </li>";    


			$i++;
		}

		echo "</ul></div></div>";
		echo "</div>";

		echo "<script type=\"text/javascript\">";
		if (@$openactive) {
		?>
		function openaccordion() {
		/*alert(<?php echo ($openactive); ?>);*/
		$("#accordion").accordion('activate', <?php echo ($openactive); ?>);         
		}
		<?php
		} else {
			echo "function openaccordion() { /* alert('no openactive'); $(\"#accordion\").accordion('activate', 0);*/ }";
		}

		echo "</script>";
	}
	
	function DefineReport() {
		
		if(!isset($this->funnel)){
			$this->Welcome();
			return false;
		}
		if ($this->funnel=="save") {
			$message = $this->SaveFunnel();
			if (isset($this->funnelid)) { $funnel="edit"; }
		} else if ($this->funnel=="delete") {
			$message = $this->DeleteFunnel();
		}
		if ($this->funnel=="") {
			$this->Welcome();
		} else if ($this->funnel=="create" || $this->funnel=="edit") {
			$this->EditFunnel();
		} else if ($this->funnel=="report") {
			if (!$this->funnelid) {
				$this->Welcome();
			}
		}
		
		if(isset($message)) {
			echo $message;
		}
	}
	
	function UpdateStats() {
		return false;
	}
}
?>