<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays athe mobile agents
*/
$reports["_MOBILE_DEVICES"] = Array(
	"ClassName" => "MobileDevices", 
	"Category" => "_CLIENT_SYSTEM", 
	"icon" => "images/icons/32x32/mobileuseragents.png",
	"Options" => "daterangeField,profileselector,limit,columnSelector",
	"Filename" => "mobile_devices",
	"Distribution" => "Premium",
	"Order" => 10,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true,
	"Update" => false
);

class MobileDevices extends Report {

	function Settings() {
		$this->columnDefinitions = $this->GetColumnDefs();
	}

	function GetColumnDefs(){
		return array(
			array("Label" => "_DEVICE")
			,array("Label" => "_VISITS")
			,array("Label" => "_PAGEVIEWS")
		);
	}

	function AddDeviceImage($device){
		$img = $device;
		if($device == "iPod"){
			$img = "<img src='images/devices/device_ipod.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if($device == "iPad"){
			$img = "<img src='images/devices/ipad.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if($device == "unknown"){
			$img = "<img src='images/devices/unknown_device.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if($device == "iPhone"){
			$img = "<img src='images/devices/device_iphone.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if($device == "Android"){
			$img = "<img src='images/devices/device_android.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if($device == "Zune"){
			$img = "<img src='images/devices/device_zune.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if($device == "Symbianos"){
			$img = "<img src='images/devices/mobile-symbian-os.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if($device == "BlackBerry"){
			$img = "<img src='images/devices/device_blackberry.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if($device == "Nokia"){
			$img = "<img src='images/devices/device_nokia.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		else if(strpos($device, "SAMSUNG") !== false){
			$img = "<img src='images/devices/Samsung-Wave-525.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}else{
			$img = "<img src='images/devices/unknown_device.png' style='float:left;' /><p style='margin-left:10px; width:150px;'>$device</p>";
		}
		return $img;
	}
	function DisplayReport(){
		$d = $this->GetReportData();
		$data = array();		
		foreach($d as $k => $v){			
			
				$v[0] = $this->AddDeviceImage($v[0]);
				$data[] = $v;
		}
		$this->Table($data);
	}
	
	function GetReportData(){
		global $reports;
		$r = new $reports["_MOBILE_AGENTS"]["ClassName"]();
		$r->columnDefinitions = $this->GetColumnDefs();
		$r->sort_order = SORT_DESC;
		$r->sort_key = 0;
		$r->key_col = 4;
		$r->createDataFiles($this->from,$this->to);	
		$data = $r->GetDataFromFiles($r->DataFiles($this->from,$this->to));
		
		$newdata = array();
		
		foreach($data as $k => $v){
			if(empty($v[4])){ continue; }
			$newdata[$v[4]][0] = $v[4];
			$newdata[$v[4]][1] = $v[0] + @$newdata[$v[4]][1];
			$newdata[$v[4]][2] = $v[6] + @$newdata[$v[4]][2];
		}
		
		return $newdata;
	}
	
	function UpdateStats() {
		return false;		
	}
}
?>
