<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report lets you make split test of your pages and gives you an overview of wich one works the best.
*/
$reports["_SURVEYS"] = Array(
	"ClassName" => "Surveys", 
	"Category" => "_VISITOR_DETAILS",
	"icon" => "images/icons/32x32/surveys.png",
	"Options" => "daterangeField",
	"Filename" => "surveys",
	"Distribution" => "Premium",
	"Order" => 14,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => false,
	"Update" => false
);

class Surveys extends Report {

	function Settings(){
		global $db;
		$this->surveytablename=$this->profile->tablename."_surveys";
		$this->surveytablename_questions=$this->profile->tablename."_surveyquestions";
		$this->surveytablename_results=$this->profile->tablename."_surveyresults";
		
		if(!isset($this->surveyid)){ 
			$this->surveyid = 0; 
		} else if(!is_numeric($this->surveyid)){
			$this->surveyid = 0;
		}

		$this->fileNameExpension .= ".{$this->surveyid}";
		
		$this->SurveyTables();
	}
	
	function SurveyTables(){
		global $db;		
		if (!CheckIfTableExists($this->surveytablename)) {
			@$db->Execute("DROP TABLE {$this->surveytablename}"); # Remove to be sure it is not here when you try to add

			$db->Execute("CREATE TABLE {$this->surveytablename} (id int(11) NOT NULL auto_increment,surveyname varchar(255) NOT NULL default 'New Survey',
			surveydesc text, surveyoptions text,
			status int(1) default '1' , PRIMARY KEY (id) ) ENGINE=MyISAM CHARSET=utf8");
		}
		if (!CheckIfTableExists($this->surveytablename_questions)) {
			@$db->Execute("DROP TABLE {$this->surveytablename_questions}"); # Remove to be sure it is not here when you try to add

			$db->Execute("CREATE TABLE {$this->surveytablename_questions} (id int(11) NOT NULL auto_increment, surveyid int(11) NOT NULL default '0',
			question blob,
			question_rule blob,
			question_type varchar(255),
			question_order int(3),
			answer_rule blob, PRIMARY KEY  (id) ) ENGINE=MyISAM CHARSET=utf8");
		}
		if (!CheckIfTableExists($this->surveytablename_results)) {
			@$db->Execute("DROP TABLE {$this->surveytablename_results}"); # Remove to be sure it is not here when you try to add
			
			$db->Execute("CREATE TABLE {$this->surveytablename_results} (id int(11) NOT NULL auto_increment,
			surveyid int(10) NOT NULL default '0',
			visitorid varchar(32) NOT NULL default '0',
			timestamp int(11) NOT NULL default '0',
			questionid int(10) NOT NULL default '0',
			answer varchar(255) NOT NULL default '0' , PRIMARY KEY  (id) ) ENGINE=MyISAM CHARSET=utf8");
			$db->Execute("ALTER TABLE {$this->surveytablename_results} ADD INDEX {$this->surveytablename_results}_answer (answer)");
			$db->Execute("ALTER TABLE {$this->surveytablename_results} ADD INDEX {$this->surveytablename_results}_timestamp (timestamp)");
			$db->Execute("ALTER TABLE {$this->surveytablename_results} ADD INDEX {$this->surveytablename_results}_surveyid (surveyid)");			
		}
	}
	
	function DisplayCustomForm(){
		global $db, $session;
		
		$q = $db->Execute("select * from {$this->surveytablename} order by id asc");
		echo "<select class='report_option_field' name='surveyid'>";
		while (($q) && ($data=$q->FetchRow())) {
			if(!empty($this->surveyid) && $this->surveyid == $data["id"]){
				$selected = "selected='selected'";
			} else {
				$selected = ""; 
			}
			echo "<option $selected value='{$data["id"]}' >{$data["surveyname"]}</option>";
		} 
		echo "</select>";
		
		if($session->canEditProfiles()){
			echo "<a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS' target='_blank' class='optionlink open_iframe_window'>". _CREATE_EDIT_SURVEY ."</a><br/>";
		}
	}
	function GetReportData(){
		global $db;
		
		$import = array();
		if(empty($this->surveyid)){ 
			$q = $db->Execute("select id from {$this->surveytablename} order by id asc limit 1");
			while (($q) && ($data=$q->FetchRow())) {
				$this->surveyid = $data["id"];
			}
			if(empty($this->surveyid)){
				$this->surveyid = 0;
			}
		}
		$q = $db->Execute("select * from {$this->surveytablename_questions} where surveyid=". $db->Quote($this->surveyid));
		while (($q) && ($data=@$q->FetchRow())) {
			$query="select q.question, q.question_type as type, r.answer,count(r.visitorid) as r, count(distinct r.visitorid) as v from {$this->surveytablename_results} as r, {$this->surveytablename_questions} as q where r.surveyid=". $db->quote($this->surveyid) ." and (timestamp >=". $db->quote($this->from) ." and timestamp <=". $db->quote($this->to) .") and q.id=r.questionid and r.questionid=". $db->quote($data["id"]) ." group by r.answer order by r desc"; 
			
			$q2 = $db->Execute($query);
			$i = 0;
			while (($q2) && ($data2=@$q2->FetchRow())) {
				$import[$data2["question"]]["type"] = $data2["type"];
				$import[$data2["question"]][$data2["answer"]]["visitors"] = $data2["r"];
				$import[$data2["question"]][$data2["answer"]]["unique_visitors"] = $data2["v"];
			}
		}
		return $import;
	}
	function reportStyling(){ ?>
		<style>
			.survey_table_header{ cursor:pointer; background: url("images/gradient_bg_grey.png") repeat-x scroll left top transparent; color: #333333; font-size: 13px; margin: 0; padding: 10px 5px 5px; }
			.survey_div{float:left; width:100%; }
		</style>
	<?php
	}
	function DisplayReport(){
		$data = $this->GetReportData();
		$this->addlabel = $this->GetSurveyName();
		$this->displayReportButtons = false;
		$this->ReportHeader();
		if(empty($data)){ echoNotice(_NO_DATA_TO_DISPLAY,"margin:5px;"); }
		$this->displayHeader = false;
		$this->displayReportButtons = false;
		$this->columnDefinitions[] = array("Label" => "Answer");
		$this->columnDefinitions[] = array("Label" => "Visitors");
		$this->columnDefinitions[] = array("Label" => "Unique Visitors");
		$this->setupColumnDefinitions();
		
		$r = 0;
		foreach($data as $question => $answers){			
			$d = array();
			$i = 0;
			foreach($answers as $k => $v){
				if($k != "type"){
					$d[$i][0] = $k;
					$d[$i][1] = $v["visitors"];
					$d[$i][2] = $v["unique_visitors"];
					$i ++;
				}
			}			
			echo "<div class='survey_div'>";
			echo "<h2 class='survey_table_header' rel='$r'>Question: $question</h2>";			
			echo "<div class='survey_table$r'>";
			
			if($answers["type"] == "single"){				
				$this->PieChart($d);
			}	
			if($answers["type"] == "multiple"){
				$this->Table($d);
			}
			if($answers["type"] == "open"){
				$this->columnDefinitions = array();
				$this->columnDefinitions[] = array("Label" => "Answer");
				$this->columnDefinitions[] = array("Label" => "Unique Visitors");
				$this->setupColumnDefinitions();
				
				$this->Table($d);
			}
			echo "</div>";
			echo "</div>";
			$r ++;
		}
		$this->reportStyling();
	}
	function Toppanel() {
		global $db;
		$q = @$db->Execute("select id,surveyname from {$this->surveytablename} where status=1");
		if (!$q) {
			// Probably no table.  When we create a test, we'll create the table.
		}		
		echo "<div id='toppanel'>";
			echo "<ul>";
				echo "<li><a class='surveysBtn' href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=surveyoverview'>". _SURVEYS ."</a>";
				echo "</li>";
				
				echo "<li><a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=createsurvey'>". _ADD_SURVEY ."</a>";
				echo "</li>";
				if(!empty($this->surveyid)){
					echo "<li><a class='questionsBtn' href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=questionsoverview&surveyid={$this->surveyid}'>". _QUESTIONS ."</a>";
					echo "</li>";
					echo "<li><a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=createquestion&surveyid={$this->surveyid}'>". _ADD_QUESTION ."</a>";
					echo "</li>";					
					echo "<li><a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=preview&surveyid={$this->surveyid}'>". _PREVIEW ."</a>";
					echo "</li>";					
					echo "<li><a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=publish&surveyid={$this->surveyid}'>". _PUBLISH ."</a>";
					echo "</li>";
				}				
			echo "</ul>";
			if(!empty($this->surveyid)){
				echo "<div id='surveystat'>";
					echo "<b>".$this->GetSurveyName() . "</b> ";
					echo "
					<a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=deletesurvey&surveyid=". $this->surveyid ."' ><img style='float:right; padding:0 5px;' src='images/icons/16x16/window-close-2.png' alt='' title='". _DELETE_SURVEY ."' /></a> | <a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=editsurvey&surveyid=". $this->surveyid ."' ><img style='float:right; padding:0 0 0 5px;' src='images/icons/edit.gif' alt='' title='". _EDIT_SURVEY ."' /></a>";
				echo "</div>";
			}
		echo "</div>";
		
		echo "<div class='surveys'>";
		echo "<ul>";
		$i=0;
		while (($q) && ($data=@$q->FetchRow())) {
			echo "<li><a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&surveyid=". $data['id'] . "&action=questionsoverview'>({$data['id']}) {$data["surveyname"]}</a></li>";
			$i++;
		}
		if ($i==0) {
			echo "<li><a>". _NONE ."</a></li>";
		}
		echo "</ul>";
		echo "</div>";
		
		if(!empty($this->surveyid)){
			$q = $db->Execute("select id, question from {$this->surveytablename_questions} where surveyid = {$this->surveyid} order by question_order, id");
			echo "<div class='questions'>";
			echo "<ul>";
			$i=0;
			while (($q) && ($data=@$q->FetchRow())) {
				echo "<li><a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&questionid=". $data['id'] . "&action=editquestion&surveyid={$this->surveyid}'>({$data['id']}) ".$data['question']."</a></li>";
				$i++;
			}
			if ($i==0) {
				echo "<li><a>". _NONE ."</a></li>";
			}
			echo "</ul>";
			echo "</div>";
		}
	}
	function styling(){		
		?>
		<script type="text/javascript">
			$(document).ready( function(){
				$(".surveysBtn").live({
					mouseenter: function() {
						$(".surveys").css("display","block");
					},
					mouseleave: function() {
						$(".surveys").css("display","none");
						$(".surveys").live({
							mouseenter: function() {
								$(".surveys").css("display","block");
							},
							mouseleave: function() {
								$(".surveys").css("display","none");
							}
						});
					}
				});				
				$(".questionsBtn").live({
					mouseenter: function() {
						$(".questions").css("display","block");
					},
					mouseleave: function() {
						$(".questions").css("display","none");
						$(".questions").live({
							mouseenter: function() {
								$(".questions").css("display","block");
							},
							mouseleave: function() {
								$(".questions").css("display","none");
							}
						});
					}
				});						
				$("#answer_type").live("change", function(){
					type = $(this + "option:selected").attr("name");
					if(type != "open"){
						$("#answersrow").css("display","");
					}else{
						$("#answersrow").css("display","none");
					}
					if(type == "single"){
						$(".answersetttings").css("display","");
					}else{
						$(".answersetttings").css("display","none");
					}
				});
				$(".answersetttings").live("click", function(){
					$("#settingsform").css("display","block");
					$(".settingsform_selector").attr("rel",$(this).attr("rel"));
					$(".settingsform_input").attr("rel",$(this).attr("rel"));
					$(".add_other_field").attr("rel",$(this).attr("rel"));

					var labl = '<?php echo _ANSWER_X_SETTINGS; ?>';
					labl = labl.replace('%X%', $(this).attr("rel"));

					$(".settingsform_header").html(labl);					
					
					if($(this).attr("value").indexOf( "url:" ) !== -1 ){
						$("#linkquestions").css("display","none");
						$('.settingsform_selector option')[1].selected = true;
						$(".settingsform_input").css("display","block");
						set_url = $(this).attr("value").replace("url:","");
						$(".settingsform_input").attr("value",set_url);						
					}if($(this).attr("value").indexOf( "url:" ) !== -1 ){
						$("#linkquestions").css("display","none");
						$('.settingsform_selector option')[1].selected = true;
						$(".settingsform_input").css("display","block");
						set_url = $(this).attr("value").replace("url:","");
						$(".settingsform_input").attr("value",set_url);						
					}else if($(this).attr("value").indexOf( "link (" ) !== -1 ){
						$(".settingsform_input").css("display","none");
						$('.settingsform_selector option')[2].selected = true;
						$("#linkquestions").css("display","block");
						set_opt = $(this).attr("value").replace("link (","");
						set_opt = set_opt.split(")");
						$("#linkquestions option").each(function () {
							if($(this).attr("rel") == set_opt[0]){
								$(this).attr("selected","selected");
							}
						});
					}else if($(this).attr("value").indexOf( "default" ) !== -1 ){
						$(".settingsform_input").css("display","none");
						$("#linkquestions").css("display","none");
						$('.settingsform_selector option')[0].selected = true;
					}

					
					
					if($("#addtext"+$(this).attr("rel")).attr("value") == "block"){
						$(".add_other_field").attr('checked', true);
					}else{
						$(".add_other_field").attr("checked", false);
					}
				});
				
				
				$(".settingsform_close").live("click", function(){
					$("#settingsform").css("display","none");
				});
				$(".settingsform_selector").live("change", function(){
					sel = $(".settingsform_selector option:selected").attr("name");
					if(sel == "url"){
						$(".settingsform_input").css("display","block");
						$("#settings"+$(".settingsform_selector").attr("rel")).attr("value","url: ");
					}else{
						$(".settingsform_input").css("display","none");
					}
					if(sel == "default"){
						$("#settings"+$(".settingsform_selector").attr("rel")).attr("value","default");
					}
					if(sel == "end"){
						$("#settings"+$(".settingsform_selector").attr("rel")).attr("value","To End");
					}
					if(sel == "link"){
						linkid = $("#linkquestions option:selected").attr("rel");
						linkval = $("#linkquestions option:selected").attr("value");
						$("#linkquestions").css("display","block");
						$("#settings"+$(".settingsform_selector").attr("rel")).attr("value","link ("+linkid+") "+linkval);
						
					}else{
						$("#linkquestions").css("display","none");
					}
				});
				$(".settingsform_input").keyup( function(event){
					c = $(".settingsform_input").attr("rel");
					v = $(".settingsform_input").attr("value");
					$("#settings"+c).attr("value","url: "+v);
				});
				$("#linkquestions").live("change", function(){
					linkid = $("#linkquestions option:selected").attr("rel");
					linkval = $("#linkquestions option:selected").attr("value");
					$("#settings"+$(".settingsform_selector").attr("rel")).attr("value","link ("+linkid+") "+linkval);
				});
				$(".add_other_field").live("click", function(){
					if($(this).is(":checked") == true){
						$("#addtext"+$(this).attr("rel")).attr("value","block");
					}else{
						$("#addtext"+$(this).attr("rel")).attr("value","none");
					}
				});
			});
		</script>
		<style>
			.break{ float:left; width:100%; height:50px; }
			
			.surveys{ display:none; position:fixed; min-width:150px; left:0; z-index:55; font-size:11px; border: 1px solid #DCDBDB; background:#ffffff; top:33px;}
			.surveys ul{ list-style:none; padding:0; margin:0; }
			.surveys ul li{ list-style:none; background:#ffffff; float:none; border-right: 1px solid #DCDBDB; }
			.surveys ul li a{ color: #3E3E3E; display: block; margin: 0; padding: 9px 10px; text-decoration: none; border-bottom: 1px solid #DCDBDB; }
			.surveys ul li a:hover{ cursor:pointer; background: #CCC!important;}
			
			.questions{ display:none; position:fixed; min-width:150px; left:0; z-index:55; font-size:11px; border: 1px solid #DCDBDB; background:#ffffff; top:33px; left:141px;}
			.questions ul{ list-style:none; padding:0; margin:0; }
			.questions ul li{ list-style:none; background:#ffffff; float:none; border-right: 1px solid #DCDBDB; }
			.questions ul li a{ color: #3E3E3E; display: block; margin: 0; padding: 9px 10px; text-decoration: none; border-bottom: 1px solid #DCDBDB;}
			.questions ul li a:hover{ cursor:pointer; background: #CCC!important;}			
			
			#toppanel{ position:fixed; width:99%; left:0; z-index:55; font-size:11px; border: 1px solid #DCDBDB; background:#ffffff; top:0px;}
			#toppanel ul{ list-style:none; padding:0; margin:0; }
			#toppanel ul li{ list-style:none; background:#ffffff; float:left; border-right: 1px solid #DCDBDB; }
			#toppanel ul li a{ color: #3E3E3E; display: block; margin: 0; padding: 9px 10px; text-decoration: none; }
			#toppanel ul li a:hover{ cursor:pointer; background: #CCC!important;}
			#surveyscontent{ border: 1px solid #DCDBDB; float: left; width: 97%; padding:10px;}
			#surveyscontent a{ color:#000000; text-decoration:none;}
			#surveyscontent a:hover{ color:#000000; text-decoration:underline; }
			
			#surveystat{ float:right; margin:8px; font-size:11px; }
			.survey_options { font-size:11px; list-style-type:none; padding:0px; margin:5px 0 0 0;}
			.survey_options li{ float:left; padding:0 1px;}
			.answersetttings{ cursor:pointer; border-bottom:1px solid #000 !important; }
			#settingsform{ margin: 130px 0 0 500px; position: fixed; padding:5px; background:#FFFFFF;}
			.settingsform_header{ margin: 2px; text-align: center; font-weight:bold; }
			.settingsform_close{ cursor:pointer; text-decoration:underline; text-align:center; margin:0px;}
			
			.overview_header{ padding:0px; margin:0; font-format:16px; }
			.overview_header a{ color:#000000; text-decoration:none;}
			.overview_header a:hover{ color:#000000; text-decoration:underline; }
			
			.overview a{ color:#000000; text-decoration:underline; }
			.overview{ padding:10px; margin:5px 0 0 0; font-format:12px; border: 1px dotted #DCDBDB; }
		</style><?php
	}
	function DefineReport() {
		if(!isset($this->action)){
			$this->action = "";
		}
		$this->styling();
		
		echo "<div class='break'></div>";
		echo "<div id='surveyscontent'>";
		switch($this->action){
			case "":
				$this->Welcome();
			break;
			case "orderlist":
				$this->ReorderQuestions(stdToAssoc(json_decode($_REQUEST['orderlist'])));
			break;
			case "surveyoverview":
				$this->ListSurveys();
			break;
			
			case "createsurvey":
				$this->CreateSurvey();
			break;
			
			case "deletesurvey":
				$this->DeleteSurvey();
			break;
			
			case "saveSurvey":
				$this->Save();
				$this->edit = 0;
				$this->CreateQuestion();
			break;
			
			case "savequestion":
				$this->RewriteAnswerRules();
				$this->RewriteQuestionRules();
				$this->Save();
				$this->edit = 0;
				$this->CreateQuestion();
			break;
			
			case "editsurvey":
				$this->edit = 1;
				$this->CreateSurvey();
			break;
			
			case "editquestion":			
				$this->edit = 1;
				$this->CreateQuestion();
			break;
			
			case "deletequestion":
				$this->DeleteQuestion();
			break;
			
			case "questionsoverview":
				$this->ListQuestions();
			break;			
			
			case "createquestion":
				$this->CreateQuestion();
			break;
			
			case "preview":
				$this->SurveyDialog();
			break;
			case "nextquestion":
				$this->NextQuestion();
			break;
			
			case "publish":
				$this->Publish();
			break;
			case "download":
				$this->Download();
			break;
		}
		echo "</div>";		
		$this->Toppanel();
	}
	function RewriteAnswerRules(){
		$rules = array();
		$i = 0;
		foreach($_REQUEST as $k => $v){
			$a = strpos($k,'cvalue');
			if($a !== false){
				$rules[$i]["answer"] = $v;
			}
			$o = strpos($k,'addtext');
			if($o !== false){
				$rules[$i]["otherBox"] = $v;
				$i ++;
			}
			$s = strpos($k,'settings');
			if($s !== false){
				$rules[$i]["otherBox"] = "";
				$rules[$i]["default"] = "";
				$rules[$i]["url"] = "";
				$rules[$i]["link"] = "";
				$rules[$i]["end"] = "";
				$rules[$i]["code"] = "";
				
				
				if(strpos($v,'default') !== false){
					$rules[$i]["default"] = 1;
				}
				if(strpos($v,'End') !== false){
					$rules[$i]["end"] = 1;
				}
				if(strpos($v,'url:') !== false){
					$v = str_replace("url: ","",$v);
					$rules[$i]["url"] = $v;
				}
				if(strpos($v,'link (') !== false){
					$v = str_replace("link (","",$v);
					$v = explode(")",$v);
					$v = $v[0];
					$rules[$i]["link"] = intval($v);
				}
				if(strpos($v,'code:') !== false){
					$v = str_replace("code:","",$v);
					$rules[$i]["code"] = $v;
				}
				
			}
		}
		
		$_REQUEST["answer_rule"] = json_encode($rules);
	}
	function Publish() {
		global $db,$lang;
		$q = $db->Execute("SELECT * FROM {$this->surveytablename} WHERE id='{$this->surveyid}'");
		while (($q) && ($data=$q->FetchRow())) {
			$opts = json_decode($data["surveyoptions"],true);
			echo "<h3>". _PUBLISH ."</h3>";
			echo "<p>". _PUBLISH_SURVEY_DESC ."</p>";
			echo "<textarea readonly cols='100'>"; 
				echo "<iframe src='".Logaholic_URL()."/doSurvey.php?conf={$this->profile->profilename}&labels=_SURVEYS&lang={$lang}&surveyid={$this->surveyid}&opts={$opts["link"]}' ></iframe>";
			echo "</textarea>";
		}
	}
	function RewriteQuestionRules(){
		$question_rules = '$answers = array(';
		$i = 0;
		foreach($_REQUEST as $k => $v){
			$a = strpos($k,'cvalue');
			if($a !== false){
				if($i == 0){
					$question_rules .= "'".addslashes($v)."'";
				}else{
					$question_rules .=','."'".addslashes($v)."'";
				}				
				$i = 1;
			}			
		}
		$question_rules .= ');';
		
		$question_rules .= '$answers_opts = array(';
		$i = 0;
		foreach($_REQUEST as $k => $v){
			$a = strpos($k,'addtext');
			if(empty($v)){
				$v = "none"; 
			}
			if($a !== false){
				if($i == 0){
					$question_rules .= "'$v'";
				}else{
					$question_rules .=','."'$v'";
				}				
				$i = 1;
			}			
		}
		$question_rules .= ');';
		
		if($_REQUEST["answer_type"] == "single"){
			$question_rules .= '$this->single_answers($answers,$answers_opts);';
		}elseif($_REQUEST["answer_type"] == "multiple"){
			$question_rules .= '$this->multiple_answers($answers,$answers_opts);';		
		}elseif($_REQUEST["answer_type"] == "open"){
			$question_rules .= '$this->open_answer();';
		}
		$_REQUEST["question_rule"] = $question_rules;
	}
	
	function DeleteSurvey() {
		global $db;
		$db->Execute("delete from {$this->surveytablename} where id=". $db->Quote($this->surveyid)) or die ($db->ErrorMsg());
		$db->Execute("delete from {$this->surveytablename_questions} where surveyid=". $db->Quote($this->surveyid)) or die ($db->ErrorMsg());
		$db->Execute("delete from {$this->surveytablename_results} where surveyid=". $db->Quote($this->surveyid)) or die ($db->ErrorMsg());
		echo "Deleted Survey information ..<br>";
		echo "Deleted Survey questions ..<br>"; 
		echo "Deleted Survey results ..<br>";  
		echo "Done!";
		$this->surveyid = "";
	}
	
	function DeleteQuestion() {
		global $db;    
		$db->Execute("delete from {$this->surveytablename_questions} where id=". $db->Quote($_REQUEST['questionid'])) or die ($db->ErrorMsg());
		echo "Done!";
	}
	
	function CreateQuestion(){
		global $db;
		
		$data["a_type"] = "single";
		if($this->action == "editquestion"){
			$data = $this->getQuestionData();
			$data["answer_rule"] = json_decode($data["answer_rule"],true);
		}
		if(empty($data["question_order"])) {
			$q = $db->Execute("SELECT COUNT(*) AS amount_of_questions FROM {$this->surveytablename_questions} WHERE surveyid = {$this->surveyid}");
			$amount = $q->FetchRow();
			
			$data["question_order"] = $amount[0];
		}
		$selected = "";
		echo "<div style=\"float:left;\"><form name=editor method=POST action='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&surveyid={$this->surveyid}'><table cellpadding=6 cellspacing=0 width=500 border=0><tr><td colspan=2><font size=3><b>". _ADD_QUESTION_TO .": ".$this->GetSurveyName()."</b></font></td></tr>";
		echo "<tr><td colspan=2>". _ADD_QUESTION_TO_DESC ."</td></tr>";
		echo "<tr><td>". _QUESTION .":</td><td><input type=text name=question size=60 value=\"".@$data["question"]."\"></td></tr>";
		echo "<tr><td>". _QUESTION_ORDER .":</td><td><input type=text name=question_order size=3 value=\"".@$data["question_order"]."\"></td></tr>";
		echo "<tr><td>". _TYPE .":</td><td><select id='answer_type' name='answer_type'>";
			
			if($data["a_type"] == "single"){ $selected = "selected='selected'"; }else{ $selected = "";}
			echo "<option name='single' value='single' $selected>". _SINGLE_ANSWER ."</option>";
			if($data["a_type"] == "multiple"){ $selected = "selected='selected'"; }else{ $selected = "";}
			echo "<option name='multiple' value='multiple' $selected>". _MULTIPLE_ANSWERS ."</option>";
			if($data["a_type"] == "open"){ $selected = "selected='selected'"; }else{ $selected = "";}
			echo "<option name='open' value='open' $selected>". _OPEN_ANSWERS ."</option>";
		echo "</select></td></tr>";
		if($data["a_type"] == "open"){ $style= "style='display:none;'"; }else{ $style=""; }
		echo "<tr id='answersrow' $style><td>". _ANSWERS .":</td><td>";
			$condition_options = array();
			if(!empty($data["answers"])){
				foreach($data["answers"] as $option => $val) {
					$condition_options['cvalue'][] = $val;
				}
			}
			$form_id = md5(time());
			$form = "<script type='text/javascript'>plusMinusForm('{$form_id}','cvalue','settings','addtext');</script>";
			$form .= "<div id='{$form_id}'>";
				if(count($condition_options) == 0) {
					$form .= "<div class='conditions_row'>";
					$form .= "<input style='width: 175px;' src='cvalue' rel='1' name='cvalue1' id='cvalue1' value=\"\" autocomplete='off'>";
					$form .= "<input style='width: 25px; margin: 0; padding: 0;' type='button' class='plus_btn' value=' + ' /><input style='width: 25px; margin: 0; padding: 0;' type='button' class='min_btn' value=' - ' disabled='disabled' />";
						$form .= "<input style='border:0px;' src='settings' readonly class='answersetttings' type='text' value='default' id='settings1' name='settings1' rel='1' />";
						$form .= "<input type='hidden' id='addtext1' name='addtext1' rel='1' value='none' />";
					$form .= "</div>";
				} else {
					for($c = 0; $c < count($condition_options['cvalue']); $c++) {
						$set = "default";
						if(!empty($data["answer_rule"][$c]["url"])){ $set = "url: " . $data["answer_rule"][$c]["url"]; }
						if(!empty($data["answer_rule"][$c]["link"])){ $set = "link ({$data["answer_rule"][$c]["link"]})"; }
						$form .= "<div class='conditions_row'>";
							$form .= "<input style='width: 175px;' src='cvalue' rel='".($c + 1)."' name='cvalue".($c + 1)."' id='cvalue".($c + 1)."' value=\"".stripslashes($condition_options['cvalue'][$c])."\" autocomplete='off'>";
							$form .= "<input style='width: 25px; margin: 0; padding: 0;' type='button' class='plus_btn' value=' + ' /><input style='width: 25px; margin: 0; padding: 0;' type='button' class='min_btn' value=' - ' />";
							$form .= "<input readonly src='settings' class='answersetttings' rel='".($c + 1)."' type='text' value='$set' id='settings".($c + 1)."' name='settings".($c + 1)."' style='border:0px;";
							if($data["a_type"] != "single"){ $form .=  " display:none;"; }
							$form .= "'/>";
							$form .= "<input type='hidden' src='addtext' id='addtext".($c + 1)."' name='addtext".($c + 1)."' rel='".($c + 1)."' value='".@$data["options"][$c]."' />";
						$form .= "</div>";
					}
				}
				echo $form;
		echo "</td></tr>";
		if(!empty($this->edit) && $this->edit == 1){
			echo "<input type=hidden name=edit value=\"1\">";
			echo "<input type=hidden name=questionid value=\"{$this->questionid}\">";
		}
		echo "<tr><td><input type=submit value='". _SAVE_QUESTION ."'><input type=hidden name=surveyid value=\"{$this->surveyid}\"><input type=hidden name=surveyname value=\"".$this->GetSurveyName()."\"><input type=hidden name=action value=\"savequestion\"><input type=hidden name=conf value=\"{$this->profile->profilename}\"></td></tr></table>";
		echo "</form></div>";
		$this->aSettings();
	}
	
	function aSettings(){
		global $db;
		echo "<div id='settingsform' style='display:none;' class='smallborder'>";
			echo "<p class='settingsform_header'></p>";
			echo "<select class='settingsform_selector' rel=''><option name='default'>". _NEXT_QUESTION ." (". _DEFAULT .")</option><option name='url'>". _LINK_TO_URL ."</option><option name='link'>". _LINK_TO_QUESTION ."</option><option name='end'>". _LINK_TO_END ."</option></select>";
			echo "<input rel='' class='settingsform_input' style='display:none;  margin:7px 0 0 0;' value='' />";
			echo "<select id='linkquestions' style='display:none; margin:7px 0 0 0;'>";
			$q = $db->Execute("SELECT id,question FROM {$this->surveytablename_questions} where surveyid={$this->surveyid} order by question_order, id");
			while (($q) && ($data=$q->FetchRow())) {
				if($this->questionid != $data["id"]){
					echo "<option rel='{$data["id"]}'>{$data["question"]}</option>";
				}
			}
			echo "</select></br/>";
			echo "<input type='checkbox' rel='' class='add_other_field' />". _ADD_INPUT_WHEN_SELECTED ."<br/>";
			echo "</br/><p class='settingsform_close'>". _CLOSE ."</p>";
		echo "</div>";
	}
	
	function getSurveyData(){
		global $db;
		$q = $db->Execute("select * from {$this->surveytablename} where id='{$this->surveyid}'");
		while (($q) && ($data=$q->FetchRow())) {
			return $data;
		}
	}
	
	function getQuestionData(){
		global $db;
		$q = $db->Execute("select * from {$this->surveytablename_questions} where id={$_REQUEST['questionid']}");
		while (($q) && ($data=$q->FetchRow())) {
			if(!empty($data["question_rule"])){
				$answers = $data["question_rule"];				
				$answers = explode('\');$this->',$answers);				
				$a_type = $answers[1];				
				$answers = explode('\');$answers_opts = array(\'',$answers[0]);
				$answers_arr = str_replace('$answers = array(\'','',$answers[0]);
				$answers_arr = explode("','",$answers_arr);
				$answers_opts = explode("','",$answers[1]);
				$data["answers"] = $answers_arr;
				$data["options"] = $answers_opts;
				$a_type =explode("_answer",$a_type);
				$a_type = $a_type[0];
				$data["a_type"] = $a_type;
			}
			return $data;
		}
	}
	
	function CreateSurvey() {		
		if($this->action == "editsurvey"){
			$data = $this->getSurveyData();
			$opts = json_decode($data["surveyoptions"],true);
			$data["csslink"] = $opts["link"];
			$data["csscustom"] = $opts["custom"];
		}
		
		echo "<div><table cellpadding=6 cellspacing=0 width=740 border=0><tr><td colspan=3><font size=3><b>". _CREATE_NEW_SURVEY ."</b></font></td></tr>";
		echo "<tr><td colspan=3><ul><li>". _NEW_SURVEY_STEP_1;
		echo "<li>". _NEW_SURVEY_STEP_2;
		echo "<li>". _NEW_SURVEY_STEP_3 ."</ul><P>";  
		echo _LETS_START_SURVEY . "<hr noshade size=1>";
		echo "<form method=POST action='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS'></td></tr>";
		echo "<tr><td>". _SURVEY_NAME ."</td><td><input type=text size=35 name=surveyname maxval=255 value='".@$data["surveyname"]."'></td>";
		echo "<td bgcolor=#e0e0e0>". _SURVEY_NAME_DESC ."</td></tr>";
		echo "<tr><td>". _SURVEY_DESCRIPTION ."</td><td><textarea name=surveydesc cols=30 rows=5 maxval=255>".@$data["surveydesc"]."</textarea></td>";
		echo "<td bgcolor=#e0e0e0>". _SURVEY_DESCRIPTION_DESC ."</td></tr>";
		echo "<tr><td>". _CSS_LINK ."</td><td><input size='35' type='text' value='".@$data["csslink"]."' id='csslink' name='csslink' /></td><td bgcolor=#e0e0e0>". _SURVEY_CSS_DESC .":<br/><ul><li>survey_header</li><li>survey_textarea</li><li>survey_answer</li><li>survey_submit</li><li>survey_question</li><li>survey_form</li></ul></td></tr>";
		echo "<tr><td>". _CUSTOM_CSS ."</td><td><textarea cols=30 rows=5 id='customcss' name='customcss'>".@$data["csscustom"]."</textarea></td><td bgcolor=#e0e0e0></td></tr>";
		echo "</table>";
		if(!empty($this->edit) && $this->edit == 1){
			echo "<input type=hidden name=edit value=\"1\">";
			echo "<input type=hidden name=surveyid value=\"".$this->surveyid."\">";
		}else{
			echo "<input type=hidden name=surveyid value=\"0\">";		
		}
		echo "<input type=submit value="._SAVE."><input type=hidden name=action value=\"saveSurvey\"><input type=hidden name=conf value=\"{$this->profile->profilename}\"></form></div>";
	}
	
	function ListQuestions() {
		global $db, $profile;
		$q = @$db->Execute("select id,question from {$this->surveytablename_questions} where surveyid={$this->surveyid} order by question_order, id");
		
		echo "<div style=\"float:left; margin:10px;\">";
		echo "<h3 class='overview_header'>".$this->GetSurveyName()." ". _QUESTIONS .":</h3>";
		$i=0;
		echo "<ol id='surveyquestions'>";
		while (($q) && ($data=@$q->FetchRow())) {
			echo "<li rel='{$data['id']}' class='overview'><a href=definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&questionid=". $data['id'] . "&action=editquestion&surveyid={$this->surveyid}>". $data['question'] . " (Question ID: {$data['id']})</a> <a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=deletequestion&questionid={$data['id']}' ><img style='float:right; padding-left:5px;' src='images/icons/16x16/window-close-2.png' alt='' title='Delete Question' /></a></li>";
			$i++;
		}
		if ($i==0) {
			echo "<li>". _NONE ."</li>";
		}
		echo "</ol>";
		echo "</div>";
		?>
		<script type="text/javascript">
			$("#surveyquestions li:not(a)").css("cursor", "move");
			$("#surveyquestions").sortable({
				update: function() {
					var orderlist = {};
					var c = 0;
					$("#surveyquestions li").each(function() {
						orderlist[c] = $(this).attr('rel');
						
						c++;
					});
					
					$.ajax({
						url: "definereport.php?labels=<?php echo $this->label_constant; ?>&conf=<?php echo $profile->profilename; ?>&action=orderlist",
						data: {
							orderlist: JSON.stringify(orderlist)
						}
					});
				}
			});
		</script>
		<?php
	}
	
	function ReorderQuestions($new_orderlist = array()) {
		global $db;
		
		foreach($new_orderlist as $key => $val) {
			$query = "UPDATE {$this->surveytablename_questions} SET question_order = {$key} WHERE id = {$val}";
			echo $query."<br/>";
			$db->Execute($query);
		}
	}
	
	function ListSurveys() {
		global $db;
		$q = $db->Execute("select * from {$this->surveytablename} order by id");


		echo "<div style=\"float:left;\"><h2>". _SURVEYS .":</h2>";
		echo "<ol>";
		$i=0;
		while (($q) && ($data=@$q->FetchRow())) {
			echo "<li><h4 class='overview_header'><a href=definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=questionsoverview&surveyid={$data['id']}>". $data['surveyname'] . "</a></h4>"; 
			echo "<p class='overview'>{$data["surveydesc"]}</p>";			
			echo "<ul class='survey_options'><li> <a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=editsurvey&surveyid={$data['id']}' ><img style='float:right; padding:0 0 0 5px;' src='images/icons/edit.gif' alt='' title='Edit Survey' /></a>
					</li><li><a href='definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=deletesurvey&surveyid={$data['id']}' ><img style='float:right; padding:0 5px;' src='images/icons/16x16/window-close-2.png' alt='' title='Delete Survey' /></a></li></ul><br/><br/></li>";
			$i++;
		}
		if ($i==0) {
			echo "<li><p class='overview'>". _NO_SURVEYS_FOUND ."</p></li>";
		}
		echo "</ol>";
		echo "</div>";
	}
	function GetSurveyName() {
		global $db;  
		$q = $db->Execute("select id,surveyname from {$this->surveytablename} where id={$this->surveyid}"); 
		$data=$q->FetchRow();
		return $data[1]; 
	}	
	function Save() {
		global $db;
		if(empty($_REQUEST["surveyid"])){
			$cd=time();
			$ar["custom"] = $_REQUEST["customcss"];
			$ar["link"] = $_REQUEST["csslink"];

			$_REQUEST["surveyoptions"] = json_encode($ar);
			$db->Execute("insert into {$this->surveytablename} (surveyname, surveydesc, surveyoptions) values ('".$_REQUEST["surveyname"]."','".$_REQUEST["surveydesc"]."','".$_REQUEST["surveyoptions"]."')");
			$this->surveyid= $db->Insert_ID();
			return $this->surveyid;  
		} else {
			if (isset($_REQUEST["edit"]) && !empty($_REQUEST["questionid"])) {
				$db->Execute("update {$this->surveytablename_questions} set question=\"".$_REQUEST["question"]."\", question_order=\"".$_REQUEST["question_order"]."\", question_type=\"".$_REQUEST["answer_type"]."\", question_rule=\"".addslashes($_REQUEST["question_rule"])."\", answer_rule=\"".addslashes($_REQUEST["answer_rule"])."\", surveyid=\"{$this->surveyid}\" where id=\"".$_REQUEST["questionid"]."\"") or die ($db->ErrorMsg());
			} else if (isset($_REQUEST["edit"]) && empty($_REQUEST["questionid"])) {
				$ar["custom"] = addslashes($_REQUEST["customcss"]);
				$ar["link"] = $_REQUEST["csslink"];
				$_REQUEST["surveyoptions"] = json_encode($ar);
				$db->Execute("update {$this->surveytablename} set surveyname='".$_REQUEST["surveyname"]."',surveydesc='".$_REQUEST["surveydesc"]."',surveyoptions='".$_REQUEST["surveyoptions"]."' where id='{$this->surveyid}'") or die ($db->ErrorMsg());
			} else {
				// this is where we'll save a question.
				$db->Execute("insert into {$this->surveytablename_questions} set question=\"".$_REQUEST["question"]."\", question_order=\"".$_REQUEST["question_order"]."\", question_type=\"".$_REQUEST["answer_type"]."\", question_rule=\"".addslashes($_REQUEST["question_rule"])."\", answer_rule=\"".addslashes($_REQUEST["answer_rule"])."\", surveyid=\"{$this->surveyid}\"") or die ($db->ErrorMsg());			  
			}
		}
	}
	function Welcome() {
		echo "<P><table width=100% cellpadding=5 border=0><tr><td valign=top style='line-height:20px;'>";
		echo "<h3>". _WELOCME_SURVEY ."</h3>";
		echo _WELOCME_INTRO_SURVEY . "<P>";

		echo "<li> <a href=definereport.php?conf={$this->profile->profilename}&labels=_SURVEYS&action=createsurvey>". _CREATE_NEW_SURVEY ."</a>";                                                                   
		echo "</tr></table>";
	}
	function multiple_answers($answers,$answers_opts) {
		$i = 0;
		foreach ($answers as $answer) {
			echo "<div class='survey_answer'><input id='answer$i' type='checkbox' class='noTextInput' name=\"{$this->questionid}\" value=\"$answer\" />$answer<br/>";
			if(isset($answers_opts[$i]) && $answers_opts[$i] == "block"){
				echo "<input name='other_$answer' id='other' rel='$i' type='text' style='margin-left:20px;' />";
			}
			echo "</div><br/>";
			$i ++;
		}    
	}
	function open_answer() {
		echo "<textarea class='survey_textarea' name=\"{$this->questionid}\" cols=70 rows=8></textarea><br>";       
	}

	function single_answers($answers,$answers_opts) {
		$i = 0;
		foreach ($answers as $answer) {
			echo "<div class='survey_answer'><input id='answer$i' type='radio' class='noTextInput' name=\"{$this->questionid}\" value=\"$answer\" />$answer<br/>";
			if(@$answers_opts[$i] == "block"){
				echo "<input name='other_$answer' id='other' rel='$i' type='text' style='margin-left:20px;' />";
			}
			echo "</div><br/>";     
			$i ++;
		}    
	}
	function SurveyCss(){
		global $db;
		$q = $db->Execute("select surveyoptions from {$this->surveytablename} where id={$this->surveyid}");
		if ($data=$q->FetchRow()) {
			$opts = json_decode($data["surveyoptions"],true);
			if(!empty($opts["link"])){
				echo "<link rel=\"stylesheet\" type=\"text/css\" href=\"{$opts["link"]}\" />";
			}
			if(!empty($opts["custom"])){
				echo "<style>{$opts["custom"]}</style>";
			}
		}
		echo '<script type="text/javascript" src="components/jquery/js/jquery-1.7.1.min.js"></script>';
		echo '<script type="text/javascript">';
		echo '$(document).ready( function(){
			$("#other").on("click", function(){
				$("#answer"+$(this).attr("rel")).attr("checked","checked");
			});		
		});';
		echo '</script>';
	}
	function SurveyDialog(){
		global $db;
		$this->SurveyCss();
		$linkage = ">";
		echo "<h1 class='survey_header'>". _SURVEY .": ".$this->GetSurveyname(). "</h1>";
		if (!isset($_REQUEST['lastquestion'])) {
			$_REQUEST['lastquestion'] = 0;   
		}if (!isset($_REQUEST['nextquestion'])) {
			$_REQUEST['nextquestion'] = 0;   
		}
		$q = $db->Execute("select id,answer_rule from {$this->surveytablename_questions} where surveyid={$this->surveyid} and id = ".$db->Quote($_REQUEST['lastquestion']));
		if ($data=$q->FetchRow()) {
			$lastquestion = $_REQUEST["lastquestion"];
			$answer = $_REQUEST[$lastquestion];
			// echo "answer rule $data[0] for answer: $answer .....";
			$rule = json_decode($data["answer_rule"],true);
			if($rule !== false) {
				foreach($rule as $r) {
					if($r["answer"] == $answer) {
						if(!empty($r["link"])){
							$_REQUEST['nextquestion'] = $r["link"];
							$linkage = "=";
						}
						if(!empty($r["url"])){
							echo "<script type='text/javascript'>window.location.href = '{$r["url"]}';</script>";
							echo _SURVEY_COMPLETE; 
							return;
						}
						if(!empty($r["end"])){
							$q = $db->Execute("select * from {$this->surveytablename_questions} where surveyid={$this->surveyid} ORDER BY id DESC limit 1");
							if ($data=$q->FetchRow()) {
								$_REQUEST['nextquestion'] = $data["id"] + 1;
							}
						}
					}
				}
			}
		} else {
			//echo "no answer_rule";
		}
		
		// now do the next question
		if($linkage == "="){
			$q = $db->Execute("select * from {$this->surveytablename_questions} where surveyid={$this->surveyid} and id = ".$_REQUEST['nextquestion']." limit 1");
			// echo "select * from {$this->surveytablename_questions} where surveyid={$this->surveyid} and id = ".$_REQUEST['nextquestion']." limit 1";
		} else {
			$q = $db->Execute("select * from {$this->surveytablename_questions} where surveyid = {$this->surveyid} and question_order = ".$_REQUEST['nextquestion']." order by question_order, id limit 1");
		}
		
		if ($data=$q->FetchRow()) {
			$this->questionid=$data['id']; 
			echo "<form class='survey_form' method=POST action='doSurvey.php?labels=_SURVEYS'>";
			echo "<br><b><p  class='survey_question'>{$data["question"]}</p></b><hr>";
			echo "<br>";
			echo eval($data["question_rule"]);
			echo "<input type=hidden name=surveyid value=\"{$this->surveyid}\"><input type=hidden name=nextquestion value=\"".($data['question_order'] + 1)."\"><input type=hidden name=lastquestion value=\"".$data['id']."\"><input type=hidden name=action value=\"nextquestion\"><input type=hidden name=conf value=\"{$this->profile->profilename}\">";
			echo "<br><hr><input class='survey_submit' type=submit value='". _CONTINUE ."' /></form>";
		} else {
			echo _SURVEY_COMPLETE;
		}       
	}
	function NextQuestion() {
		global $db;
		$visitorid=$_SERVER['REMOTE_ADDR'];
		$timestamp=time();
		$lastquestion=$_REQUEST["lastquestion"];
		$answer = addslashes($_REQUEST[$lastquestion]);
		$otherBox = "other_".addslashes($_REQUEST[$lastquestion]);
		if(!empty($_REQUEST[$otherBox])){
			$answer = "$answer: ".$_REQUEST[$otherBox];
		}
		
		$db->Execute("insert into {$this->surveytablename_results} (surveyid, visitorid, timestamp, questionid, answer) values (".$db->Quote($this->surveyid).",". $db->Quote($visitorid).",". $db->Quote($timestamp) .",". $db->Quote($_REQUEST["lastquestion"]) .",".$db->Quote($answer).")");
		$this->SurveyDialog();   
	}
	
	function UpdateStats() {
		return false;
	}
}