<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays a overview of todays status
*/

$reports["_TODAY_BOX"] = Array(
	"ClassName" => "TodayOverview", 
	"Category" => "_VISITOR_DETAILS", 
	"icon" => "images/icons/32x32/todayoverview.png",
	"Options" => "daterangeField,profileselector",
	"Filename" => "today_overview",
	"Distribution" => "Standard",
	"Order" => 1,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true,
	"Update" => false
);


class TodayOverview extends Report {

	function Settings() {
		$this->help = "";
		$this->allowDateFormat = false;
		$this->sort = false;
			
		$this->columnDefinitions = array(
			0 => array("Label" => "_DATE")
			,1 => array("Label" => _TODAY,"dataType" => "String")
			,2 => array("Label" => "","dataType" => "String")
			,3 => array("Label" => "","dataType" => "String")
		);
	}
	
	function getDataFromFiles($files) {
		$data = array();
		foreach($files as $file) {
			$t = explode(".",$file);
			$data[$t[1]] = $this->getDataFromFile($file);
		}
		return $data;
	}
	function GetReportData() {
		global $db, $get_constant, $reports;

		# settings overwrite
		$t = LogaDate(array("format1" => "F", "seperator1" => " ", "format2" => "Y"), $this->to);
		$p = LogaDate(array("format1" => "F", "seperator1" => " ", "format2" => "Y"), mktime(0,0,0,date("m", $this->to) - 1,01,date("Y", $this->to)));

		$this->from = mktime(0,0,0,date("m", $this->to),01,date("Y", $this->to));
		
		$this->prevfrom = mktime(0,0,0,date("m", $this->to) - 1,01,date("Y", $this->to)); 
		$this->prevto = mktime(0,0,0,date("m", $this->to),01 - 1,date("Y", $this->to));
		$this->columnDefinitions[2]["Label"] = $t;
		$this->columnDefinitions[3]["Label"] = $p;		
		
		# Get Today Data
		$r = new $reports["_VISITORS_PER_DAY"]["ClassName"]();
		$r->label = _VISITORS_PER_DAY;
		$r->from = mktime(0,0,0,date('m',$this->to),date('d',$this->to),date('Y',$this->to));
		$r->to = $this->to;
		$d = $r->GetReportData();
		
		# get This And Last Month Data
		$r = new $reports["_VISITORS_PER_MONTH"]["ClassName"]();
		$r->label = _VISITORS_PER_MONTH;
		$r->from = $this->prevfrom;
		$r->to = $this->to;
		$m = $r->GetReportData();
		
		# Get Visitor per day data for entire range
		$r = new $reports["_VISITORS_PER_DAY"]["ClassName"]();
		$r->label = _VISITORS_PER_DAY;
		$r->from = $this->prevfrom;
		$r->to = $this->to;
		$r->dataCollectType = "days";
		$this->days = $r->GetReportData();
		
		# Preset data
		$nm = array( array(), array() );
		$data = array();

		if(!empty($m)) {
			if(count($m) == 2){
				# Go as you please
			} else {
				if($m[0][0] == $this->columnDefinitions[2]["Label"]){
					# Equils 'to' date	
					$nm[0] = array(); 
					$nm[1] = $m[0]; 
				} else if($m[0][0] == $this->columnDefinitions[3]["Label"]){
					# Equils 'from' date	
					$nm[0] = $m[0]; 
					$nm[1] = array(); 
				}
				$m = $nm;
			}
		}
		
		# added @ to ignore errors when data is 0.
		@$data[0] = Array(0 => _VISITORS, 1 => $d[0][1],  2 => $m[1][1],  3 => $m[0][1]);
		@$data[1] = Array(0 => _PAGES, 1 => $d[0][2],  2 => $m[1][2],  3 => $m[0][2]);		
		@$data[2] = Array(0 => _PAGES_PV_SHORT, 1 => number_format(($data[1][1] / $data[0][1]),2),  2 => number_format(($data[1][2] / $data[0][2]),2),  3 => number_format(($data[1][3] / $data[0][3]),2));
			
		$data[3] = Array(0 => _VISITS_PER_USER, 1 => 0,  2 => 0,  3 => 0);
		$data[4] = Array(0 => _VISITORS_PER_DAY, 1 => 0,  2 => 0,  3 => 0);
		$data[5] = Array(0 => _VISITS_PER_DAY, 1 => 0,  2 => 0,  3 => 0);

		$data[6] = Array(0 => _CONVERSION_RATE, 1 => 0,  2 => 0,  3 => 0);
		$data[7] = Array(0 => _BOUNCE_RATE, 1 => 0,  2 => 0,  3 => 0);
		
		$this_month_total_days = 0;
		$last_month_total_days = 0;

		# count visitors/visits from each visitors per day day.
		$this_month_total_visitors = 0;
		$last_month_total_visitors = 0;
		$this_month_total_visits = 0;
		$last_month_total_visits = 0;
		
		foreach($this->days as $day) {
			$t = date("Ym",strtotime($day[0]));
			
			if( $t == date("Ym", $this->prevfrom) ) {
				$last_month_total_visits += $day[4];
				$last_month_total_visitors += $day[1];
				$last_month_total_days ++;
			}
			
			if( $t == date("Ym", $this->to) ) {
				$this_month_total_visits += $day[4]; 
				$this_month_total_visitors += $day[1]; 
				$this_month_total_days ++;
			} 
		}
		
		# visitsPerUser = format (this month visits / this month visitors	
		$data[3][2] = ($data[0][2] == 0) ? 0 : number_format(($this_month_total_visits / $this_month_total_visitors),1);		
		# visitsPerUser = format (last month visits / last month visitors
		$data[3][3] = ($data[0][3] == 0) ? 0 : number_format(($last_month_total_visits / $last_month_total_visitors),1);	
		
		# visitorsperday = format (this month visitors / this month days
		$data[4][2] = ($this_month_total_days == 0) ? 0 : $this_month_total_visitors / $this_month_total_days;		
		# visitorsperday = format (last month visitors / last month days
		$data[4][3] = ($last_month_total_days == 0) ? 0 : $last_month_total_visitors / $last_month_total_days;
		
		# visitsperday = format (this month visits / this month days
		$data[5][2] = ($this_month_total_days == 0) ? 0 : $this_month_total_visits / $this_month_total_days;
		# visitsperday = format (last month visits / last month days
		$data[5][3] = ($last_month_total_days == 0) ? 0 : $last_month_total_visits / $last_month_total_days;
		
		
		if ($data[0][2] != 0) {
			$query  = "select ((count(distinct visitorid) * 1.00) / {$data[0][2]}) * 100 as ctr from {$this->profile->tablename_conversions} where timestamp >= ". $db->quote($this->from) ." and timestamp <= ". $db->quote($this->to) ." group by url";
			$a=0;
			$totctr = 0;
			$result=$db->Execute($query);
			if ($result) {
				while ($row = $result->FetchRow()) {
					$totctr=$totctr+$row["ctr"];
					$a++;
				}
			}
			if ($a <> 0) {
				$data[6][2] = number_format(($totctr/$a),2);
			} else {
				$data[6][2] = number_format(0,2);
			}
		}
		
		if ($data[0][3] != 0) {
			$query  = "select ((count(distinct visitorid) * 1.00) / {$data[0][3]}) * 100 as ctr from {$this->profile->tablename_conversions} where timestamp >= {$this->prevfrom} and timestamp <= {$this->prevto} group by url";
			$a=0;
			$totctr = 0;
			$result=$db->Execute($query);
			if ($result) {
				while ($row = $result->FetchRow()) {
					$totctr=$totctr+$row["ctr"];
					$a++;
				}
			}
			if ($a <> 0) {
				$data[6][3] = number_format(($totctr/$a),2);
			} else {
				$data[6][3] = number_format(0,2);
			}
		}
		
		$bounce = New $reports["_BOUNCE_RATE"]["ClassName"]();
		$bounce->label = _BOUNCE_RATE;
		$bounce->from = $this->prevfrom;
		$bounce->to = $this->to;
		$bounceRates = $bounce->getReportData();	
		
		$rates = array();
		$previous_month = date("M", $this->prevfrom);
		$today_month = date("M", $this->to);
		
		$rates[$previous_month] = array();
		$rates[$today_month] = array();
		
		foreach($bounceRates as $rate){
			foreach($this->profile->dateFormat as $dk => $dv){
				if(strpos($dk, 'sep') !== false){
					$rate[0] = str_replace($dv,"-",$rate[0]);
				}
			}
			
			$dateparts = explode("-",$rate[0]);
			
			$rate[1] = str_replace("%","",$rate[1]);
			$month = $dateparts[1];
			
			if($month == $previous_month){
				$rates[$previous_month][] = $rate[1];
			}
			if($month == $today_month){
				$rates[$today_month][] = $rate[1];
			}			
		}
		
		$data[7][3] = (count($rates[$previous_month]) > 0) ? number_format(array_sum($rates[$previous_month]) / count($rates[$previous_month]),2) : 0.00;
		
		$data[7][2] = (count($rates[$today_month]) > 0) ? number_format(array_sum($rates[$today_month]) / count($rates[$today_month]),2) : 0.00;
		
		return $data;
	}
	function DisplayReport() {		
		global $todaylabel,$db,$warning,$vnum,$databasedriver,$real_today,$tableheaderfontcolor,$showcharturl,$lang,$reports,$session;

		$d = $this->GetReportData();
		
		$data = array();
		foreach($d as $k){
			$data[$k[0]][1] = $k[1];
			$data[$k[0]][2] = $k[2];
			$data[$k[0]][3] = $k[3];
		}
				
		$fields = $this->fieldsArray();
		
		if ($this->to) {			
			$this->todaysdate = $this->to;
		} else {
			$this->todaysdate = time();
		}
		$from = $this->prevfrom;
		$uvtoday=$data[_VISITORS][1];
		$uvthismonth = $data[_VISITORS][2];
		$uvlastmonth = $data[_VISITORS][3];
		$tmctr = $data[_CONVERSION_RATE][2];
		$lmctr = $data[_CONVERSION_RATE][3];
		$avgvisitspuser2 = $data[_VISITS_PER_USER][2];
		$avgvisitspuser1 = $data[_VISITS_PER_USER][3];
		$bounce1 = $data[_BOUNCE_RATE][3];
		$bounce2 = $data[_BOUNCE_RATE][2];
		
		if ($bounce1 < $bounce2) {
			$bounce2="<font color=red>$bounce2 %</font>";    
		} else {
			$bounce2="<font color=green>$bounce2 %</font>";    
		}
		if ($avgvisitspuser1 > $avgvisitspuser2) {
			 $avgvisitspuser2="<font color=red>$avgvisitspuser2</font>";
		} else {
			 $avgvisitspuser2="<font color=green>$avgvisitspuser2</font>";
		}
		if ($avgvisitspuser1 > $avgvisitspuser2) {
			 $color2="red";
		} else {
			 $color2="green";
		}
		ob_start();
		
		# Report Header
		$this->customHeaderContent = _TODAY_CONTEXT.": ".date("l - d M Y (H:i:s)", $this->to);
		# add name to the addlabel if profilename not equal to the main profilename.					
		if(!empty($this->profileselector)){
			$md5_time = md5(time());
			$span_id = $md5_time.rand(1,1000);
		
			$this->customHeaderContent .= " | <span class='$span_id-addlabel-profile-selector'>Profile: {$this->profileselector}</span> ";
			$this->customHeaderContent .= "<script type='text/javascript'> 
				$(document).ready( function(){
				if(original_conf_name == '{$this->profileselector}'){
					$('.$span_id-addlabel-profile-selector').css('display','none');
				}
				});
			</script>";
		}
		
		
		
		$newVSreturning = array();
		$newret = New $reports["_NEW_VS_RETURNING"]["ClassName"]();
		$newret->label = _NEW_VS_RETURNING;
		
		# Get for today
		$newret->from = mktime(0,0,0,date('m',$this->to),date('d',$this->to),date('Y',$this->to));
		$newret->to = $this->to;
		$newret->period = 'days';
		$newret->Settings();		
		$nr = $newret->getReportData();
		$newVSreturning[0] = (isset($nr[0])) ? $nr[0] : array(1 => '', 2 => '');
		
		# get this and last month
		$newret->from = $this->prevfrom;
		$newret->to = $this->to;
		$newret->period = 'months';
		$newret->Settings();
		$nr = $newret->getReportData();
		
		$newVSreturning[1] = (isset($nr[0])) ? $nr[0] : array(1 => '', 2 => '');
		$newVSreturning[2] = (isset($nr[1])) ? $nr[1] : array(1 => '', 2 => '');
				
		# create the array we'll use for the upper table		
		$table_data[0][0] = $fields[1];
		$table_data[0][1] = $data[_VISITORS][1];
		$table_data[0][2] = $data[_PAGES][1];
		$table_data[0][3] = $data[_PAGES_PV_SHORT][1];
		$table_data[0][4] = "{$newVSreturning[0][1]} - <font color=green>{$newVSreturning[0][2]}</font>";
		
		$table_data[1][0] = $fields[2];
		$table_data[1][1] = $data[_VISITORS][2];
		$table_data[1][2] = $data[_PAGES][2];
		$table_data[1][3] = $data[_PAGES_PV_SHORT][2];
		$table_data[1][4] = "{$newVSreturning[2][1]} - <font color=green>{$newVSreturning[2][2]}</font>";
		
		$table_data[2][0] = $fields[3];
		$table_data[2][1] = $data[_VISITORS][3];
		$table_data[2][2] = $data[_PAGES][3];
		$table_data[2][3] = $data[_PAGES_PV_SHORT][3];
		$table_data[2][4] = "{$newVSreturning[1][1]} - <font color=green>{$newVSreturning[1][2]}</font>";

		# zero fill this array
		foreach($table_data as $k => $row) {
			$table_data[$k][1] = (empty($row[1]) ? '0' : $row[1]);
			$table_data[$k][2] = (empty($row[2]) ? '0' : $row[2]);
			$table_data[$k][3] = (empty($row[3]) ? '0' : $row[3]);
			$table_data[$k][4] = (empty($row[4]) ? '-' : $row[4]);
		}
		
		# define our columns
		$this->columnDefinitions = array();
		$this->columnDefinitions[] = array("Label" => "_DATE");
		$this->columnDefinitions[] = array("Label" => "_UNIQUE_VISITORS");
		$this->columnDefinitions[] = array("Label" => "_PAGES");
		$this->columnDefinitions[] = array("Label" => "_PAGES_PV_SHORT");
		$this->columnDefinitions[] = array("Label" => "_NEW_VS_RETURNING_SHORT");		
		$this->setupColumnDefinitions();
		
		# show the table
		$this->displayTotalRow=false;
		$this->Table($table_data);
		?>		
			<table id="todaybox" style='margin: 0 auto; margin-bottom:10px; margin-top:10px; border:1px dotted silver;' cellspacing=0 cellpadding=0 border=0 width=90%>
				<tr>
					<td valign=top>
						<?php				
						if (empty($this->gname)) {
							$this->gname = "months";
						}						
						$this->graphTypeMenu($this->gname);
						echo "<div style=\"height:190px; width:300px; margin-bottom: 20px;\" id=\"todaychart\">";
							
							if ($this->gname == "weeks") {
								$this->TodayOverviewWeek();
							} if ($this->gname == "oldmonths") {
								$this->TodayOverviewMonthBar();
							} else if ($this->gname == "months") {
								$this->TodayOverviewMonthArea();
							} else if ($this->gname == "years") {
								$this->TodayOverviewYearArea();
							} 
						echo "</div>";
					echo "</td>";
					echo "<td valign=top width=\"100%\">";
						echo "<table cellspacing=0 cellpadding=2 border=0 style='margin:0 auto; min-width:215px;' >";
							echo "<tr>";
								echo "<td>";
									echo "<table cellpadding=3 width=\"100%\"  border=0>";
										echo "<tr>";
											echo "<td valign=top>";
												echo "<b>"._TRENDS.":</b><br>";
												$diff=($data[_VISITORS_PER_DAY][2]-$data[_VISITORS_PER_DAY][3]);
												$diff=intval($diff);		
												if (($diff < 2) && ($diff > -2) && ($diff !=0)) {
													echo "<font color=orange>"._PRETTY_STABLE."</font><br>";
													$color="orange";
													$smile="smile-flat.gif";
												} else if ($data[_VISITORS_PER_DAY][3] > $data[_VISITORS_PER_DAY][2]) {
													$color="red";    
													$smile="smile-shame.gif";
													echo "<font color=red>"._LOSING_VISITORS."</font><br>";
												} else if ($data[_VISITORS_PER_DAY][3] == $data[_VISITORS_PER_DAY][2]) {
													$color="orange";
													$smile="smile-flat.gif";
													echo "<font color=orange>"._STABLE."</font><br>";
												} else {
													$color="green";
													if ($diff > 300) {
															$smile="smile-fast.gif";
													} else {
															$smile="smile.gif";
													}
													echo "<font color=green>"._GAINING_VISITORS."</font><br>";
												}
												$otmctr=$tmctr;
												if ($lmctr > $tmctr) {
													$tmctr="<font color=red>$tmctr %</font>";
													echo "<font color=red>"._PERF_DROPPING."</font><br>";
												} else if ($lmctr==$tmctr) {
													$tmctr="<font color=orange>$tmctr %</font>";
													echo "<font color=orange>"._PERF_STABLE."</font><br>";
												} else {
													$tmctr="<font color=green>$tmctr %</font>";
													echo "<font color=green>"._PERF_INCREASING."</font><br>";
												}    
												$ctrdiff=$otmctr-$lmctr;    
												$diff=number_format($diff,0);
												echo "<div style=\"padding:14px;margin-left:6px;\">";
												if ($diff > 0) {
													echo "<table cellpadding=3>";
														echo "<tr>";
															echo "<td>";
																echo "<img src=\"images/$smile\" width=\"23\" height=\"23\" alt=\"\">";
															echo "</td>";
															echo "<td>";
																echo "<font color=$color size=3><b>+$diff</b></font>";
															echo "</td>";
												} else {
													echo "<table cellpadding=3>";
														echo "<tr>";
															echo "<td>";
																echo "<img src=\"images/$smile\" width=\"23\" height=\"23\" alt=\"\">";
															echo "</td>";
															echo "<td>";
																echo "<font color=$color size=3><b>$diff</b></font>";
															echo "</td>";
												}
														if ($ctrdiff > 0) {
															$smile="smile-relax.gif";
															echo "<td class=sider>";
																echo "<img src=\"images/$smile\" width=\"23\" height=\"23\" alt=\"\">";
															echo "</td>";
															echo "<td>";
																echo "<font color=green size=3><b>+$ctrdiff %</b></font>";
															echo "</td>";
														} else if ($ctrdiff==0) {
															$smile="smile-flat2.gif";
															echo "<td class=sider>";
																echo "<img src=\"images/$smile\" width=\"23\" height=\"23\" alt=\"\">";
															echo "</td>";
															echo "<td>";
																echo "<font color=orange size=3><b>$ctrdiff %</b></font>";
															echo "</td>";
														} else {
															$smile="smile-red.gif";
															echo "<td class=sider>";
																echo "<img src=\"images/$smile\" width=\"23\" height=\"23\" alt=\"\">";
															echo "</td>";
															echo "<td>";
																echo "<font color=red size=3><b>$ctrdiff %</b></font>";
															echo "</td>";
														}
													echo "</tr>";
												echo "</table>";
											echo "</div>";												 
											?>
											<table cellpadding=2 cellspacing=0 border=0>
												<tr>
													<td class=grayline>
														<font color=gray><?php echo _AVERAGES;?></font>
													</td>
													<td class=grayline2>
														<font color=gray><?php echo _LAST_MONTH;?></font>
													</td>
													<td class=grayline2>
														<font color=gray><?php echo _THIS_MONTH;?></font>
													</td>
												</tr>
												<tr>
													<td><?php echo _VISITORS_PER_DAY;?></td>
													<td align=center class=sider><?php echo number_format($data[_VISITORS_PER_DAY][3]); ?></td>
													<td align=center class=sider><?php echo "<font color=$color>".number_format($data[_VISITORS_PER_DAY][2])."</font>";?></td>
												</tr>
												<tr>
													<td><?php echo _VISITS_PER_DAY;?></td>
													<td align=center class=sider><?php echo @number_format($data[_VISITS_PER_DAY][3]); ?></td>
													<td align=center class=sider><?php echo "<font color=$color2>".@number_format($data[_VISITS_PER_DAY][2]); ?></font></td>
												</tr>
												<tr>
													<td><?php echo _VISITS_PER_USER;?></td>
													<td align=center class=sider><?php echo $avgvisitspuser1; ?></td>
													<td align=center class=sider><?php echo $avgvisitspuser2; ?></td>
												</tr>
												<tr>
													<td><?php echo _CONVERSION_RATE;?></td>
													<td align=center class=sider><?php echo $lmctr; ?> %</td>
													<td align=center class=sider><?php echo $tmctr; ?></td>
												</tr>
												<tr>
													<td title="<?php echo _BOUNCE_RATE_EXPLAIN;?>"><?php echo _BOUNCE_RATE;?></td>													
													<td align=center class=sider><?php echo $bounce1; ?> %</td>
													<td align=center class=sider><?php echo $bounce2; ?> </td>
												</tr> 
											</table>
										</td>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		
		<?php
		$todaytrends = ob_get_clean();
		echo $todaytrends;
	}
	function TodayOverviewMonthArea() {
		global $db , $reports;
		
		$graphdata = array();
		
		$color[0]="EEEEEE";
		$color[1]="9999FF";
		$color[2]="0080C0";
		$color[3]="FF3399";
		$color[4]= "FF8040";
		$color[5]="FFFF00";
		$color[6]= "FF0080";
		$color[7]= "00FF00";
		$color[8]= "FFFFCC";
		$color[9]= "FF0000";
		$color[10]="00CCFF";
		$color[11]="CCCCCC"; 
		$color[12]="993300";
		
		$from = mktime(0,0,0,(date("m", $this->todaysdate)-1), 01, date("Y", $this->todaysdate));
		$to = mktime(23,59,59,date("m", $this->todaysdate), date("d", $this->todaysdate), date("Y", $this->todaysdate));
		$lastmonth_q = date("M Y", $from);
		$thismonth_q = date("M Y", $to);
		$lmn = get_month_lastday(date("m", $from), date("Y", $from));
		$tmn = get_month_lastday(date("m", $to), date("Y", $to)); 
		if ($lmn > $tmn) {
			$n = $lmn;   
		} else {
			$n = $tmn;
		}

		if ($n > 8) {
			$step = round(($n/5), 0);
		} else {
			$step = 1;
		}
		if ($step == 0) {
			$step = 1;   
		}
		$i=1;

		while ($i <= $n) {
			$graphdata[($i - 1)][0] = $i;
			$graphdata[($i - 1)][1] = 0;
			$graphdata[($i - 1)][2] = 0;
			$graphdata[($i - 1)][3] = 0;
			$i++;
		}
		
		$r = new $reports["_VISITORS_PER_DAY"]["ClassName"]();
		$r->label = _VISITORS_PER_DAY;
		$r->from = $from;
		$r->to = $to;
		$r->dataCollectType = "days";
		$d = $r->GetReportData();
		
		foreach($d as $date) {
			$time = strtotime($date[0]);
			$d = intval(date("d",$time));
			
			if( date("Ym",$time) == date("Ym",$from) ) {
				$graphdata[($d - 1)][2] = $date[1]; // lastmonth
			} else if( date("Ym",$time) == date("Ym",$to) ) {
				$graphdata[($d - 1)][3] = $date[1]; // thismonth
			}
			$trenddata[] =	$date[1];
		}
		
		// $start_trend = ($graphdata[0][2] + $graphdata[0][3]) / 2;
		if(!empty($trenddata)) {
			$start_trend = array_sum($trenddata) / count($trenddata);
		} else {
			$start_trend = 0;
		}
		if(!isset($trenddata)){ 
			echoWarning(_NO_DATA_TO_DISPLAY, "width:150px;");
			return false;
		}
		$start_trend = array_sum($trenddata) / count($trenddata);
		
		$trend_step = getTrend($trenddata);
		
		$step = $start_trend + $trend_step;
		for($c = 0; $c <= 30; $c++) {
			$graphdata[$c][1] = round($step);
			$step = $step + $trend_step;
		}
		
		$this->columnDefinitions = array();
		$this->columnDefinitions[] = array("Label" => _DATE);
		$this->columnDefinitions[] = array("Label" => _VISITOR_TREND);
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS . " " . LogaDate(array("format1" => "F"),date("F", $from),"STRING"));
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS . " " . LogaDate(array("format1" => "F"),date("F", $to),"STRING"));
		$this->setupColumnDefinitions();		
		
		$custom_graphoptions = array(
			'seriesDefaults' => array(
				"lineWidth" => 3,
				"markerOptions" => array(
					"show" => false
				)
			)
		);
		
		$this->Graph($graphdata, 'line', '', 0, 150, $custom_graphoptions, 'south', 'block');
	}
	
	function TodayOverviewWeek() {
		global $db;
		
		$graphdata = array();
		
		$from_3weeks_ago = strtotime("-3 weeks", $this->todaysdate);
		$from_3weeks_ago = mktime(0, 0, 0, date("m", $from_3weeks_ago), date("d", $from_3weeks_ago), date("Y", $from_3weeks_ago));
		$to_now = mktime(23,59,59,date("m", $this->todaysdate),date("d", $this->todaysdate),date("Y", $this->todaysdate));
		$to_week = date("W Y", $to_now);
		$from_week = date("W Y", $from_3weeks_ago);
		
		$n = 7;
		if ($n > 8) {
			$step = round(($n / 5), 0);
		} else {
			$step = 1;
		}
		if ($step == 0) {
			$step = 1;
		}

		$s = 1;
		$thisweek = date("W Y", $from_3weeks_ago);
		$thisfrom = $from_3weeks_ago;
		
		$prefill = array();
		$prefill[1] = "Monday";
		$prefill[2] = "Tuesday"; 
		$prefill[3] = "Wednesday"; 
		$prefill[4] = "Thursday"; 
		$prefill[5] = "Friday"; 
		$prefill[6] = "Saturday"; 
		$prefill[7] = "Sunday";
		
		$dat = array();
		$allowedWeeks[date("W Y", mktime( 0,0,0,date("m",$this->to),date("d",$this->to) - 21,date("y",$this->to) ) )] = 1;
		$allowedWeeks[date("W Y", mktime( 0,0,0,date("m",$this->to),date("d",$this->to) - 14,date("y",$this->to) ) )] = 2;
		$allowedWeeks[date("W Y", mktime( 0,0,0,date("m",$this->to),date("d",$this->to) - 7,date("y",$this->to) ) )] = 3;
		$allowedWeeks[date("W Y", $this->to)] = 4;
		
		foreach($this->days as $day) {
			$w = date("W Y",strtotime($day[0]));
			if( isset($allowedWeeks[$w]) ) {
				$d = date("N",strtotime($day[0]));
				$w = $allowedWeeks[$w]; 
				
				$graphdata[$d][0] = 0;
				if( isset($graphdata[$d][$w]) ) {
					$graphdata[$d][$w] = $graphdata[$d][$w] + $day[4];
				} else {
					$graphdata[$d][$w] = $day[4];
				}
			}
		}
		
		
		$this->graphcolors[0] = "#50A5D3";
		$this->graphcolors[1] = "#1970B4";
		$this->graphcolors[2] = "#0E4067";
		$this->graphcolors[3] = "#FF0000";
		
		$custom_graphoptions = array(
			"series" => array(
				0 => array(
					"color" => "#50A5D3"
				),
				1 => array(
					"color" => "#1970B4"
				),
				2 => array(
					"color" => "#0E4067"
				),
				3 => array(
					"color" => "#FF0000"
				)
			),
			"seriesDefaults" => array(
				"pointLabels" => array( "show" => false ),
				"rendererOptions" => array(
					"barWidth" => 6,
					"barPadding" => 3
				),				
			),
			"axes" => array(
				"xaxis" => array(
					"ticks" => array(
						"Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"
					),
					"tickOptions" => array(
						"angle" => 0
					)
				)
			)
		);
		
		$this->columnDefinitions = array();
		$this->columnDefinitions = array();
		$this->columnDefinitions[] = array("Label" => _DATE);
		$this->columnDefinitions[] = array("Label" => "3 "._WEEKS_AGO);
		$this->columnDefinitions[] = array("Label" => "2 "._WEEKS_AGO);
		$this->columnDefinitions[] = array("Label" => "1 "._WEEK_AGO);
		$this->columnDefinitions[] = array("Label" => _THIS_WEEK);
		$this->setupColumnDefinitions();	
		
		$this->Graph($graphdata, 'bar', '', 0, 140, $custom_graphoptions, 'south', 'inline');
	}
	
	function TodayOverviewMonthBar() {
		global $db;
		
		$graphdata = array();
		
		$color[0]="EEEEEE";
		$color[1]="9999FF";
		$color[2]="0080C0";
		$color[3]="FF3399";
		$color[4]= "FF8040";
		$color[5]="FFFF00";
		$color[6]= "FF0080";
		$color[7]= "00FF00";
		$color[8]= "FFFFCC";
		$color[9]= "FF0000";
		$color[10]="00CCFF";
		$color[11]="CCCCCC"; 
		$color[12]="993300";
		
		$from = mktime(0,0,0,(date("m", $this->todaysdate)-1), 01, date("Y", $this->todaysdate));
		$to = mktime(23,59,59,date("m", $this->todaysdate), date("d", $this->todaysdate), date("Y", $this->todaysdate));
		$lastmonth_q = date("M Y", $from);
		$thismonth_q = date("M Y", $to);
		$lmn = get_month_lastday(date("m", $from), date("Y", $from));
		$tmn = get_month_lastday(date("m", $to), date("Y", $to)); 
		if ($lmn > $tmn) {
			$n = $lmn;   
		} else {
			$n = $tmn;
		}

		if ($n > 8) {
			$step = round(($n/5), 0);
		} else {
			$step = 1;
		}
		if ($step == 0) {
			$step = 1;   
		}
		$i=1;

		while ($i <= $n) {
			$graphdata[($i - 1)][0] = $i;
			$graphdata[($i - 1)][1] = 0;
			$graphdata[($i - 1)][2] = 0;
			$graphdata[($i - 1)][3] = 0;
			$i++;
		}
		
		foreach($this->days as $day) {
			$t = date("Ym",strtotime($day[0]));
			$d = intval(date("d",strtotime($day[0])));
			$graphdata[($d - 1)][2] = $day[4];
			$trenddata[] = $day[4];
		}
		
		$start_trend = ($graphdata[0][2] + $graphdata[0][3]) / 2;
		$trend_step = getTrend($trenddata);
		$step = $start_trend;
		
		for($c = 0; $c <= 30; $c++) {
			$graphdata[$c][1] = round($step);
			$step = $step + $trend_step;
		}
		
		$this->columnDefinitions = array();
		$this->columnDefinitions[] = array("Label" => _DATE);
		$this->columnDefinitions[] = array("Label" => _VISITOR_TREND);
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS);
		$this->columnDefinitions[] = array("Label" => date("F", $from));
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS);
		$this->columnDefinitions[] = array("Label" => date("F", $to));
		$this->setupColumnDefinitions();	
		
		$custom_graphoptions = array(
			"series" => array(
				0 => array(
					"lineWidth" => 1,
					"markerOptions" => array(
						"show" => false
					)
				)
			),
			"seriesDefaults" => array(
				"rendererOptions" => array(
					"barWidth" => 3,
					"barPadding" => 1,
					"barMargin" => 10
				)
			)
		);
		
		$this->Graph($graphdata, array('','line','bar','bar'), '', 0, 150, $custom_graphoptions);
	}
	
	function TodayOverviewYearArea() {
		global $db , $reports;
		
		$graphdata = array();
		
		$color[0]="EEEEEE";
		$color[1]="9999FF";
		$color[2]="0080C0";
		$color[3]="FF3399";
		$color[4]= "FF8040";
		$color[5]="FFFF00";
		$color[6]= "FF0080";
		$color[7]= "00FF00";
		$color[8]= "FFFFCC";
		$color[9]= "FF0000";
		$color[10]="00CCFF";
		$color[11]="CCCCCC"; 
		$color[12]="993300";
		
		$from = mktime(0,0,0,01,01,date("Y", $this->todaysdate)-1);
		$to = mktime(23,59,59,date("m", $this->todaysdate),date("d", $this->todaysdate),date("Y", $this->todaysdate));
		
		$lastmonth_q = date("Y", $from);
		$thismonth_q = date("Y", $to);
		
		$n = 12;
		
		if ($n > 8) {
			$step = round(($n/5),0);
		} else {
			$step=1;
		}
		if ($step==0) {
			$step=1;
		}
		
		$i = 1;
		while ($i <= $n) {
			$graphdata[($i - 1)][0] = $i;
			$graphdata[($i - 1)][1] = 0;
			$graphdata[($i - 1)][2] = 0;
			$graphdata[($i - 1)][3] = 0;
			$i++;
		}
		
		$r = new $reports["_VISITORS_PER_MONTH"]["ClassName"]();
		$r->label = _VISITORS_PER_MONTH;
		$r->from = $from;
		$r->to = $to;
		$months = $r->GetReportData();
		
		foreach($months as $md) {
			$m = date("m",strtotime($md[0]));
			$y = date("Y",strtotime($md[0]));
			 
			if($y == date("Y",$to)) {
				$graphdata[($m - 1)][3] = $md[1];
				$tmp_trenddata[1][] = $md[1];
			}
			if($y == date("Y",$from)) {
				$graphdata[($m - 1)][2] = $md[1];
				$tmp_trenddata[0][] = $md[1];
			}
			
			$trenddata[1][] = $md[1];
		}
		
		if(!empty($tmp_trenddata[0])) {
			$avg_first = round(array_sum($tmp_trenddata[0]) / count($tmp_trenddata[0]));
		} else {
			$avg_first = 0;
		}
		
		if(!empty($tmp_trenddata[1])) {
			$avg_second = round(array_sum($tmp_trenddata[1]) / count($tmp_trenddata[1]));
		} else {
			$avg_second = 0;
		}
		
		if($avg_first == 0 && $avg_second == 0) {
			$start_trend = 0;
		} else {
			$start_trend = ($avg_first + $avg_second) / 2;
		}
		
		if(!isset($trenddata)){
			echoWarning(_NO_DATA_TO_DISPLAY, "width:150px;");
			return false;
		}	
		
		$trend_step = getTrend($trenddata);
		$step = $start_trend + $trend_step;
		for($c = 0; $c <= 11; $c++) {
			$graphdata[$c][1] = round($step);
			$step = $step + $trend_step;
		}		
		$this->columnDefinitions = array();
		$this->columnDefinitions[] = array("Label" => _DATE);
		$this->columnDefinitions[] = array("Label" => _VISITOR_TREND);
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS . " " . date("Y", $from));
		$this->columnDefinitions[] = array("Label" => _UNIQUE_VISITORS . " " . date("Y", $to));
		$this->setupColumnDefinitions();
		
		$custom_graphoptions = array(
			"series" => array(
				0 => array(
					"lineWidth" => 1,
					"markerOptions" => array(
						"show" => false
					)
					// "color" => "#333333"
				)
			),
			'seriesDefaults' => array(
				"lineWidth" => 3,
				"markerOptions" => array(
					"show" => false
				)
			),
			"axes" => array(
				"xaxis" => array(
					"tickOptions" => array(
						"angle" => 0
					)
				)
			)
		);
		
		$this->Graph($graphdata, 'line', '', 0, 150, $custom_graphoptions, 'south', 'inline');
	}
	
	function DisplayCustomForm() {
		if(empty($this->gname)) { $this->gname = "months"; }
		$selected = $this->gname;
		
		echo "<label for='gname'>"._CHART_TYPE."</label>";
		echo "<select class='report_option_field' id='gname' name='gname'>";
			if($this->gname == 'months') {
				echo "<option value='months'>"._MONTH."</option>";
			} else {
				echo "<option value='months'>"._MONTH."</option>";
			}
			
			if($this->gname == 'weeks') {
				echo "<option value='weeks'>"._WEEK."</option>";
			} else {
				echo "<option value='weeks'>"._WEEK."</option>";
			}
			
			if($this->gname == 'years') {
				echo "<option value='years'>"._YEAR."</option>";
			} else {
				echo "<option value='years'>"._YEAR."</option>";
			};
		echo "</select>";
	}
	
	function graphTypeMenu($selected) {		
		$r = array();
		$r[0] = "<a class='graylink open_in_this_dialog quickopen' href=\"reports.php?labels=_TODAY_BOX&statstable_onl=1&gname=months\">"._MONTH."</a>";
		$r[1] = "<a class='graylink open_in_this_dialog quickopen' href=\"reports.php?labels=_TODAY_BOX&statstable_onl=1&gname=weeks\">"._WEEK."</a>";
		$r[2] = "<a class='graylink open_in_this_dialog quickopen' href=\"reports.php?labels=_TODAY_BOX&statstable_onl=1&gname=years\">"._YEAR."</a>";
		
		for ($i=0;$i < count($r);$i++) {
			if (strpos($r[$i],$selected)!==FALSE) {
				$r[$i] = str_replace("graylink","graylinkselected",$r[$i]);
			}
		}
		
		echo "<span style=\"position:absolute;margin-top: 7px; margin-left:30px;\">";
		foreach ($r as $row) {
			echo $row;   
		}
		echo "</span>";
	}
	function UpdateStats() {
		return false;
	}
}
?>
