<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/

$reports["_TOP_COUNTRIES_CITIES"] = Array(
	"ClassName" => "TopCountriesCities", 
	"Category" => "_INCOMING_TRAFFIC", 
	"icon" => "images/icons/32x32/topcountriescities.png",
	"Options" => "daterangeField,profileselector,trafficsource,limit,columnSelector",
	"Filename" => "top_countries_cities",
	"Distribution" => "Standard",
	"Order" => 8,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class TopCountriesCities extends Report {
	function Settings() {
		$this->columnDefinitions[] = array("Label" => "_COUNTRIES");
		$this->columnDefinitions[] = array("Label" => "_VISITS");
		$this->columnDefinitions[] = array("Label" => "_PAGEVIEWS");
		$this->columnDefinitions[] = array("Label" => "_PAGES_PER_VISIT", "totalRow" => "avg");
		
		$this->paginationDisplayLength = 10;
		if($this->limit < 100){ $this->limit = 100; } # fix the bug in the dashboard first that shows 100 instead of doing pagination
		$this->paginationPanel = true;
		$this->sort_order = SORT_DESC;
		$this->sort_key = 1;
	}

	function DefineQuery() {
		global $db;
		$query  = "select country, count(distinct sessionid) as ips,count(*) as hits from {$this->profile->tablename} where timestamp >=". $db->quote($this->from) ." and timestamp <=". $db->quote($this->to) ." and country!='' group by country order by ips desc";
		
		return $query;
	}

	function GetReportData(){
		$data = parent::GetReportData();
		
		# add the pages per visit column
		foreach($data as $k => $v){
			if(isset($data[$k][1]) && !empty($data[$k][1])){
				$data[$k][3] = number_format(($data[$k][2] / $data[$k][1]),2); 
			}
		}
		return $data;
		
	}
	function DisplayReport(){
		global $cnames, $reports;;
		$this->reportHeader();
		
		$data = $this->GetReportData();

		$this->WorldMapGraph($data);

		$temp = array();
		foreach($data as $key => $row) {
			$countryname = @$cnames[$row[0]];
			$temp[$countryname] = $data[$key];
		}
		unset($temp[""]);
		unset($temp["unknown"]);
		$data = $temp;


		# we need to send the minimumDate and maximumDate
		$date = "from={$this->from}&to={$this->to}";

		foreach($data as $key => $row) {
			if(!empty($key) && !empty($row[0])){
				$countryname = @$cnames[$row[0]];

				$ccode = strtolower($row[0]);
				$image= "<img hspace=3 width=14  height=11 src=\"images/flags/{$ccode}.png\" border=0 alt=\"{$ccode}\">";

				# without @ you get error: Creating default object from empty value, if empty do statement does not fix this.
				@$tmp_code->country = $ccode;

				$data[$key][0] = $image."<a class=\"open_in_new_dialog quickopen\" options='".json_encode($tmp_code)."' href=\"reports.php?conf=".$this->profile->profilename."&labels=_TOP_CITIES&country=".$row[0]."&".$date ."\" rel=\"TopCities\" type=\"_TOP_CITIES\" name=\""._TOP_CITIES."\">".$countryname."</a>";
			}
		}
				
		$this->displayHeader = false;
		$this->Table($data);
	}
	
}
?>