<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays a overview of your top keywords
*/
$reports["_TOP_KEYWORDS"] = Array(
	"ClassName" => "TopKeywords", 
	"Category" => "_INCOMING_TRAFFIC", 
	"icon" => "images/icons/32x32/topkeywords.png",
	"Options" => "daterangeField,profileselector,displaymode,trafficsource,search,limit,columnSelector",
	"Filename" => "top_keywords",
	"Distribution" => "Standard",
	"Order" => 5,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class TopKeywords extends Report {

	function Settings() {
		$this->DefaultDisplay = "table";
		$this->DisplayModes = "table,pie";
		$this->actionmenu_type = 'keyword';
		$this->sort_order = SORT_DESC;
		$this->sort_key = 1;
		
		$this->columnDefinitions[] = array("Label" => "_KEYWORDS","actionmenu" => 'keyword',"search" => true);
		$this->columnDefinitions[] = array("Label" => "_VISITS");
		$this->columnDefinitions[] = array("Label" => "_PAGEVIEWS");
	}
	
	function DefineQuery() {
		global $db,$nc;
		
		$emptykeyword = getID('','keyword');
		
		$subquery = subsetDataToSourceID("select {$nc} keywords, count(distinct sessionid) as visits, count(*) as hits, count(distinct visitorid) as visitors from {$this->profile->tablename} where timestamp >= ". $db->quote($this->from) ." and timestamp <= ". $db->quote($this->to) ." and keywords != '{$emptykeyword}' group by keywords order by visits desc", $this->trafficsource);
		
		$this->applytrafficsource = false;
		
		$query = "select {$nc} k.keywords, sq.visits, sq.hits, sq.visitors from ({$subquery}) as sq, {$this->profile->tablename_keywords} as k where sq.keywords=k.id";
			
		return $query;
	} 
}
?>
