<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc Definitions for this report: Top Pages Details

    Page: The requested page, excluding any parameters (e.g. ?variable=1)
    Unique ID's: The total number of visitors (including human and bot/crawler)
    Pageviews: The total number of pages requested (excluding any bots and crawlers).
    Total requests: The total number of times this page was requested.
    Crawled %: The percentage of requests that were generated by bots or crawlers (like the googlebot indexer).
*/

$reports["_TOP_PAGES_DETAILS"] = Array(
	"ClassName" => "TopPagesDetails", 
	"Category" => "_POPULAR_CONTENT", 
	"icon" => "images/icons/32x32/toppagesdetails.png",
	"Options" => "daterangeField,profileselector,displaymode,trafficsource,search,limit,columnSelector",
	"Filename" => "top_pages_details",
	"Distribution" => "Legacy",
	"Order" => 2,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class TopPagesDetails extends Report {

	function Settings() {
		$this->DefaultDisplay = "table";
		$this->DisplayModes = "table,pie";
		$this->columnDefinitions[] = array("Label" => "_PAGE","actionmenu" => 'page');
		$this->columnDefinitions[] = array("Label" => "_VISITS");
		$this->columnDefinitions[] = array("Label" => "_PAGEVIEWS");
		$this->actionmenu_type = 'page';
		$this->sort_key = 1;
		$this->sort_order = SORT_DESC;
	}
	
	function GetReportData() {
		global $db, $get_constant;
		$this->createDataFiles($this->from,$this->to);
		$d = $this->getDataFromFiles($this->dataFiles($this->from,$this->to));	
		$data = array();
		$i = 0;
		foreach($d as $val){
			$data[$i][0]  = $val[0];
			$data[$i][1]  = $val[1];
			$data[$i][2]  = $val[2];
			$i ++;
		}		
		return $data;
	} 
	
	function DefineQuery() {
		global $nc,$db;
        
		$subquery  = subsetDataToSourceID("select concat(url,'.',params) as numfurl,url,params,count(distinct sessionid) as visits,count(*) as hits,count(distinct visitorid) as visitors from {$this->profile->tablename} where timestamp >= ". $db->quote($this->from) ." and timestamp <= ". $db->quote($this->to) ." group by numfurl order by visits desc",$this->trafficsource);
		$query = "select concat(r.url,rp.params,'##',r.title) as furl, sq.visits,sq.hits, sq.visitors  FROM ({$subquery}) as sq, {$this->profile->tablename_urls} as r, {$this->profile->tablename_urlparams} as rp WHERE sq.url=r.id and sq.params=rp.id";
		$this->applytrafficsource=false;        
		
		return $query;
	}
	
	function updateStats(){
		false;
	}
}
?>
