<?php 
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/
$reports["_TRAFFIC_FLOW"] = Array(
	"ClassName" => "TrafficFlow", 
	"Category" => "_POPULAR_CONTENT",
	"icon" => "images/icons/32x32/traffic_flow.png",
	"Options" => "daterangeField,profileselector,limit",
	"Filename" => "traffic_flow",
	"Distribution" => "Premium",
	"Order" => 15,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlrts" => false,
	"Update" => false
);

class TrafficFlow extends Report{

	function Settings() {
		$this->displayReportButtons = false;
		if(!isset($this->source) || empty($this->source)){
			$this->source = "/";
		}
		if(!isset($_REQUEST['limit'])){
			$_REQUEST['limit'] = 20;
		}
		if($this->limit > 25){
			$this->limit = 25;
		}
		$this->help = "
					<h3>How to read:</h3>
					<ul>
					<li>The outer ring represents the pages with each its unique color.</li>
					<li>The chords represents the 2 way traffic between those pages. (So every chord is connected to 2 sources).</li>
					<li>The wider the chord is at the source the more traffic originates from that source.</li>
					<li>The source where the most traffic originates from determines the color of the chord.</li>
					<li>The number of pageviews is based on the number of times source 1 was found as the referrer of source 2.</li>
					</ul>
					<h4>Tips:</h4>
					<ul>
					<li>If you hover your mouse over the pages on the outer ring, it will highlight the chords connected to that page.</li>
					<li>If you hover your mouse on a page, you can see the total views of that page.</li>
					<li>If you hover your mouse on a chord, you can see the 2 way traffic represented in hits.</li>
					<li>You can turn pages on and off by clicking on the colored box in the legend.</li>
					<li>You can obtain more information about each page by clicking on them in the legend.</li>
					</ul>
					<h4>Options:</h4>
					<ul>
					<li>'Page' means the root referring page.</li>
					<li>Default limit is set to 20</li>
					<li>Max limit is 25.</li>
					</ul>
				";
		
		$this->actionmenu_type = 'page';
	}

	function DisplayCustomForm() {
		echo "<label for=\"source\">Page</label>";
		echo "<input type=\"hidden\" id=\"sourcetype\" value=\"page\">";
		echo "<div><input id=\"source\" class=\"report_option_field\" type=\"text\" autocomplete=\"off\" onclick=\"popupMenu(event, this.value+'@'+this.id+'@'+$('#sourcetype').val(), 'forminput');\" onkeyup=\"popupActionMenu(event, this.value+'@'+this.id+'@'+$('#sourcetype').val(), 'forminput');\" value=\"{$this->source}\" name=\"source\"></div>";
	}

	function urlid_to_refid($urlid) {
		global $db;
	
		$url = getVAL($urlid,"urls");

		$ref = "http://".$this->profile->confdomain.$url;

		$refid = getID($ref,"referrers");

		return $refid;
	}

	function DisplayReport(){
		$this->ReportHeader();
		$this->chordGraphCreate();
	}

    function UpdateStats() {
		return false;
	}
}
?>