<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc This report displays a small twitter feed.
*/

$reports["_TWITTER_FEED"] = Array(
    "ClassName" => "TwitterFeed", 
    "Category" => "_SOCIAL_MEDIA", 
    "icon" => "images/icons/32x32/twitter_feed.png",
	"Options" => "limit",
	"Filename" => "twitter_feed",
	"Distribution" => "Premium",
	"Order" => 4,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => false,
	"DeleteOutdatedFiles" => false,
	"Update" => false
);

class TwitterFeed extends TwitterCore {

	function Settings() {
		$this->help = "Twitter can have keywords that modify search behavior, the available behaviors are:<br/>
			<table style='font-size:11px; width:100%;'>
				<tr></tr><tr><td>watching now</td><td>containing both “watching” and “now”. This is the default operator.</td></tr><tr><td>“happy hour”</td><td>containing the exact phrase “happy hour”.</td></tr><tr><td>love OR hate</td><td>containing either “love” or “hate” (or both).</td></tr><tr><td>beer -root</td><td>containing “beer” but not “root”.</td></tr><tr><td>#haiku</td><td>containing the hashtag “haiku”.</td></tr><tr><td>from:alexiskold</td><td>sent from person “alexiskold”.</td></tr><tr><td>to:techcrunch</td><td>sent to person “techcrunch”.</td></tr><tr><td>@mashable</td><td>referencing person “mashable”.</td></tr><tr><td>superhero since:2015-07-19</td><td>containing “superhero” and sent since date “2015-07-19” (year-month-day).</td></tr><tr><td>ftw until:2015-07-19</td><td>containing “ftw” and sent before the date “2015-07-19”.</td></tr><tr><td>movie -scary :)</td><td>containing “movie”, but not “scary”, and with a positive attitude.</td></tr><tr><td>flight :(</td><td>containing “flight” and with a negative attitude.</td></tr><tr><td>traffic ?</td><td>containing “traffic” and asking a question.</td></tr><tr><td>hilarious filter:links</td><td>containing “hilarious” and linking to URL.</td></tr><tr><td>news source:twitterfeed</td><td>containing “news” and entered via TwitterFeed</td></tr></table>";
	}
	
	function DisplayCustomForm(){
		if(!empty($this->keyword)) {
			$keyword = $this->keyword;
		} else {
			$keyword = '';
		}
		return "<label for='keyword'>". _INSERT_KEYWORD . "</label><input type='text' id='keyword' class='report_option_field' name='keyword' value='{$keyword}' />";
	}
	
	function GetReportData(){
		$this->addlabel = "Search: ";		
		$this->displayReportButtons = false;
		$this->displayHelp = true;
		if(empty($this->keyword)){	
			return array();
		}		
		$this->addlabel .= $this->keyword;
		
		$search = $this->keyword;
		$data = array();
		$tweets = $this->TwitterCall("search", urlencode($search));
		if(empty($tweets['statuses'])){
			return array();
		}

		$i = 0;
		foreach ($tweets['statuses'] as $tweet) {
			if($i < $this->limit){
				$data[] = array(
					"id" => $tweet['id']
					,"retweets" => $tweet['retweet_count']
					,"favorites" => $tweet['favorite_count']
					,"date" => $tweet['created_at']
					,"author" => $tweet['user']['name']
					,"author-url" => "http://twitter.com/" . $tweet['user']['screen_name']
					,"content" => $tweet['text']
					,"image" => $tweet['user']['profile_image_url']
					,"country" => $tweet['metadata']['iso_language_code']	
				);
			}
			$i ++;
		}
		return $data;
	}

	function DisplayReport() {
		$data = $this->GetReportData();
		$this->ReportHeader();
		if(empty($this->keyword)){
			echoNotice(_INSERT_KEYWORD, "margin:5px;"); 
			return false;
		}

		if(empty($data)){
			echo "No tweets found..";
		}

		echo "<style>
		.search-tweet-main{ border-bottom:1px solid #99CDE1; width:100%; margin:0 0 0 0; padding:5px 0 5px 0; background-color: #E5F2F7; }	
		.search-tweet{ border-bottom:1px solid #ddd; width:100%; margin:0 0 0 0; padding:0 0 5px 0; }	
		.tweet-container a { text-decoration:none; color: #1970B3; }
		.tweet-container a:hover{ text-decoration:underline;}
		.tweet-container em { font-weight: bold; font-style: normal; }
		.tweet-img{ float:left; max-width:48px; max-height:48px; margin:0 5px 0 0;}
		.tweet-author { text-align:right; float:right;}
		.tweet-date { text-align:left; float:left; color: #999; }
		.tweet-container{ padding: 0 10px 0 10px; }
		</style>";
		
		foreach($data as $tweet){
			echo "<div class='search-tweet'>";			
				echo "<div class='tweet-container'>";
					echo "<p>{$tweet["content"]}</p>";
					echo "<div class='tweet-details'>";
						echo "<div class='tweet-date'>{$tweet["date"]}, Retweets: {$tweet["retweets"]}</div>";
						echo "<div class='tweet-author'>By: <a href='{$tweet["author-url"]}' target='_blank'>{$tweet["author"]}</a></div>";
					echo "</div>";
					echo "<div class='clear'></div>";
				echo "</div>";			
			echo "</div>";			
		}
	}
	
	function UpdateStats() {
		return false;
	}
}
?>