<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc Definitions for this report: Visitors and Visists

    Visitors: Unique Visitors that accessed your site (excluding any bots and crawlers).
    Visits: The total number of visits people made to your site
    Visits per user: The average number of times one users visits your site (the total number of visits devided by the number of visitors).
*/
$reports["_VISITORS_AND_VISITS"] = Array(
	"ClassName" => "VisitorsAndVisits",
	"Category" => "_VISITOR_DETAILS",
	"icon" => "images/icons/32x32/visitorsandvisits.png",
	"Options" => "daterangeField,profileselector,displaymode,trafficsource,columnSelector",
	"Filename" => "visitors_and_visits",
	"Distribution" => "Standard",
	"Order" => 7,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true,
	"Update" => false
);

class VisitorsAndVisits extends Report {

	function Settings() {
		$this->DefaultDisplay = "table";
		$this->DisplayModes = "table,linechart,barchart";
		$this->columnDefinitions[] = array("Label" => "_DATE");
		$this->columnDefinitions[] = array("Label" => "_UNIQUE_VISITORS");
		$this->columnDefinitions[] = array("Label" => "_VISITS");
		$this->columnDefinitions[] = array("Label" => "_VISITS_PER_USER");
	}
	
	function GetReportData(){
		global $reports;
		$r = new $reports["_VISITORS_PER_DAY"]["ClassName"]();
		$r->sort = false;
		$data =	$r->GetReportData();
		$newdata = array();
		foreach($data as $k => $v){
			$newdata[$k][0] = $v[0];
			$newdata[$k][1] = $v[1];
			$newdata[$k][2] = $v[4];
			$newdata[$k][3] = $v[4] / $v[1];
		}		
		return $newdata;
	}
	
	function updateStats(){
		return false;
	}
}
?>