<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc Definitions for this report: Visitors per Day

    Visitors: Unique Visitors that accessed your site (excluding any bots and crawlers).
    Pageviews: The total number of pages requested (excluding any bots and crawlers).
    Average Pages per user: The total number of pages devided by the number of visitors.
*/
$reports["_VISITORS_PER_DAY"] = Array(
	"ClassName" => "VisitorsPerDay", 
	"Category" => "_VISITOR_DETAILS", 
	"icon" => "images/icons/32x32/visitorsperday.png",
	"Options" => "daterangeField,profileselector,displaymode,trafficsource,columnSelector",
	"Filename" => "visitors_per_day",
	"Distribution" => "Standard",
	"Order" => 4,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class VisitorsPerDay extends Report {
	function Settings() {
		$this->DisplayModes = "table,linechart,barchart";
		$this->DefaultDisplay = "table";
		if(empty($this->displaymode)){
			$this->displaymode = $this->DefaultDisplay;
		}

		$this->sort = false;		
		$this->columnDefinitions[] = Array("Label" => "_DATE");
		$this->columnDefinitions[] = Array("Label" => "_UNIQUE_VISITORS");
		$this->columnDefinitions[] = Array("Label" => "_PAGEVIEWS");
		$this->columnDefinitions[] = Array("Label" => "_PAGES_PER_USER", "totalRow" => "avg");
		
		if(empty($this->displaymode) || $this->displaymode !== 'table'){
			$this->columnDefinitions[] = Array("Label" => "_VISITS", "display" => false);
		}
	}
	function DefineQuery() {
		global $db;
		$query = "SELECT FROM_UNIXTIME(timestamp, '%d-%b-%Y %a') AS days, COUNT(DISTINCT visitorid) as visitors, COUNT(*) AS pages, (COUNT(*) / COUNT(DISTINCT visitorid)) AS ppv, COUNT(DISTINCT sessionid) AS visits FROM {$this->profile->tablename} WHERE timestamp >= ". $db->quote($this->from) ." AND timestamp <= ". $db->quote($this->to) ." GROUP BY days ORDER BY timestamp";
		//echo $query;
		return $query;
	}
}
?>
