<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
/**
* @desc Definitions for this report: Visitors per Hour

    Visitors: Unique Visitors that accessed your site (excluding any bots and crawlers).
    Pageviews: The total number of pages requested (excluding any bots and crawlers).
    Pages per user: The total number of pages devided by the number of visitors.

Tip: When viewing more than one day, keep in mind that you are seeing summed up totals for that hour for each day in your date range. 
*/
$reports["_VISITORS_PER_HOUR"] = Array(
	"ClassName" => "VisitorsPerHour", 
	"Category" => "_VISITOR_DETAILS", 
	"icon" => "images/icons/32x32/visitorsperhour.png",
	"Options" => "daterangeField,profileselector,displaymode,trafficsource,columnSelector",
	"Filename" => "visitors_per_hour",
	"Distribution" => "Standard",
	"Order" => 3,
	"ReportVersion" => 1.0,
	"MinimumVersion" => 3.0,
	"EmailAlerts" => true
);

class VisitorsPerHour extends Report {
	function Settings() {
		$this->DefaultDisplay = "table";
		$this->DisplayModes = "table,linechart,barchart";
		$this->columnDefinitions[] = array("Label" => "_HOUR");
		$this->columnDefinitions[] = array("Label" => "_VISITS");
		$this->columnDefinitions[] = array("Label" => "_PAGEVIEWS");
		$this->columnDefinitions[] = array("Label" => "_PAGES_PER_VISIT", "totalRow" => "avg");
	}
	
	function DefineQuery() {
		global $db;
		$query  = "SELECT FROM_UNIXTIME(timestamp, '%H') AS hours, COUNT(DISTINCT sessionid) AS visits, COUNT(*) AS pages, (COUNT(*) / COUNT(DISTINCT sessionid)) AS ppu,COUNT(DISTINCT visitorid) AS visitors FROM {$this->profile->tablename} WHERE timestamp >= ". $db->quote($this->from) ." AND timestamp <= ". $db->quote($this->to) ." GROUP BY hours ORDER BY hours";
		 

		return $query;
	}
	
	function UpdateStats(){
		return false;
	}
}
?>
