<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 
include_once("top.php");
if($validUserRequired && !$session->isAdmin()){
	echoWarning(_MUST_BE_ADMIN,"margin:10px;");
	exit;
}

include_once("components/Subscriptions/subscriptions.php");
include_once("includes/formGenerator.php");

$form = new FormGenerator();
$form->editable = true;
$form->typemerging = true;
$form->JqueryScript();

$global_sub = getGlobalSetting("DefaultSubscription", "");

$subscriptions = new Subscriptions();
$subscriptions->install_subscription_system();

if(isset($_POST["default_subscription"])){
	# Save Subscription as default for new users
	$id = empty($subscriptions->subscripts[ $_POST["default_subscription"] ]['id']) ? "" : $subscriptions->subscripts[ $_POST["default_subscription"] ]['id'];
	setGlobalSetting("DefaultSubscription",$id);
	$global_sub = $id;
}

if(isset($_POST["copy_from"])){
	# copy a subscription
	$id = $_POST['copy_from'];
	$name = $_POST['copy_to'];
	$subscriptions->copySubscription($id, $name);	
}

#delete a subscription
if(isset($_POST["deletesub"])){
	if($_POST["subtodelete"] == $global_sub){
		# Reset the default
		setGlobalSetting("DefaultSubscription","");
		$global_sub = "";
	}
	$subscriptions->delete_subscription($_POST["subtodelete"],$_POST["deletesub"]);
}

#edit subscription
if(isset($_POST['subedit#submit'])){
	unset($_POST['subedit#submit']);
	$subscriptions->edit_subscription($_POST);
}

#edit subscription reports
if(isset($_POST['editsubscriptionReports'])){
	foreach($_POST as $id => $rs){
		if(is_numeric($id)){
			$rs = explode(",",$rs);
			$subscriptions->edit_reports($id,$rs);
		}
	}
}

#save a new subscription
$errors = 0;
if(isset($_POST['subsave#submit'])){
	unset($_POST['subsave#submit']);
	foreach($_POST as $key => $value){
		if($key !== "id#hidden"){
			if(checkEmpty($value) == true){
				$errors ++;
			}
		}
	}	
	if($errors == 0){
		$subscriptions->new_subscription($_POST);
	}
}

$subscriptions->subscripts = $subscriptions->get_subscriptions();

function CheckEmpty($input){
	if(empty($input) && $input != 0){ return true; }
	return false;
}
?>
<style type='text/css'>
#InstallGrid { width: 960px; color: #333; margin: 0 auto; text-align: center; }
#InstallGrid #ReportGrid,
#InstallGrid #SubscriptionGrid { text-align: left; border: 1px solid silver; width: 470px; float: left; margin-bottom: 20px; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; }
#InstallGrid #ReportGrid .list-header,
#InstallGrid #SubscriptionGrid .list-header { width: 100%; height: auto; border-bottom: 1px solid silver; }

#InstallGrid #SubscriptionGrid { margin-left: 16px; }

#Reports,
#Subscriptions { height: 450px; overflow-x: hidden; overflow-y: auto; padding: 0; margin: 0; width: 100%; list-style-type: none; background: #999; -moz-text-shadow: 0 1px 0 #FFFFFF; -webkit-text-shadow: 0 1px 0 #FFFFFF; }
#Reports li,
#Subscriptions li { width: 470px; height: 28px; line-height: 28px; border-top: 1px solid #FFF; border-bottom: 1px solid silver; background-color: #E0E0E0; }
#Reports li:last-child,
#Subscriptions > li:last-child { box-shadow: 0 5px 5px #666; -moz-box-shadow: 0 5px 5px #666; -webkit-box-shadow: 0 5px 5px #666; border-bottom-left-radius: 4px; border-bottom-right-radius: 4px; -moz-border-bottomleft-radius: 4px; -moz-border-bottomright-radius: 4px; -webkit-border-bottom-left-radius: 4px; -webkit-border-bottom-right-radius: 4px; }

#Reports.error_message { width: 458px; padding: 5px; color: #900; background-color: #F09090; height: auto; text-shadow: none; -moz-text-shadow: none; -webkit-text-shadow: none; border: 1px solid #900; }
.error_message { width: 458px; padding: 5px; color: #900; background-color: #F09090; height: auto; text-shadow: none; -moz-text-shadow: none; -webkit-text-shadow: none; border: 1px solid #900; }

#Reports li { cursor: move; width: 460px; padding: 0 5px; }
#Reports li .quantity { float: right; }
#Reports li.disabled { cursor: default; }

#Subscriptions > li { height: auto; }
#Subscriptions .subscriptionname { cursor: pointer; height: 28px; line-height: 28px; background-image: url(images/arrow_right_darkgrey_square.png); background-repeat: no-repeat; background-position: 5px center; background-color: #FFBB00; padding: 0 5px 0 15px; border-bottom: 1px solid silver; }

#Subscriptions li.open .subscriptionname { background-image: url(images/arrow_down_darkgrey_square.png); background-repeat: no-repeat; background-position: 5px center; }

.all-Subscriptions .checkbox,
#Subscriptions .subscriptionname .checkbox { cursor: pointer; width: 12px; height: 12px; float: right; margin: 8px 20px 0 0; border: 1px solid silver; background-color: #F9F9F9; border-radius: 2px; -moz-border-radius: 2px; -webkit-border-radius: 2px; }
.all-Subscriptions .checkbox:hover,
#Subscriptions .subscriptionname .checkbox:hover { border: 1px solid #333; background-color: #FFF; }
.all-Subscriptions .checkbox .checked,
#Subscriptions .subscriptionname .checkbox .checked { width: 10px; height: 10px; margin: 1px 0 0 1px; border-radius: 1px; -moz-border-radius: 1px; -webkit-border-radius: 1px; }
.all-Subscriptions .checkbox:hover .checked,
#Subscriptions .subscriptionname .checkbox:hover .checked { background-color: #FFBB00; }
.all-Subscriptions.selected .checkbox .checked,
#Subscriptions .subscriptionname.selected .checkbox .checked { background: url(images/gradient_bg_blue.png) repeat-x top left #1970B4; }
#Subscriptions li.includes { border-top: 1px solid #FF0; border-bottom: 1px solid #CC0; }
#Subscriptions li.includes .subscriptionname { background-color: #FFBB00; text-shadow: none; -moz-text-shadow: none; -webkit-text-shadow: none; }
#Subscriptions li.includes.open { border-bottom: 0; }

#Subscriptions .subscriptioncontent { display: none; width: 100%; padding: 0; margin: 0; list-style-type: none; }
#Subscriptions li.open .subscriptioncontent { display: block; }
#Subscriptions .subscriptioncontent li { cursor: move; width: 450px; background-color: #C0C0FF; padding: 0 5px 0 15px; }
#Subscriptions .subscriptioncontent li.added { background-color: #C0FFC0; }
#Subscriptions .subscriptioncontent li.disabled { cursor: default; }
#Subscriptions .subscriptioncontent li .update-report { float: right; color: #1970B4; text-decoration: none; margin-right: 20px; }
#Subscriptions .subscriptioncontent li .uninstall-report { float: right; color: #1970B4; text-decoration: none; margin-right: 20px; }
#Subscriptions .subscriptioncontent li .update-report:hover { text-decoration: underline; }
#Subscriptions .subscriptioncontent li .uninstall-report:hover { text-decoration: underline; }

#Subscriptions .subscriptioncontent li .deleted { margin-left: 1ex; }
#Subscriptions .subscriptioncontent li .reinstall { float: right; color: #1970B4; text-decoration: none; margin-right: 20px; }
#Subscriptions .subscriptioncontent li .reinstall:hover { text-decoration: underline; }

#Subscriptions > li:last-child .subscriptioncontent li:last-child { border-bottom-left-radius: 4px; border-bottom-right-radius: 4px; -moz-border-bottomleft-radius: 4px; -moz-border-bottomright-radius: 4px; -webkit-border-bottom-left-radius: 4px; -webkit-border-bottom-right-radius: 4px; }

.button_wrapper { width: 100px; border: 1px solid #24364C; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; float: right; margin: 0 5px; }
.button_wrapper.cancel-reset { border: 1px solid #BBC4CC; }
.button_wrapper.cancel-reset a { background-color: #E0E2E5; display: block; color: #333; padding: 5px 10px; text-align: center; text-decoration: none; border: 1px solid #E0E1E4; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; }
.button_wrapper.cancel-reset:hover a { background-color: #C1C3C9; }
.button_wrapper.commit-install a { background-color: #2B4C74; display: block; color: #FFF; padding: 5px 10px; text-align: center; text-decoration: none; border: 1px solid #2D4F7D; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; }
.button_wrapper.commit-install:hover a { background-color: #14274A; }.button_wrapper.cancel-reset { border: 1px solid #BBC4CC; }

#report-filter { background-color: #F9F9F9; margin-left: 5px; border: 1px solid silver; padding: 4px; width: 36ex; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; box-shadow: 1px 1px 3px #C1C1C1 inset; -moz-box-shadow: 1px 1px 3px #C1C1C1 inset; -webkit-box-shadow: 1px 1px 3px #C1C1C1 inset; }
#report_input{ margin:5px;}

.delete-button{ float:left; cursor:pointer; background-color: #2B4C74; display: block; color: #FFF; padding: 5px 10px; text-align: center; text-decoration: none; border: 1px solid #2D4F7D; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; }
.save-edit-button{ float:left; cursor:pointer; background-color: #2B4C74; display: block; color: #FFF; padding: 5px 10px; text-align: center; text-decoration: none; border: 1px solid #2D4F7D; border-radius: 4px; -moz-border-radius: 4px; -webkit-border-radius: 4px; }

.delete-subscription{ background: url("images/icons/16x16/close_grey.png") no-repeat scroll left top transparent; display: block; float: right; height: 16px; margin: 6px 0 0 5px; width: 16px; }
.delete-subscription:hover{ background: url("images/icons/16x16/close_grey.png") no-repeat scroll left bottom transparent;}

.edit-subscription{ background: url("images/icons/16x16/system-settings_grey.png") no-repeat scroll left top transparent; display: block; float: right; height: 16px; margin: 6px 0 0 5px; width: 16px; }
.edit-subscription:hover{ background: url("images/icons/16x16/system-settings_grey.png") no-repeat scroll left bottom transparent;}

.copy-subscription{ background: url("images/icons/16x16/copy_grey.png") no-repeat scroll left top transparent; display: block; float: right; height: 16px; margin: 6px 0 0 5px; width: 16px; }
.copy-subscription:hover{ background: url("images/icons/16x16/copy_grey.png") no-repeat scroll left bottom transparent;}

.custom-form{ display:none; }

.form-adding-options{ 
	position:absolute; 
	z-index:1100; 
	display:none; 
	background:#DDDDDD; 
	padding: 10px; 
	border:1px solid silver; 
	box-shadow: 1px 1px 4px 0px; 
	text-align: 
	center; width: 200px; 
}
.form-adding-options a { cursor:pointer; }
.add-new-sub{ cursor:pointer; }
.remove-field{ cursor:pointer; }

.subscriptions-info-list{ text-align:left; margin:0px; padding: 0 14px 5px 14px; }

</style>
<script type='text/javascript'>
$(document).ready( function(){
	$("#Reports li").draggable({
		helper: 'clone',
		revert: "invalid"
	});	
		
	$(".subscriptioncontent li").draggable({ // Apply the draggable to reports in the subscriptions list
		helper: 'clone',
		revert: "invalid"
	})
	
	$("#Subscriptions > li").droppable({ // Make it possible to drop reports in the subscriptions list
		accept: "#Reports > li, .subscriptioncontent > li",
		drop: function(ev, ui) {
			if($(this).find(".subscriptioncontent").find("li[rel='" + ui.draggable.attr('rel') + "']").length >= 1) { // If the report already exists for this subcription, we don't want to do anything (the drag will be reverted)
				return false;
			}		
		
			$(this).addClass("open"); // Show the contents of the profile
				
			var cloned_object = ui.draggable.clone();			
			
			cloned_object.prependTo($(this).find(".subscriptioncontent")); // Prepend the cloned object to the profile's list
			cloned_object.addClass('added'); // Add a CSS class so we know this is a to-be-added report.
			
			$(cloned_object).draggable({ // Reapply the draggable to the cloned object
				helper: 'clone',
				revert: "invalid"
			});
		}
	});
	
	$("#Reports").droppable({ // Make it possible to remove reports from the subscription
		accept: ".subscriptioncontent > li",
		drop: function(ev, ui) {
			ui.draggable.remove();
		}
	});
	
	$(".subscriptionname").click(function(ev) { // Show / Hide a subscription's content
		if($(this).next(".subscriptioncontent").is(":hidden") == true) {
			$(this).parent().addClass("open"); // Show the content
		} else {
			$(this).parent().removeClass("open"); // Hide the content
		}
	});
	
	$(".commit-install").live( "click", function() {
		var subscriptions = {};
		$("#Subscriptions > li").each( function() {
			var subscr_id = $(this).find(".subscriptionname").attr("rel");
			var report_ids = Array();
			
			var i = 0;
			$(this).find(".subscriptioncontent > li").each(function() {	
				report_ids[i] = $(this).attr("rel");
				i ++;
			});
			subscriptions['editsubscriptionReports'] = 'ok';
			subscriptions[subscr_id] = report_ids;
		});
		
		post_to_url('subscriptions.php',subscriptions);		
	});
	
	
	
	$("#report-filter").keyup(function() { // Filter profiles by the user's input
		if($("#report-filter").val() != "") {
			$("#Reports .reportname").each(function() {
				if($(this).text().toLowerCase().indexOf($("#report-filter").val().toLowerCase()) >= 0) {
					$(this).parent().show();
					$(this).addClass("selected");
				} else {
					$(this).parent().hide();
					$(this).removeClass("selected");
				}
			});
			
			$(".all-reports").removeClass("selected");
		} else {
			$("#Reports > li").show();
			$("#Reports > li > .reportname").addClass("selected");
			$(".all-reports").addClass("selected");
		}
	});
	
	
	$(".add-new-sub").live( "click", function() {
		$("#subscription_settings").html($(".new-sub-form").html());
		
		$("#subscription_settings").dialog("open");
	});
	
	$(".edit-subscription").live( "click", function() {
		$("#subscription_settings").html($(".edit-sub-"+$(this).attr("rel")).html());
		
		$("#subscription_settings").dialog("open");
	});
	
	$(".copy-subscription").live( "click", function() {
		var copy_from = $(this).attr("name");
		var new_sub = prompt("Copy Subscription '"+copy_from+"' To (New Name): ");
		
		if(new_sub == ""){
			alert('<?php echo _INVALID_SUBSCRIPTION_NAME; ?>');
			return false;
		}
		
		var posting = {};
		posting["copy_from"] = copy_from;
		posting["copy_to"] = new_sub;
		post_to_url('subscriptions.php',posting);
	});
	
	$(".delete-subscription").live( "click", function() {
		$("#subscription_settings").html("<?php $subscriptions->ui_delete_form(); ?>");
		$(".subscription_tag").html("("+$(this).attr("name")+")");
		$(".remove-"+$(this).attr("name")).remove();
		$("#subtodelete").attr("value",$(this).attr("rel"));
		$("#subscription_settings").dialog("open");
	});
	
	$( "#subscription_settings" ).dialog({
		autoOpen: false,
		modal: true,
		width:600,
		height:350
	});
	
	$(".close-popup").live( "click", function() {
		$("#subscription_settings").dialog("close");
	});
});

function post_to_url(path, params, method) {
	method = method || "post"; // Set method to post by default, if not specified.

	// The rest of this code assumes you are not using a library.
	// It can be made less wordy if you use one.
	var form = document.createElement("form");
	form.setAttribute("method", method);
	form.setAttribute("action", path);

	for(var key in params) {
		if(params.hasOwnProperty(key)) {
			var hiddenField = document.createElement("input");
			hiddenField.setAttribute("type", "hidden");
			hiddenField.setAttribute("name", key);
			hiddenField.setAttribute("value", params[key]);

			form.appendChild(hiddenField);
		 }
	}

	document.body.appendChild(form);
	form.submit();
}


</script>

	<?php $subscriptions->new_subscription_form(); ?>
	<?php $subscriptions->ui_edit_form(); ?>
	<div id='InstallGrid'>
		<h2 style='text-align: left;'><?php echo _SETUP_REPORT_SUBSCRIPTIONS; ?></h2>
		<p style='text-align: left;'>
			<!-- INFO -->
			<?php echo _SUBSCRIPTIONS_INFO; ?>
		</p>
		<h2 style='text-align: left;'><?php echo _DEFAULT; ?></h2>
		<p style='text-align: left;'>
			<!-- DEFAULT -->
			<?php echo "Please choose a subscription to set as default for new users:"; ?><br/>
			<form method="POST" style="float: left; width:600px"><select style="float: left; height: 21px; margin: 0 5px 10px; width: 100px;" name="default_subscription">
				<?php
				echo "<option value=''>". _NONE ."</option>";
				foreach($subscriptions->subscripts as $name => $values){					
					if($values["id"] == $global_sub){ $sel ="selected='selected'"; } else { $sel = ""; }
					echo "<option value='$name' $sel >$name</option>";
				}
				?>
			</select>
			<input type="submit"  style="float:left;"  value="<?php echo _SAVE; ?>" />
			</form>
		</p>
		
		<div id='ReportGrid'>
			<div class='list-header'>
				<div id='getReportsContainerWrapper'>
					<div id="getReportsContainer">
						<div id='report_input'>
							<label for='report-filter'><?php echo _REPORTS; ?>:</label><input type='text' id='report-filter' name='report-filter' />
						</div>
					</div>
				</div>
			</div>
			<ul id='Reports'>
				<?php $subscriptions->ui_report_list(); ?>	
			</ul>
		</div>
		<div id='SubscriptionGrid'>
			<div class='list-header'>
				<p style='margin:9px; padding:0; float:left;'><?php echo _SUBSCRIPTION; ?>:</p>
				<p style='margin:9px; padding:0; float:right;'><img class='add-new-sub' src='images/icons/add_profile.gif' /></p>
				
			</div>
			<ul id='Subscriptions'>
				<?php $subscriptions->ui_subscription_list(); ?>
			</ul>
		</div>
		<br class='clear'/>
		<div class='button_wrapper commit-install'>
			<a href='#commit'><?php echo _COMMIT; ?></a>
		</div>
		<div class='button_wrapper cancel-reset'>
			<a href='#cancel'><?php echo _CANCEL; ?></a>
		</div>
	</div>
	<div id="subscription_settings" title="<?php echo _SUBSCRIPTIONS_SETTINGS; ?>" style='font-size:12px;'></div>
</body>
</html>