<?php
/* Logaholic Web Analytics software             Copyright(c) 2005-2013 Logaholic B.V.
 *                                                               All rights Reserved.
 * This code is subject to the Logaholic license. Unauthorized copying is prohibited.
 * support@logaholic.com                         http://www.logaholic.com/License.txt
*/ 

include_once "common.inc.php";

if (_LOGAHOLIC_EDITION == 4 || LOGAHOLIC_BASE_EDITION == "cPanel Edition") {
	echo $template->NoAccess("Feature not required in cPanel Edition.");
	exit();
}

if(!$validUserRequired){
	echo $template->NoAccess("No user set to adjust settings for.");
	exit();
}

if(!$session->canEditUserInfo()){
	echo $template->NoAccess(_SORRY_NO_PERMISSIONS.".");
	exit();
}

include_once "top.php";

$userdata = array();
$userdata["username"] = "";
$userdata["password"] = "";
$userdata["name"] = "";
$userdata["email"] = "";
$userdata["subscriptionid"] = "";
$query = "SELECT * from ".TBL_USERS." where username = ".$db->Quote($session->username);
$result = $db->Execute($query) or die(_ERROR_FINDING_USER.": " . $db->ErrorMsg());
$userdata = $result->FetchRow();
$updated = array();

# check if subscription component is being used by checking if the table exists.
@$results = $db->Execute("SELECT * FROM ".TBL_SUBSCRIPTIONS."");
$subscriptions = array();
if($results != false){
	while($row = $results->fetchRow()){
		$vals = json_decode($row["value"],true);

		$subscriptions[$row["id"]]['name'] = $row["name"];
		$subscriptions[$row["id"]]['price'] = 0;
		if(!empty($vals["Price"])){
			$subscriptions[$row["id"]]['price'] = $vals["Price"]['value'];	
		}
	}
}


if(isset($_POST['useraction'])){
	if(!empty($_POST['email'])){
		$userdata['email'] = $_POST['email'];
		$updated[] = _UPDATED ." "._EMAIL_ADDRESS."</br>";
	}
	
	if(!empty($_POST['password'])){
		$userdata['password'] = md5($_POST['password']);
		$updated[] = _UPDATED ." "._PASSWORD."</br>";
	}
	
	if(!empty($_POST['name'])){
		$userdata['name'] = $_POST['name'];
		$updated[] = _UPDATED ." "._NAME."</br>";
	}

	if($userdata['subscriptionid'] != $_POST['userSubscription']){
		$now = time();	
		$nowd = date("Y-m-d H:i:s",$now);
		$lastsub = $subscriptions[$userdata['subscriptionid']];
		
		$userdata['subscriptionid'] = $_POST['userSubscription'];
		if(!empty($userdata['subscriptionid'])){
			NewSubscriptionLogEntry("On $nowd Changed from {$lastsub['name']} to {$subscriptions[$userdata['subscriptionid']]['name']}",$subscriptions[$userdata['subscriptionid']]['name'],$subscriptions[$userdata['subscriptionid']]['price']);
		} else {
			NewSubscriptionLogEntry("Removed Subscription");
		}
	}
	
	$query = "UPDATE ".TBL_USERS." SET password = ?, name = ?, email = ?, subscriptionid = ? WHERE userid = ?";
	$db->Execute($query,array($userdata['password'],$userdata['name'],$userdata['email'],$userdata['subscriptionid'],$userdata['userid']));
}
if(!empty($updated)){
	echoNotice(implode("",$updated), "width:250px; margin:10px 35px;");
}

?>
<div style='margin:0 35px;'>
	<form action='' method="POST">
	<table cellpadding=6 width=600 border=0>
		<tr>
			<td colspan=3 class=toplineblue bgcolor=#BBDDFF>
				<font size=3><b><img width=16 height=16 src=images/icons/user_edit.gif border=0 align=left>User Settings</b></font>
			</td>
		</tr>
		<tr>
			<td valign="top" class="dotline"><?php echo _NAME;?></td>
			<td valign=top class="dotline"><input size=40 type="text" name="name" value="<?php echo $userdata['name']; ?>"></td>
			<td bgcolor='#f0f0f0'><?php echo _NAME_EXPLAIN; ?><br>
				<a href='<?php echo "index.php?lgpkey=". md5($userdata["username"]) . ":".$userdata["password"]; ?>'>Login link</a>
			</td>	
		</tr>
		<tr>
			<td valign="top" class="dotline"><?php echo _PASSWORD;?></td>
			<td valign=top class="dotline"><input size=25 type="password" name="password" value=""></td>
			<td bgcolor="#f0f0f0"><?php echo _PASSWORD_EXPLAIN;?></td>
		</tr>
		<tr>
			<td valign="top" class="dotline"><?php echo _EMAIL_ADDRESS;?></td>
			<td valign=top class="dotline"><input size=25 maxlength=51 type="text" name="email" value="<?php echo $userdata["email"]; ?>"></td>
			<td bgcolor="#f0f0f0"><?php echo _EMAIL_ADDRESS_EXPLAIN;?></td>
		</tr>
		<?php					
		# check if there actually are subscriptions in the table. If so then add the subscription option to the form.
		if(!empty($subscriptions)){
			echo "<tr>";
				echo "<td valign=\"top\" class=\"dotline\">". _SUBSCRIPTION ."</td>";
				echo "<td valign=top class=\"dotline\">";
				# add dropdown option for selecting a subscription.
				echo "<select name='userSubscription'>";
				echo "<option value=''>-----". _NONE ."-----</option>";
				foreach($subscriptions as $subid => $sub){
					$selected = "";
					if($userdata["subscriptionid"] == $subid){
						$selected = "selected='selected'";
					}
					echo "<option $selected value='{$subid}'>{$sub['name']}</option>";
				}
				echo "</select>";
				echo "</td><td bgcolor=\"#f0f0f0\">". _SUBSCRIPTION_EXPLAIN ."</tr>";
			echo "</tr>";
		}		
		?>
		<tr>
			<td></td>
			<td><input type="Submit" value="Save" name="useraction"></td>
			<td></td>
		</tr>
	 </table>
	 </form>
 </div>